<?php
/*
Retrieves the auth.net config info, including:
	APIID = API ID
	TRANSID = Transaction ID
	DELIM = Field delimiter (normally a | symbol)
	TESTMODE = yes/no
	TRANSEMAIL = admin email to which Auth.net will send emails
	invoiceItem = Text that appears on customer's statement
	Enabled (yes/no)


		$tpl->set('applicantID',$festos->id);
		$tpl->set('thispage', $_SERVER['PHP_SELF']);
		$tpl->set('querystring',urlencode(passTheQueryString($_GET)));
		$tpl->set('config',$config);
		$tpl->set('lang',$lang);
		$whichpage = (isset($_GET['pg'])) ? $_GET['pg'] : 'default';
		$tpl->set('total',$total);


*/

$authnetquery = "SELECT invoiceItem, enabled, config FROM ".$config['dbprefix']."paymentmodules 
	WHERE LCase(moduleName) = 'authorize.net'";
$authnetres = $festos->query($authnetquery);
$authnetrow = $authnetres->fetch();
$authnet = unserialize($authnetrow['config']);
$authnet['invoiceItem'] = $authnetrow['invoiceItem'];
if($authnetrow['enabled']==0) {
	die();
}
if($authnet['TESTMODE'] == 'FALSE') {
	// if in live mode (TESTMODE=FALSE), then make sure we're loading from an HTTPS connection
	SSLon(); // see core/core.php
	$authnet['gateway'] = 'https://secure.authorize.net/gateway/transact.dll';
	$myURL = "https://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
} else {
	$authnet['gateway'] = 'https://test.authorize.net/gateway/transact.dll';
	$myURL = "http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
}
$tpl->set('myURL', $myURL);

// pass the authnet config data to the template
$tpl->set('authnet',$authnet);

if(!isset($_POST['stage']) || ctype_digit($_POST['stage']) === false) {
	$stage = 1;
} else {
	$stage = $_POST['stage'];
}
$tpl->set('stage',$stage);
$tpl->set('postvars',$_POST);

// library helper class for dealing with credit card numbers
require_once($config['ABSOLUTE_FILE_PATH'].'addons/pay_authnet/creditcard.inc.php');
$cc_validate = new CCValidate();



switch($stage) {
	// cases listed in reverse numeric order so that the default can be associated with stage=1
	case 3:
		// process payment and handle return code (paid, denied, error)
		if(!isset($_POST['stage']) || $_POST['stage'] != '3') {
			redirect($myURL);
		}
		require_once($config['ABSOLUTE_FILE_PATH'].'addons/pay_authnet/Class.Authnet.php');
		$auth = new Authnet($authnet);
		$auth->setCardNumber($cc_validate->decrypt($_POST['cc_num']));
		$auth->setExpirationDate($_POST['expire']);
		$auth->setCVV($_POST['cvv2']);
		$auth->setAmount($total);
		$auth->setParameter("x_first_name", $_POST['firstname']);
		$auth->setParameter("x_last_name", $_POST['lastname']);
		$auth->setParameter("x_address", $_POST['address']);
		$auth->setParameter("x_city", $_POST['city']);
		$auth->setParameter("x_state", $_POST['state']);
		$auth->setParameter("x_zip", $_POST['zip']);
		$auth->setParameter("x_cust_id", $_POST['applicantID']);
		// check for errors, if present, don't process, instead bump back to stage 1
		// tbd
		
		//Process transaction
		$auth->process();
		
		require_once($config['ABSOLUTE_FILE_PATH'].'core/PaymentRecorder.php');
		$paymentrecord = new PaymentRecorder($config);
		//Get response and do something with it
		if ($auth->isApproved()) {
			// approved, no errors, record transaction
			$paymentrecord->setVendorID($festos->id);
			$paymentrecord->paymentDate(strftime($config["SHORT_DATE_FORMAT"], mktime()));
			$paymentrecord->paymentAmount($auth->getAmount());
			$paymentrecord->paymentID($auth->getTransactionID());
			$paymentrecord->paymentNotes($auth->getResponseText()); // I don't think this is actually used in PaymentRecorder
			$paymentrecord->paymentProcessor('Credit Card');
			$paymentrecord->recordPayment();
			$paymentrecord->paymentNotify();
			// build output string for pay.tpl
			$tpl->set('cc_status', 'Approved');
			$tpl->set('cc_date', strftime($config["SHORT_DATE_FORMAT"], mktime()) );
			$tpl->set('cc_amount', $auth->getAmount());
			$tpl->set('cc_responseText', $auth->getResponseText());
			$tpl->set('cc_transactionID', $auth->getTransactionID());

		}elseif($auth->isDeclined()){
			// declined by bank, don't record, bump to stage 1
			$paymentrecord->setVendorID($festos->id);
			$paymentrecord->paymentDate(strftime($config["SHORT_DATE_FORMAT"], mktime()));
			$paymentrecord->paymentAmount($auth->getAmount());
			$paymentrecord->paymentID($auth->getTransactionID());
			$paymentrecord->paymentNotes($auth->getResponseText()); // I don't think this is actually used in PaymentRecorder
			$paymentrecord->paymentProcessor('Credit Card');
			$paymentrecord->recordPayment();
			$paymentrecord->failureNotify();
			// build output string for pay.tpl
			$tpl->set('cc_status', 'Declined');
			$tpl->set('cc_date', strftime($config["SHORT_DATE_FORMAT"], mktime()) );
			$tpl->set('cc_amount', '0');
			$tpl->set('cc_responseText', $auth->getResponseText());
			$tpl->set('cc_transactionID', $auth->getTransactionID());

		}else{
			// Auth.net error
			//$auth->setError($auth->getResponseText());
			//$auth->showErrors();
			// build output string for pay.tpl
			$tpl->set('cc_status', 'Error');
			$tpl->set('cc_date', strftime($config["SHORT_DATE_FORMAT"], mktime()) );
			$tpl->set('cc_amount', '0');
			$tpl->set('cc_responseText', $auth->getResponseText());
			$tpl->set('cc_transactionID', $auth->getTransactionID());
			if($config['DEBUG_MODE']=='true') {
				$tpl->set('debug',$auth->toString());
			} else {
				$tpl->set('debug','');
			}
		}
		

	break;

	case 2:
		// test data, show confirmation
		if(!isset($_POST['stage']) || $_POST['stage'] != '2') {
			redirect($myURL);
		}
	break;

	case 1:
	default:
		// show payment form, this is done by festos_apply.php, so we're done here
	break;
} // end switch($stage)

/* THE ACTUAL TEMPLATE CALL IS MADE IN festos_apply.php SO THERE'S NO MORE TO DO HERE */



?>