<?php
/* ****************************************************************
Available variables:
	$details = array of applicant details, keys match field names in vendors table
	$appTypes = 2-dim array of application types (keys: apptypeID, apptype, apptypelabel, rulesPDF)
	$applicantID = (if logged in) applicants unique ID
	$thispage = URI of the page
	$querystring = All the stuff after the ? in the URL, url-encoded
	$config = configuration data
	$fees = array of application fees (keys: boothFee, appFee, lateFee, lateFeeDate, cornerBoothFee)
	$appfee = application fee
	$boothfee = booth fee for one or more booths
	$cornerfee = corner booth fee or 0
	$latefee = late application fee or 0
	$total = total amount owed
	$totalwithoutappfee = total amount, minus application fee

Template-specific notes:
	THIS TEMPLATE INCLUDES THREE SECTIONS, ONLY ONE OF WHICH IS DISPLAYED AT ANY ONE
		LOADING.
		
		PART 1: DISPLAYS INITIAL ENTRY FORM (NAME, CC NUMBER, EXP. DATE, ETC.)
		PART 2: DISPLAYS RESULTS OF ENTRY-DATA-VALIDATION (REQUIRED DATA PRESENT, CC NUM IS VALID FORM, ETC.)
		PART 3: DISPLAYS RESULTS FROM AUTH.NET TRANSACTION (SUCCESS, DENIED, ERROR)

****************************************************************** */
require_once($config['ABSOLUTE_FILE_PATH'].'addons/pay_authnet/lang.php'); // module-specific language values

switch($stage) {

case 3:
// PART 3: DISPLAYS RESULTS FROM AUTH.NET TRANSACTION

/*
$tpl->set('cc_status', 'Error'); // Approved Declined
$tpl->set('cc_amount', '0');
$tpl->set('cc_responseText', $auth->getResponseText());
$tpl->set('cc_transactionID', $auth->getTransactionID());
*/

	if($cc_status == 'Approved') {
?>
<h3>Approved</h3>
<p>Your payment has been approved by your credit card company. These are the details of the transaction:</p>
<ul style="list-style-type:none;">
	<li>Date: <?php echo $cc_date;?></li>
	<li>Amount: <?php echo $cc_amount;?></li>
	<li>Transaction ID: <?php echo $cc_transactionID;?></li>
	<li>Status: <?php echo $cc_responseText;?></li>
</ul>

<p><a href="<?php echo $config['HTTP_PATH'];?>addons/pay_authnet/receipt.php?date=<?php echo urlencode($cc_date);?>&amount=<?php echo $cc_amount;?>&tID=<?php echo $cc_transactionID;?>" target="_blank">Click Here</a> for a Printable Receipt</p>

<?php
	} elseif ($cc_status == 'Declined') {
?>

<h3>Declined</h3>
<p>Your payment has been declined by your credit card company. Your credit card <em>has not</em> been charged. These are the details of the transaction:</p>
<ul style="list-style-type:none;">
	<li>Date: <?php echo $cc_date;?></li>
	<li>Amount: <?php echo $cc_amount;?></li>
	<li>Transaction ID: <?php echo $cc_transactionID;?></li>
	<li>Status: <?php echo $cc_responseText;?></li>
</ul>

<?php
	} elseif ($cc_status == 'Error') {
?>
<h3>Error</h3>
<p>We apologize. Our credit card processing partner has reported an error with this transaction. Your credit card <em>has not</em> been charged. These are the details of the transaction:</p>
<ul style="list-style-type:none;">
	<li>Date: <?php echo $cc_date;?></li>
	<li>Amount: <?php echo $cc_amount;?></li>
	<li>Transaction ID: <?php echo $cc_transactionID;?></li>
	<li>Status: <?php echo $cc_responseText;?></li>
</ul>

<div><?php echo $debug;?></div>

<?php
	} else {
?>
<p>We're sorry. Something has gone wrong with this transaction.</p>
<?php
	}

break;

case 2:
// PART 2: DISPLAYS RESULTS OF ENTRY-DATA-VALIDATION

require_once($config['ABSOLUTE_FILE_PATH'].'addons/pay_authnet/creditcard.inc.php');
$cc_validate = new CCValidate();

?>
<h4><?php echo $lang['authnet_stage2_heading'];?></h4>

<p><strong>Item Info:</strong><br/>
Amount: <?php echo '$'.number_format($total,2); ?><br/>
Item: <?php echo $authnet['invoiceItem'];?>
</p>

<p><strong>Credit Card Info:</strong><br/>
Card Type: <?php echo $cc_validate->identify($postvars['cc_num']); ?><br/>
Card Number: <?php echo $cc_validate->hide($postvars['cc_num']); ?><br/>
Name on Card: <?php echo $postvars['firstname'].' '.$postvars['lastname'];?>
</p>

<form method="post" method="<?php echo $myURL;?>">
<input type="hidden" name="stage" value="3">
<input type="hidden" name="applicantID" value="<?php echo $applicantID;?>">
<input type="hidden" name="firstname" value="<?php echo $postvars['firstname'];?>">
<input type="hidden" name="lastname" value="<?php echo $postvars['lastname'];?>">
<input type="hidden" name="address" value="<?php echo $postvars['address']; ?>">
<input type="hidden" name="city" value="<?php echo $postvars['city']; ?>">
<input type="hidden" name="state" value="<?php echo $postvars['state']; ?>">
<input type="hidden" name="zip" value="<?php echo $postvars['zip']; ?>">
<input type="hidden" name="cc_num" value="<?php echo $cc_validate->encrypt($cc_validate->clean($postvars['cc_num'])); ?>">
<input type="hidden" name="expire" value="<?php echo $postvars['expire']; ?>">
<input type="hidden" name="cvv2" value="<?php echo $postvars['cvv2']; ?>">
<input type="submit" value="Submit">
</form>

<p class="artisanApplicationNotice"><?php echo $lang['authnet_notice'];?></p>


<br clear="all"/>
<?php
break;

case 1:
default:
/// PART 1: INITIAL ENTRY FORM
?>

<h4><?php echo $lang['authnet_stage1_heading'];?></h4>

<form method="post" method="<?php echo $myURL;?>">
<input type="hidden" name="stage" value="2">
<table cellpadding="2" cellspacing="0">
<tr>
	<td valign="top">Amount Owed: </td>
	<td valign="top"><?php echo '$'.number_format($total,2); ?></td>
</tr>
<tr>
	<td valign="top">Item Name: </td>
	<td valign="top"><?php echo stripslashes($authnet['invoiceItem']);?><br/>(This is what will appear on your credit card statement.)</td>
</tr>
<tr>
	<td valign="top" class="cc_required">First Name: </td>
	<td valign="top"><input type="text" name="firstname" value="<?php echo $details['firstname'];?>"><br/>(Must match the name on your card.)</td>
</tr>
<tr>
	<td valign="top" class="cc_required">Last Name: </td>
	<td valign="top"><input type="text" name="lastname" value="<?php echo $details['lastname'];?>"><br/>(Must match the name on your card.)</td>
</tr>
<tr>
	<td valign="top" class="cc_required">Address: </td>
	<td valign="top"><input type="text" name="address" value="<?php echo $details['address'];?>"></td>
</tr>
<tr>
	<td valign="top" class="cc_required">City: </td>
	<td valign="top"><input type="text" name="city" value="<?php echo $details['city'];?>"></td>
</tr>
<tr>
	<td valign="top" class="cc_required">State: </td>
	<td valign="top"><input type="text" name="state" value="<?php echo $details['state'];?>"></td>
</tr>
<tr>
	<td valign="top" class="cc_required">Zip Code: </td>
	<td valign="top"><input type="text" name="zip" value="<?php echo $details['zip'];?>"></td>
</tr>
<tr>
	<td valign="top" class="cc_required">Credit Card #: </td>
	<td valign="top"><input type="text" name="cc_num" value=""></td>
</tr>
<tr>
	<td valign="top" class="cc_required">Expiration Date: </td>
	<td valign="top"><input type="text" name="expire" value=""></td>
</tr>
<tr>
	<td valign="top" class="cc_required">Security Code: </td>
	<td valign="top"><input type="text" name="cvv2" value=""><br/><em>This is the 3- or 4-digit number most likely on the back of your card.</em></td>
</tr>
<tr>
	<td valign="top"></td>
	<td valign="top"><input type="submit" value="Submit"></td>
</tr>

</table>

</form>
<br clear="all"/>

<?php
break; // ends first stage output

} // end switch() 
?>
