<?php
/* ****************************************************************
Available variables:
	$details = array of applicant details, keys match field names in vendors table
	$appTypes = 2-dim array of application types (keys: apptypeID, apptype, apptypelabel, rulesPDF)
	$applicantID = (if logged in) applicants unique ID
	$thispage = URI of the page
	$querystring = All the stuff after the ? in the URL, url-encoded
	$config = configuration data
	$fees = array of application fees (keys: boothFee, appFee, lateFee, lateFeeDate, cornerBoothFee)
	$appfee = application fee
	$boothfee = booth fee for one or more booths
	$cornerfee = corner booth fee or 0
	$latefee = late application fee or 0
	$total = total amount owed
	$totalwithoutappfee = total amount, minus application fee

Template-specific notes:
	NONE

****************************************************************** */
?>

<h1><?php echo $lang['festival'];?> - Pay By Mail</h1>

<table class="artisanApplicationTable" cellpadding="3" cellspacing="0" border="0" id="appTable" style="margin-left:20px;">
<tr>
  <td valign="top">Vendor name:</td>
  <td valign="top" align="left"><?php echo $details['vendorName']; ?></td>
</tr>
<tr>
  <td valign="top" width="180">First name:</td>
  <td valign="top" align="left" width="225"><?php echo $details['firstname']; ?></td>
</tr>
<tr>
  <td valign="top">Last name:</td>
  <td valign="top" align="left"><?php echo $details['lastname']; ?></td>
</tr>
<tr>
  <td valign="top">Address:</td>
  <td valign="top" align="left"><?php echo $details['address']; ?></td>
</tr>
<tr>
  <td valign="top">Address 2:</td>
  <td valign="top" align="left"><?php echo $details['address2']; ?></td>
</tr>
<tr>
  <td valign="top">City:</td>
  <td valign="top" align="left"><?php echo $details['city']; ?></td>
</tr>
<tr>
  <td valign="top">State:</td>
  <td valign="top" align="left"><?php echo $details['state']; ?></td>
</tr>
<tr>
  <td valign="top">Zip code:</td>
  <td valign="top" align="left"><?php echo $details['zip']; ?></td>
</tr>
<tr>
  <td valign="top">Phone:</td>
  <td valign="top" align="left"><?php echo $details['phone']; ?></td>
</tr>
<tr>
  <td valign="top">Tax ID:</td>
  <td valign="top" align="left"><?php echo $details['taxid']; ?></td>
</tr>

<tr>
  <td valign="top"># Booths Requested:</td>
  <td valign="top" align="left"><?php echo $details['requestedBooths']; ?></td>
</tr>

<tr>
  <td valign="top">Corner Requested:</td>
  <td valign="top" align="left"><?php echo ($details['corner']) ? 'Yes' : 'No'; ?></td>
</tr>

<tr>
  <td valign="top">Demo Requested:</td>
  <td valign="top" align="left"><?php echo ($details['demo']) ? 'Yes' : 'No'; ?></td>
</tr>
</table>


<p style="font-weight:bold;">Please print this page and send it along with two (2) checks, as follows:</p> 
	<blockquote>Check 1 &mdash; Application fee: <strong>$<?php echo number_format($appfee, 2, '.', ','); ?></strong></blockquote>
	
	<blockquote>Check 2 &mdash; Booth fee: <strong>$<?php echo number_format($totalwithoutappfee, 2, '.', ','); ?></strong></blockquote>

<blockquote>Make checks payable to: <strong><?php echo $lang['organizer'];?></strong> and mail with a printout of this page to:<br />
	<blockquote><?php echo $lang['mailingaddress'];?></blockquote>
</blockquote>
</p>

<p style="font-style:italic;">Your application will not be processed until the we receive your checks. Your booth fee check will not be deposited until you are approved for the festival. Any checks returned for insufficient funds will result in application rejection.</p>

<p style="font-style:italic;"><strong>Late fees:</strong> Payments received after <?php echo strftime($config['DATE_FORMAT'],$fees['lateFeeDate']); ?> will be charged a $<?php echo $fees['lateFee']; ?> late fee. If applicable, this amount has been added to your application fee.</p>
