<?php

/*
Receive payment info from PayPal
*/
require_once('../../core/config.php');
require_once($config['ABSOLUTE_FILE_PATH'].'core/core_applicant.php');
$applicant->login(false);
require_once($config['ABSOLUTE_FILE_PATH'].'core/PaymentRecorder.php');
$paymentrecord = new PaymentRecorder($config);


$paypalquery = "SELECT enabled, config FROM ".$config['dbprefix']."paymentmodules 
	WHERE LCase(moduleName) = 'paypal'";
$paypalres = $applicant->query($paypalquery);
$paypalrow = $paypalres->fetch();
$paypal = unserialize($paypalrow['config']);

if($paypalrow['enabled']==0) {
	// if the module is disabled, die now
	die();
}

if($paypal['testmode']==0) {
	$paypalURL = 'ssl://www.paypal.com';
} else {
	$paypalURL = 'ssl://www.sandbox.paypal.com';
}

// read the post from PayPal system and add 'cmd'
$req = 'cmd=_notify-validate';
foreach ($_POST as $key => $value) {
	$value = urlencode(stripslashes($value));
	$req .= "&$key=$value";
}

// assign posted variables to local variables
$item_name = (isset($_POST['item_name'])) ? $_POST['item_name'] : $_POST['item_name1'];
$item_number = (isset($_POST['item_number'])) ? $_POST['item_number'] : $_POST['item_number1'];
$payment_status = $_POST['payment_status'];
$mc_gross = (isset($_POST['mc_gross'])) ? $_POST['mc_gross'] : $_POST['mc_gross1'];
$payment_currency = $_POST['mc_currency'];
$txn_id = $_POST['txn_id'];
$receiver_email = $_POST['receiver_email'];
$receiver_id = $_POST['receiver_id'];
$quantity = (isset($_POST['quantity'])) ? $_POST['quantity'] : $_POST['quantity1'];
$payment_date = strtotime($_POST['payment_date']);
$first_name = $_POST['first_name'];
$last_name = $_POST['last_name'];
$payment_type = $_POST['payment_type'];
$payment_status = $_POST['payment_status'];
$payer_email = $_POST['payer_email'];
$txn_type = $_POST['txn_type'];
$payer_status = $_POST['payer_status'];
$tax = $_POST['tax'];
$custom = $_POST['custom'];

// post back to PayPal system to validate
$header = "POST /cgi-bin/webscr HTTP/1.0\r\n";
$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";

$fp = fsockopen ($paypalURL, 443, $errno, $errstr, 30);


if (!$fp) {
	// HTTP ERROR, SEND AN EMAIL TO THE FESTIVAL PAYMENT ADMINISTRATOR

	$adminquery = "SELECT administratorsEmail FROM ".$config['dbprefix']."payments LIMIT 1";
	$adminres = $applicant->query($adminquery);
	$adminrow = $adminres->fetch();
	$message = "PayPal IPN Error:\n\n";
	$meesage .= "We're sorry, but there has been a network error in the PayPal IPN (Instant Payment Notification) component of FestOS. This usually means that you do not have CURL and OpenSSL enabled. Perhaps you're using PHP 4 also? You will need PHP version 5, though perhaps PHP 4 on a Linux server will do. You must have the php_curl and php_openssl extensions enabled. On a Windows server, you would add these two lines to your php.ini file:\n\n
extension = php_curl.dll\n
extension = php_openssl.dll\n\n";

	$message .= "Diagnostic error message: $errno - $errstr\n";
	sendEmail($adminrow['administratorsEmail'], 'FestOS: PayPal IPN Error', $message);

	} else {
		fputs ($fp, $header . $req);
		while (!feof($fp)) {
			$ppres = fgets ($fp, 1024);
			if (strcmp ($ppres, "VERIFIED") == 0) {
				// If strings are equal, payment is verified, so record:
				$paymentrecord->setVendorID($custom);
				$paymentrecord->paymentDate(strftime($config["DATE_FORMAT"], $payment_date));
				$paymentrecord->paymentAmount($mc_gross);
				$paymentrecord->paymentID($txn_id);
				$paymentrecord->paymentNotes($payment_status);
				$paymentrecord->paymentProcessor('PayPal');
				$paymentrecord->recordPayment();
				$paymentrecord->paymentNotify();
			} else if (strcmp ($ppres, "INVALID") == 0) {
				// Payment is invalid, not verified
				$paymentrecord->setVendorID($custom);
				$paymentrecord->paymentDate(strftime($config["DATE_FORMAT"], $payment_date));
				$paymentrecord->paymentAmount('0');
				$paymentrecord->paymentID($txn_id);
				$paymentrecord->paymentNotes($payment_status);
				$paymentrecord->paymentProcessor('PayPal');
				$paymentrecord->failureNotify();
			} // end if_verified block
		} // end while
	fclose ($fp);
}

?>