<?php 
$title = "ADMIN: Manage Applicant Types";

require_once('../core/core.php');
if($_SESSION["roleID"] > $sponsor) {
   header("Location:index.php");
}
include "includes/header.php";

require_once('../core/MySQL.php');
require_once('includes/security.php');

?>
<script type="text/javascript" language="javascript" src="../js/ajax.js"></script>
<script type="text/javascript" language="javascript" src="../js/unserialize.js"></script>
<script type="text/javascript" language="javascript">

// global variables for use in the various functions
apptypeID = '';
apptypelabel = '';
sortorder = '';
rulesPDF = '';
numphotos = '';
numphotosrequired = '';

// create the ajax request object
var request = null;
function createRequest() {
	try {
	  request = new XMLHttpRequest();
	} catch (trymicrosoft) {
	  try {
		request = new ActiveXObject("Msxml2.XMLHTTP");
	  } catch (othermicrosoft) {
		try {
		  request = new ActiveXObject("Microsoft.XMLHTTP");
		} catch (failed) {
		  request = null;
		}
	  }
	}
} // end createRequest();

// get the sponsor details
function getApplicantType(vtid) {
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_applicants_getdetails.php?apptypeID='+vtid;
	request.open('GET', url, true);
	request.onreadystatechange = updatePage;
	request.send(null);
} // end getSponsor


function updatePage() {
	if(request.readyState==4) {
		// after a short pause, remove focus FROM ".$config['dbprefix']."the button and reset its text
		var arr = PHP_Unserialize(request.responseText);
//		alert(request.responseText);
		apptypeID = arr['apptypeID'];
		apptypelabel = arr['apptypelabel'];
		sortorder = arr['sortorder'];
		rulesPDF = arr['rulesPDF'];
		numphotos = arr['numphotos'];
		numphotosrequired = arr['numphotosrequired'];
		setTimeout("newDetails();", 150);
	}
} // end updatePage

function newDetails() {
	// update the page with the new details just retrieved FROM ".$config['dbprefix']."the server
	document.getElementById('frm_legend').innerHTML = "Edit";
	document.getElementById('frm_legend').style.fontWeight = "bold";
	document.getElementById('frm_apptype').style.backgroundColor = "#BBFFA8";
	document.getElementById('frm_apptype').apptypeID.value = apptypeID;
	document.getElementById('frm_apptype').apptypelabel.value = apptypelabel;
	document.getElementById('frm_apptype').sortorder.value = sortorder;
	document.getElementById('frm_apptype').rulesPDF.value = rulesPDF;
	document.getElementById('frm_apptype').numphotos.value = numphotos;
	document.getElementById('frm_apptype').numphotosrequired.value = numphotosrequired;
	document.getElementById('frm_apptype').frm_button.value = 'Edit';
	document.getElementById('frm_apptype').frm_button.onclick = function() { editApplicantType(document.getElementById("frm_apptype"));};

} // newDetails

function editApplicantType(frm) {
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_applicants_edit.php';
	request.open('POST', url, true);
	request.onreadystatechange = updatePagePostEdit;
	request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	postData = 
		"apptypeID="+frm.apptypeID.value +
		"&apptypelabel="+escape(frm.apptypelabel.value) +
		"&sortorder="+escape(frm.sortorder.value) +
		"&rulesPDF="+escape(frm.rulesPDF.value) +
		"&numphotos="+escape(frm.numphotos.value) +
		"&numphotosrequired="+escape(frm.numphotosrequired.value);
	request.send(postData);
} // end editSponsor

function updatePagePostEdit() {
	if(request.readyState==4) {
//		alert(request.responseText);
		document.location.reload();
	}
} // end updatePagePostEdit


</script>

<h1>Manage Applicant Types &amp; Forms</h1>
<p>Use this page to manage the types of applicants to your festival and their application forms. <strong>You cannot add or delete applicant types.</strong></p>
<?php 
if(isset($_GET["errormsg"])) { 
  echo '<p class="error"><b>Problems:</b><br>'.stripslashes(urldecode($_GET["errormsg"])).'</p>';
} 
?>


<table cellpadding="4" cellspacing="0" class="stripeMe">
<?php

// query
$query = "SELECT apptypeID, apptypelabel, sortorder, appFormID, rulesPDF, numphotos, numphotosrequired
		  FROM ".$config['dbprefix']."applicanttypes
		  ORDER BY sortorder, apptypeID";
$result = $festos->query($query);


// output
if($result->size() > 0) {
?>

<tr id="header">
  <td class="smaller tableheader" valign="top"><strong>Sort</strong></td>
  <td class="smaller tableheader" valign="top"><strong>Appl. Type</strong></td>
  <td class="smaller tableheader" valign="top"><strong>Rules PDF</strong></td>
  <td class="smaller tableheader" valign="top"><strong># Photos Allowed</strong></td>
  <td class="smaller tableheader" valign="top"><strong># Photos Required</strong></td>
  <td class="smaller tableheader" valign="top">&nbsp;</td>
  <td class="smaller tableheader" valign="top">&nbsp;</td>
</tr>
<?php
while ($row = $result->fetch()) {
?>

<tr id="row<?php echo $row["apptypeID"];?>">
  <td class="smaller" valign="top" width="100"><?php echo $row["sortorder"];?></td>
  <td class="smaller" valign="top" width="100"><?php echo $row["apptypelabel"];?></td>
  <td class="smaller" valign="top" width="100"><?php echo $row["rulesPDF"];?></td>
  <td class="smaller" valign="top" width="100"><?php echo $row["numphotos"];?></td>
  <td class="smaller" valign="top" width="100"><?php echo $row["numphotosrequired"];?></td>
  <td class="smaller" valign="top"><input type="button" value="Edit" onClick="getApplicantType(<?php echo $row["apptypeID"];?>)"></td>
  <td class="smaller" valign="top"><input type="button" value="Edit Application" onClick="location='appform.php?apptypeID=<?php echo $row["apptypeID"];?>'"></td>
</tr>

<?php
} // continue while loop

} // end if()
?>
</table>

<form style="margin-top:20px;" id="frm_apptype" name="frm_apptype">
<input type="hidden" name="apptypeID" value="">
<fieldset>
<legend id="frm_legend">Edit</legend>
<table>
<tr>
	<td valign="top" width="125">Sort Order</td>
	<td valign="top"><input type="text" name="sortorder" size="4" value=""></td>
	<td valign="top"></td>
</tr>
<tr>
	<td valign="top" width="125">Applicant Type</td>
	<td valign="top"><input type="text" name="apptypelabel" size="40" value=""></td>
	<td valign="top"></td>
</tr>
<tr>
	<td valign="top" width="125">Rules PDF</td>
	<td valign="top"><input type="text" name="rulesPDF" size="40" value=""></td>
	<td valign="top" class="smaller">(you must upload this file to the /apps directory)</td>
</tr>
<tr>
	<td valign="top" width="125"># Photos Allowed</td>
	<td valign="top"><input type="text" name="numphotos" size="4" value=""></td>
	<td valign="top"></td>
</tr>
<tr>
	<td valign="top" width="125"># Photos Required</td>
	<td valign="top"><input type="text" name="numphotosrequired" size="4" value=""></td>
	<td valign="top"><input type="button" value="Edit" onClick="editApplicantType(this.form);" style="margin-left:25px;" name="frm_button"> <input type="button" value="Reset" onClick="location.reload();"></td>
</tr>
</table>

</fieldset>

</form>

<script type="text/javascript">
 $(document).ready(function(){
   $(".stripeMe tr").mouseover(function(){$(this).addClass("overrow");}).mouseout(function(){$(this).removeClass("overrow");});
   $(".stripeMe tr:even").addClass("oddrow");
 });
</script>

<?php 

include "includes/footer.php";
?>
