<?php 
$title = "Dynamic Configuration";

require_once('../core/core.php');
require_once($config['ABSOLUTE_FILE_PATH'].'admin/includes/header.php');

?>

<h2>Dynamic Configuration</h2>
<p><strong style="background-color:#990000;color:#fff;padding:3px;">Changing these values could prevent your site from working.</strong></p>
<p>With this page, you can adjust the operation of your web site. If you're not sure of the right value to use, contact your host, webmaster, or leave the setting as-is.</p>

<form action="configuration_doit.php" method="post">
<table>
<tr>
	<td valign="middle" class="artisanApplicationTableHeader" colspan="3">General settings</td>
</tr>
<tr>
	<td valign="middle">Blind juried show</td>
	<td valign="middle">
	<?php if(isset($config['JURIED']) && $config['JURIED'] == 1) { ?>
	<input type="radio" name="JURIED" value="1" checked> Yes&nbsp;&nbsp;<input type="radio" name="JURIED" value="0"> No
	<?php } else { ?>
	<input type="radio" name="JURIED" value="1"> Yes&nbsp;&nbsp;<input type="radio" name="JURIED" value="0" checked> No
	<?php } ?>
	</td>
	<td> Name and other identifying details hidden on some reports for blind juried shows.</td>
</tr>
<tr>
	<td valign="middle">Recent Applications</td>
	<td valign="middle"><input type="text" width="6" name="RECENT_APPS" value="<?php echo $config['RECENT_APPS'];?>"></td>
	<td> number of recent applications to show in box on admin home page.</td>
</tr>
<tr>
	<td valign="middle">Auto-logout</td>
	<td valign="middle"><input type="text" width="6" name="AUTO_LOGOUT" value="<?php echo $config['AUTO_LOGOUT'];?>"></td>
	<td> <strong>seconds</strong> until administrators are logged out. Set to <strong>false</strong> to disable.</td>
</tr>
<tr>
	<td valign="middle">"No image" image</td>
	<td valign="middle"><input type="text" width="6" name="NO_IMAGE" value="<?php echo $config['NO_IMAGE'];?>"></td>
	<td> image to show when there is "no image" uploaded.</td>
</tr>
<tr>
	<td valign="middle">Theme</td>
	<td valign="middle">
	<select name="THEME">
	<?php
	if ($handle = opendir($config['ABSOLUTE_FILE_PATH'].'themes/')) {
    while (false !== ($file = readdir($handle))) {
        if (is_dir($config['ABSOLUTE_FILE_PATH'].'themes/'.$file) && $file != "." && $file != "..") {
            echo '<option value="'.$file.'"';
			if(isset($config['THEME']) && $file == $config['THEME']) echo ' selected';
			echo '>'.$file.'</option>';
        }
    }
    closedir($handle);
	}

	?>
	</select>
	
	</td>
	<td> User interface theme, which corresponds to a set of files and directories in the /themes directory.</td>
</tr>

<tr>
	<td valign="middle" class="artisanApplicationTableHeader" colspan="3">Date and Time settings</td>
</tr>
<tr>
	<td valign="middle">Date format</td>
	<td valign="middle"><input type="text" width="6" name="DATE_FORMAT" value="<?php echo $config['DATE_FORMAT'];?>"></td>
	<td> date format, based on the PHP <a href="http://us3.php.net/strftime" title="PHP help docs: strftime() function">strftime()</a> function</td>
</tr>
<tr>
	<td valign="middle">Date &amp; time format</td>
	<td valign="middle"><input type="text" width="6" name="DATETIME_FORMAT" value="<?php echo $config['DATETIME_FORMAT'];?>"></td>
	<td> format for the longer date and time output</td>
</tr>
<tr>
	<td valign="middle">Time format</td>
	<td valign="middle"><input type="text" width="6" name="TIME_FORMAT" value="<?php echo $config['TIME_FORMAT'];?>"></td>
	<td> format for a simpler time output (used on performance schedule page)</td>
</tr>
<tr>
	<td valign="middle">Short Date format</td>
	<td valign="middle"><input type="text" width="6" name="SHORT_DATE_FORMAT" value="<?php echo $config['SHORT_DATE_FORMAT'];?>"></td>
	<td> a short (abbreviated) date format, used mostly in the admin pages</td>
</tr>
<tr>
	<td valign="middle">Short Date &amp; time format</td>
	<td valign="middle"><input type="text" width="6" name="SHORT_DATETIME_FORMAT" value="<?php echo $config['SHORT_DATETIME_FORMAT'];?>"></td>
	<td> a short (abbreviated) date and time output</td>
</tr>


<tr>
	<td valign="middle" class="artisanApplicationTableHeader" colspan="3">Google Maps settings</td>
</tr>

<tr>
	<td valign="middle">Google Maps API key</td>
	<td valign="middle"><input type="text" width="6" name="GOOGLE_MAPS_API" value="<?php echo $config['GOOGLE_MAPS_API'];?>"></td>
	<td> enter your Google Maps API key</td>
</tr>

<tr>
	<td valign="middle" class="artisanApplicationTableHeader" colspan="3">Mail configuration settings</td>
</tr>

<tr>
	<td valign="middle">SMTP server</td>
	<td valign="middle"><input type="text" width="6" name="SMTP_SERVER" value="<?php echo $config['SMTP_SERVER'];?>"></td>
	<td> your outgoing mail server's name or address, e.g. mail.yourserver.com</td>
</tr>
<tr>
	<td valign="middle">Sender</td>
	<td valign="middle"><input type="text" width="6" name="SMTP_SENDER" value="<?php echo $config['SMTP_SENDER'];?>"></td>
	<td> email address from which emails are sent</td>
</tr>
<tr>
	<td valign="middle">Reply To</td>
	<td valign="middle"><input type="text" width="6" name="SMTP_REPLYTO" value="<?php echo $config['SMTP_REPLYTO'];?>"></td>
	<td> (optional) provide an alternate reply-to address</td>
</tr>
<tr>
	<td valign="middle">CC (Carbon Copy)</td>
	<td valign="middle"><input type="text" width="6" name="SMTP_CC" value="<?php echo $config['SMTP_CC'];?>"></td>
	<td> (optional) a CC address to which emails will be also sent (not fully implemented)</td>
</tr>
<tr>
	<td valign="middle">SMTP Authentication</td>
	<td valign="middle"><input type="text" width="6" name="SMTP_AUTH" value="<?php echo ($config['SMTP_AUTH']=='true') ? 'true' : 'false';;?>"></td>
	<td> <strong>true</strong> to use SMTP authentication, or set to <strong>false</strong></td>
</tr>
<tr>
	<td valign="middle">SMTP user</td>
	<td valign="middle"><input type="text" width="6" name="SMTP_USER" value="<?php echo $config['SMTP_USER'];?>"></td>
	<td> the email address to use with SMTP authentication</td>
</tr>
<tr>
	<td valign="middle">SMTP password</td>
	<td valign="middle"><input type="password" width="6" name="SMTP_USER_PASSWORD" value="<?php echo $config['SMTP_USER_PASSWORD'];?>"></td>
	<td> the password to use with SMTP authentication</td>
</tr>
<tr>
	<td valign="middle">phpMailer language</td>
	<td valign="middle"><input type="text" width="6" name="PHPMAILER_LANGUAGE" value="<?php echo $config['PHPMAILER_LANGUAGE'];?>"></td>
	<td> 2-letter abbreviation per phpMailer instructions</td>
</tr>

<tr>
	<td valign="middle" class="artisanApplicationTableHeader" colspan="3">Category special handling</td>
</tr>

<tr>
	<td valign="middle">Default application type</td>
	<td valign="middle"><input type="text" width="6" name="DEFAULT_APPLICANT_TYPE" value="<?php echo $config['DEFAULT_APPLICANT_TYPE'];?>"></td>
	<td> enter the <strong>application ID number</strong> that is the default</td>
</tr>
<tr>
	<td valign="middle">Food vendor applicant type</td>
	<td valign="middle"><input type="text" width="6" name="FOOD_VENDORS_TYPEID" value="<?php echo $config['FOOD_VENDORS_TYPEID'];?>"></td>
	<td> food vendors are treated differently; enter their <strong>applicant type number</strong> here</td>
</tr>
<tr>
	<td valign="middle">Member applicant type</td>
	<td valign="middle"><input type="text" width="6" name="MEMBER_APPLICANT_TYPE" value="<?php echo $config['MEMBER_APPLICANT_TYPE'];?>"></td>
	<td> "members" of the sponsoring organization are treated differently; enter their <strong>applicant type number</strong> here</td>
</tr>
<tr>
	<td valign="middle">Excluded vendor category</td>
	<td valign="middle"><input type="text" width="6" name="EXCLUDED_VENDOR_CATEGORIES" value="<?php echo $config['EXCLUDED_VENDOR_CATEGORIES'];?>"></td>
	<td> vendors with this <strong>category ID number</strong> are not within various lists; useful for a "member" category </td>
</tr>
<tr>
	<td valign="middle">Deleted type ID</td>
	<td valign="middle"><input type="text" width="6" name="DELETED_TYPEID" value="<?php echo $config['DELETED_TYPEID'];?>"></td>
	<td> if you delete a category, vendors in that category are given this category ID instead</td>
</tr>


<tr>
	<td valign="middle" class="artisanApplicationTableHeader" colspan="3">Application settings</td>
</tr>
<tr>
	<td valign="middle">Minimum applicants</td>
	<td valign="middle"><input type="text" width="6" name="MINIMUM_APPLICANTS" value="<?php echo $config['MINIMUM_APPLICANTS'];?>"></td>
	<td> minimum number of approved applicants before current-year records will be shown</td>
</tr>
<tr>
	<td valign="middle">Required photos</td>
	<td valign="middle"><input type="text" width="6" name="REQUIRED_PHOTOS" value="<?php echo $config['REQUIRED_PHOTOS'];?>"></td>
	<td> number, from 0 - 4, of required photos</td>
</tr>
<tr>
	<td valign="middle">Apps w/out photos</td>
	<td valign="middle"><input type="text" width="6" name="NO_PHOTOS" value="<?php echo $config['NO_PHOTOS'];?>"></td>
	<td> applicant types who don't upload photos. Follows special format: a=>b where a is just a sequential number (first is 1, then 2, etc.) and the second is the application type (see one section up). E.g. 1=>5 means volunteers don't provide photos. </td>
</tr>

<tr>
	<td valign="middle" class="artisanApplicationTableHeader" colspan="3">Miscellaneous</td>
</tr>

<tr>
	<td valign="middle">PHP error reporting</td>
	<td valign="middle"><input type="text" width="6" name="ERRORLEVEL" value="<?php echo $config['ERRORLEVEL'];?>"></td>
	<td> set to <strong>0</strong> (zero) to hide all php error reporting. See the <a href="http://us3.php.net/manual/en/function.error-reporting.php" title="error_reporting function help">php manual</a> for more info.</td>
</tr>
<tr>
	<td valign="middle">Debug mode</td>
	<td valign="middle"><input type="text" width="6" name="DEBUG_MODE" value="<?php echo ($config['DEBUG_MODE']=='true') ? 'true' : 'false';?>"></td>
	<td> set to <strong>true</strong> (or 1) to output some debugging messages, otherwise set to <strong>false</strong> (or 0)</td>
</tr>

<tr>
	<td valign="middle"></td>
	<td valign="middle"><input type="submit" value="Submit"><input type="button" value="Cancel" style="font-weight:bold;" onClick="location='index.php';"></td>
	<td></td>
</tr>

</table>

</form>


<?php 
include "includes/footer.php";
?>
