<?php
/* ************************************************
 filename: do_ex_sendannouncements.php
 function: Processor page: sends announcement emails to selected artisans
 ************************************************ */
require_once('../core/core.php');
// 1. Confirm form values

// if sendto field doesn't exist or if this page is called from another host, redirect
if(	(!isset($_POST['sendto']) && !isset($_GET['sendto']))) {
	header('Location:http://'.$_SERVER['HTTP_HOST'].rtrim(dirname($_SERVER['PHP_SELF']),'\\').'/index.php');
	die();
}

// 2. set up db access and variables
// DETERMINE IF THIS IS THE FIRST TIME THE PAGE HAS BEEN CALLED
if(!isset($_GET['next'])) {
	$beginRow = 0;   // first row to be retrieved
	// update the message text in the DB with what has been passed
	$msgQuery = "UPDATE ".$config['dbprefix']."messages SET 
		msgText = '".$_POST['msgText']."'
	WHERE msgID = 2";
	$msgRes = $festos->query($msgQuery);
	$message = $_POST['msgText'];
} else {
	$beginRow = $_GET['next'];  // first row to be retrieved
	// get message from the database
	$msgQuery = "SELECT msgText FROM ".$config['dbprefix']."messages WHERE msgID = 2";
	$msgRes = $festos->query($msgQuery);
	if($msgRes->size() > 0 ) {
		$msgRow = $msgRes->fetch();
		if($msgRow['msgText'] != '') $message = $msgRow['msgText'];
		else $message = $lang['send_approval_message'];
	} else {
		$message = $lang['send_approval_message'];
	}
}

$batchSize = MAILBATCH; // rows per batch before reloading page
$subject = (isset($_GET['subject'])) ? urldecode($_GET['subject']) : urldecode($_POST['subject']);
$sendto = (isset($_GET['sendto'])) ? $_GET['sendto'] : $_POST['sendto'];

// 3. Display page content

$title = "ADMIN: Send Artisan Approvals";


include "includes/header.php";

$whereclause = '';
switch($sendto) {
	case 'unapproved':
		$whereclause = ' AND approved = 0 ';
	break;
	case 'approved':
	default:
		$whereclause = ' AND approved = 1 ';
	break;
}
$countQuery = "SELECT vendorID FROM ".$config['dbprefix']."vendors WHERE email <> '' AND email IS NOT NULL AND email <> '0' AND fpma = 0 AND vTypeID <> ".$config["MEMBER_APPLICANT_TYPE"]." AND vTypeID <> ".$config["EXCLUDED_VENDOR_CATEGORIES"].$whereclause;
$countRes = $festos->query($countQuery);
$numResults = $countRes->size();

$upperlimit = ($beginRow + $batchSize - 1 < $numResults) ? $beginRow + $batchSize - 1 : $numResults;

echo "<h1>Sending exhibitor announcements<br />".$beginRow." through ".$upperlimit." out of ".$numResults."</h1>";


// 4. Process email messages
$query = "SELECT firstname, lastname, vendorName, email, password FROM ".$config['dbprefix']."vendors WHERE email <> '' AND email IS NOT NULL AND email <> '0' ";
$query .= $whereclause;
$query .= " LIMIT ".$beginRow.", ".$batchSize;
$res = $festos->query($query);
if($res->size() > 0) {
	// for each vendor, process and send the email message
	echo '<div style="border:1px solid #000;padding:10px;margin-bottom:15px;font-size:10px;"><b>Sending to:</b><br />';
	while($row = $res->fetch()) {
		$tmpmessage = $message;
		$tmpmessage = str_replace('{FIRSTNAME}', ($row['firstname'] != '') ? $row['firstname'] : 'Mr/Mrs' , $tmpmessage);
		$tmpmessage = str_replace('{LASTNAME}', ($row['lastname'] != '') ? $row['lastname'] : '', $tmpmessage);
		$tmpmessage = str_replace('{ARTISAN}', ($row['vendorName'] != '') ? $row['vendorName'] : '', $tmpmessage);
		$tmpmessage = str_replace('{EMAIL}', $row["email"], $tmpmessage);
		$tmpmessage = str_replace('{PASSWORD}', $row['password'], $tmpmessage);
		$tmpmessage = str_replace('{TODAY}', strftime('%B %d, %Y',mktime()), $tmpmessage);


		sendEmail($row["email"], $subject, $tmpmessage); // function defined in ../core/core.php
		
		echo $row['firstname']. ' '.$row['lastname'].' ('.$row['vendorName'].') at '.$row['email'].'<br />';
		flush();
	} // end while()
	echo '</div>';
} // end if()

$next = ($beginRow == 0) ? $batchSize : $beginRow + $batchSize;

if($next < $numResults) {
//	echo '<input type="button" value="Next" onClick="location=\'do_ex_sendannouncements.php?sendto='.$sendto.'&next='.$next.'&subject='.urlencode($subject).'&message='.urlencode($message).'\'">';

	$jsCommand = 'location=\'do_ex_sendapproved.php?sendto='.$sendto.'&next='.$next.'&subject='.urlencode($subject).'&message='.urlencode($message).'\';';
	echo '<script>setTimeout("'.$jsCommand.'", '.MAILDELAY.');</script>';

} else {
	$jsCommand = 'location=\'ex_sendapproved_done.php?sendto='.$sendto.'&total='.$numResults.'\';';
	echo '<script>setTimeout("'.$jsCommand.'", '.MAILDELAY.');</script>';
}
?>
<p><strong>DO NOT CLOSE THIS WINDOW or navigate to another web page.</strong></p><p>This page will automatically reload itself in <span id="timer" style="background-color:#FFCC99;padding:3px;font-weight:bold;">00</span> to continue sending messages. If you close this browser window, visit another page, or click your browser's stop button, any remaining email messages will <em>not</em> be sent.</p>


<script type="text/javascript" language="javascript">

function formatTime(t) {
	retVal = '';
	if(t>60) {
		retVal = Math.floor(t/60) + " mins, " + t%60 + " secs";
	} else {
		retVal = t + " seconds";
	}
	return retVal;
}

function tick(t) {
	if(t>0) {
		$('#timer').text(formatTime(t));
		t--;
		setTimeout('tick('+t+');', 1000);
	} 
}
tick(<?php echo MAILDELAY/1000; ?>);

</script>


<?php 
include "includes/footer.php";
?>

