<?php
/* ************************************************
 filename: do_mgr_add.php
 function: processor page for mgr_add.php
           Adds new site manager
LOGIC

 1. Confirm form values exist, redirect if not
 2. Stuff values into DB
 3. Display success message
 ************************************************ */
require_once('../core/core.php');
$festos->login();

// 1. Confirm form values

$error = false;
$errormsg = "";

// check for required fields
if(!isset($_POST["username"]) || count($_POST["username"]) == 0) 
  {
  $error = true;
  $errormsg = $errormsg.'User name is a required field.<br>';
  }
if(!isset($_POST["password"]) || count($_POST["password"]) == 0) 
  {
  $error = true;
  $errormsg = $errormsg.'A password is required.<br>';
  }
if(!isset($_POST["email"]) || count($_POST["email"]) == 0) 
  {
  $error = true;
  $errormsg = $errormsg.'An email address is required.<br>';
  }
  
// check for valid data
// password matches confirm
if(!isset($_POST["confirm"]) || $_POST["password"] != $_POST["confirm"]) 
  {
  $error = true;
  $errormsg = $errormsg.'Passwords don\'t match. Please try again. You must enter the same password into the Password and Confirm boxes.<br>';
  }

// password more than 5 characters
if(strlen($_POST["password"]) <= 5) 
  {
  $error = true;
  $errormsg = $errormsg.'Your password must be more than 5 characters long.<br>';
  }
// username more than 5 characters
if(strlen($_POST["username"]) <= 5) 
  {
  $error = true;
  $errormsg = $errormsg.'Your user name must be more than 5 characters long.<br>';
  }

if($error) {
  header("Location:mgr_add.php?errormsg=".urlencode($errormsg)
    .'&username='.urlencode($_POST["username"])
    .'&email='.urlencode($_POST["email"])
    .'&roleID='.urlencode($_POST["roleID"])
  );
//echo 'password = '.$_POST["password"].'<br>';
//echo 'confirm = '.$_POST["confirm"].'<br>';
//echo 'username = '.$_POST["username"].'<br>';
  die();
}



// 2. Stuff db

// set up db access
// query
$query = "INSERT INTO ".$config['dbprefix']."users
           (username, password, email, roleID)
          VALUES
           (
             '".$_POST["username"]."',
             '".md5($_POST["password"])."',
             '".$_POST["email"]."',
             ".$_POST["userRoleID"]."
            )";
$result = $festos->query($query);

// 3. Display success message

$title = "ADMIN: Add Site Manager - Success";
include "includes/header.php";
?>

<h1>Success</h1>
<p>You have successfully added a new site manager.</p>
<p>Return to:<br>
   the <a href="mgr_add.php">Add Site Managers</a> Page<br>
   the <a href="index.php">Admin Home</a> page</p>
<?php 
include "includes/footer.php";
?>

