<?php 
$debug = false;

/* ***************************************
   admin/do_reports_export.php
   Export artisan details
   
   *************************************** */

require_once('../core/core.php');
// Function to strip commas from strings
function stripCommas ($str) {
	$search = array("'([\r\n])[\s]+'","/,/");
	$replace = array(' ',' ');
	return preg_replace($search, $replace, $str);
}


$column_headers['vendorID'] = 'Vendor ID';
$column_headers['tracking'] = 'Tracking #';
$column_headers['vendorName'] =  'Exhibitor name';
$column_headers['firstname'] =  'First name';
$column_headers['lastname'] =  'Last name';
$column_headers['taxid'] =  'Tax ID';
$column_headers['vType'] =  'Vendor type';
$column_headers['description'] =  'Description of work';
$column_headers['address'] =  'Address';
$column_headers['city'] =  'City';
$column_headers['state'] =  'State';
$column_headers['zip'] =  'Zip';
$column_headers['phone'] =  'Phone';
$column_headers['cellphone'] =  'Cell phone';
$column_headers['email'] =  'Email';
$column_headers['website'] =  'Web site';
$column_headers['requestedBooths'] =  'Requested booths';
$column_headers['boothLocationPref'] =  'Booth location preference';
$column_headers['priorBooth'] =  'Prior booth';
$column_headers['corner'] =  'Corner booth';
$column_headers['demo'] =  'Demoing?';
$column_headers['demoDescription'] =  'Demo description';
$column_headers['photoDescription'] =  'Photo description';
$column_headers['ban'] =  'Ban reason';
$column_headers['comments'] =  'Comments';
$column_headers['appDate'] =  'Application date';
$column_headers['transactionID'] =  'Transaction ID / Check #';
$column_headers['paymentDate'] =  'Payment date';
$column_headers['assignedBooths'] = 'Assigned booths';

$ch = array(); // will hold the final list of column headers

$fieldlist = array();
$fieldlist[] = 'vendorID';
$fieldlist[] = 'tracking';
$fieldlist[] = 'vendorName';
$fieldlist[] = 'firstname';
$fieldlist[] = 'lastname';
$fieldlist[] = 'taxid';
$fieldlist[] = 'vType';
$fieldlist[] = 'description';
$fieldlist[] = 'address';
$fieldlist[] = 'city';
$fieldlist[] = 'state';
$fieldlist[] = 'zip';
$fieldlist[] = 'phone';
$fieldlist[] = 'cellphone';
$fieldlist[] = 'email';
$fieldlist[] = 'website';
$fieldlist[] = 'requestedBooths';
$fieldlist[] = 'boothLocationPref';
$fieldlist[] = 'priorBooth';
$fieldlist[] = 'corner';
$fieldlist[] = 'showedIn';
$fieldlist[] = 'demo';
$fieldlist[] = 'demoDescription';
$fieldlist[] = 'photoDescription';
$fieldlist[] = 'ban';
$fieldlist[] = 'comments';
$fieldlist[] = 'appDate';
$fieldlist[] = 'transactionID';
$fieldlist[] = 'paymentDate';
$fieldlist[] = 'assignedBooths';

//$queryFields = array();
//foreach ($array as $i => $value) {
//    unset($array[$i]);
//}

foreach($_POST as $val) {
	if(in_array($val, $fieldlist)) {
		
		if($val != 'assignedBooths') {
			$queryFields[] = $val;
			$ch[] = $column_headers[$val];
		}
	}
}

if($debug) {
	echo 'POST = <br />';
	print_r($_POST);
	echo '<br /><br />queryFields = <br />';
	print_r($queryFields);
	echo '<br />';
}

$fromClause = ' '.$config['dbprefix'].'vendors ';
$vendorType = '';

$whereArray = array();
$whereclause = '';
if(isset($_POST['approved']) && $_POST['approved'] != '99') {
	$whereArray[] = 'approved = '.$_POST['approved'];
}
if(isset($_POST['paid']) && $_POST['paid'] != '99') {
	$whereArray[] = 'paidBoothFee = '.$_POST['paid'];
}
if(isset($_POST['statusID']) && $_POST['statusID'] != '0') {
	$whereArray[] = 'statusID = '.$_POST['statusID'];
}

if(isset($_POST['fpma']) && $_POST['fpma'] != '99') {
	$whereArray[] = 'fpma = '.$_POST['fpma'];
}

if(isset($_POST['beginswith']) && $_POST['beginswith'] != '') {
	$whereArray[] = 'vendorName LIKE "'.$_POST['beginswith'].'%"';
}
if(isset($_POST['lastbeginswith']) && $_POST['lastbeginswith'] != '') {
	$whereArray[] = 'lastname LIKE "'.$_POST['lastbeginswith'].'%"';
}
// vendor type display
if(isset($_POST['vType']) && $_POST['vType'] != '0') {
	$whereArray[] = $config['dbprefix']."vendors.vTypeID = ".$config['dbprefix']."vendortypes.vTypeID";
	$fromClause .= ", ".$config['dbprefix']."vendortypes ";
	$vendorType = ', vType';
	$ch[] = $column_headers['vType'];
}

if(count($whereArray) > 0) {
	$whereclause = 'WHERE '.implode(' AND ', $whereArray);
}

// ORDER BY CLAUSE
$orderBy = ' ORDER BY vendorName ASC';
if(isset($_POST['sortorder'])) {
	switch ($_POST['sortorder']) {
		case 'vna':
			$orderBy = ' ORDER BY vendorName ASC';
		break;
		case 'vnd':
			$orderBy = ' ORDER BY vendorName DESC';
		break;
		case 'lna':
			$orderBy = ' ORDER BY lastname ASC';
		break;
		case 'lnd':
			$orderBy = ' ORDER BY lastname DESC';
		break;
		case 'add':
			$orderBy = ' ORDER BY appDate DESC';
		break;
		case 'ada':
			$orderBy = ' ORDER BY appDate ASC';
		break;
		case 'ida':
			$orderBy = ' ORDER BY vendorID ASC';
		break;
		case 'idd':
			$orderBy = ' ORDER BY vendorID DESC';
		break;
		default:
			$orderBy = ' ORDER BY vendorName ASC';
		break;
	} // end switch()
}

$query = 'SELECT '.implode(', ', $queryFields).$vendorType.' FROM '.$fromClause.' '.$whereclause.$orderBy;
$res = $festos->query($query);

if($debug) {
	echo '<html><head><title>Debug output</title></head><body>';
	echo 'Query: <pre>'.$query.'</pre>';
	echo '<pre>';
} else {
	header("Content-type: application/octet-stream"); 
	header("Content-disposition: attachment; filename=artisan_details_export.csv");
	header("Pragma: no-cache"); 
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	header("Expires: 0"); 
}

//if(isset($_POST['vType']) && $_POST['vType'] != '0') {
//	$queryFields[] = 'Vendor Type';
//}
echo implode(', ', $ch);
//echo implode(', ', $queryFields);
if(isset($_POST['assignedBooths'])) { echo ', Assigned booths'; }
echo "\n";
  
while ($row = $res->fetch()) {
	foreach($row as $key=>$data) {
		if($key=='appDate' || $key=='paymentDate') {
			if($data != '') echo strftime($config["SHORT_DATE_FORMAT"], $data);
		} elseif($key=='corner' || $key=='demo') {
			echo ($data==0) ? 'No' : 'Yes';
		} else {
			echo stripslashes(stripCommas($data));
		}
		echo ', ';
	}

	if(isset($_POST['assignedBooths'])) {
		$boothQuery = "SELECT booth FROM ".$config['dbprefix']."vendorlocations WHERE vendorID = ".$row['vendorID'];
		$boothRes = $festos->query($boothQuery);
		$boothQuerySize = $boothRes->size();
		if($boothQuerySize>0) {
			$count = 1;
			while ($boothRow = $boothRes->fetch()) {
				echo $boothRow['booth'];
				if($count < $boothQuerySize) echo '; ';
				$count = $count+ 1;
			} // end while
		} else {
			echo 'n/a';
		} // end if
	}
	echo "\n";
} // ends while loop

?> 

