<?php 
require_once('../core/core.php');

$title = $lang['festival']." Admin Home Page";
include "includes/header.php";
?>

<div style="width:85%;">
<h1><?php echo $lang['festival'];?> Administration Home Page</h1>

<div id="adminRightColumn">
<div id="yearHelpBox">
This year value is used to track when artists exhibited at your festival and is used in various reports. More than one festival per year? Use entries like "2009a" and "2009b" to distinguish them.
</div>

<div id="yearbox">
<strong>Fest Year:</strong> 
	<span id="yearEdit">
		<span id="yearValue"><?php echo $year; ?></span>
		<span id="yearChange"><input type="text" name="year" id="yearChangeField" value="<?php echo $year; ?>" size="5"> <img src="images/check.png" width="16" height="16" alt="Save" title="Save" border="0" align="absbottom" id="yearChangeSave"/></span>
	</span> <img src="images/edit.png" width="16" height="16" alt="Edit" title="Edit" border="0" align="absbottom" id="yearEditBtn"/>  <img src="images/help.png" width="16" height="16" alt="Help" border="0" align="absbottom" id="yearHelpBtn"/>
</div>

<div id="recentappsbox">
<script src="../js/jquery.dimensions.js" type="text/javascript"></script>
<script src="../js/jquery.cluetip.js" type="text/javascript"></script>
<h3>Apps in Last <?php echo $config['RECENT_APPS'];?> Days</h3>
<?php 
$today = mktime();
$applicationAge = $config['RECENT_APPS']*60*60*24; // 10 days
$otherDay = $today - $applicationAge;

$appquery = "SELECT vendorID, vendorName, firstname, lastname, appDate, address, city, state, zip, phone, email, website  FROM ".$config['dbprefix']."vendors 
	WHERE appDate > '".$otherDay."' 
	AND approved = 0";
$appres = $festos->query($appquery);
if($appres->size() > 0) {
	// records returned
	echo '<table class="recentApps" cellspacing="0" cellpadding="1">';
	echo '<tr><th>Name</th><th>App. Date</th></tr>';
	while($approw = $appres->fetch() ) {
		// build name output string
		$nameStr = ($approw['vendorName'] !='') ? stripslashes($approw['vendorName']) : stripslashes($approw['firstname']).' '.stripslashes($approw['lastname']);
	
		echo '<tr>';
		echo '<td width="50%"><a href="ex_edit_row.php?vendorID='.$approw['vendorID'].'"';
		echo ' title="'.$nameStr.'|';
		echo $approw['address'].'|';
		echo $approw['city'].', '.$approw['state'].' '.$approw['zip'].'|';
		echo $approw['phone'].'|';
		echo $approw['email'].'|';
		echo $approw['website'];
		echo '|(click to edit)" class="quickAppBox">';

		echo $nameStr;
		echo '</a></td>';
		echo '<td width="45%">'.strftime($config['DATE_FORMAT'], $approw['appDate']).'</td>';
		echo '</tr>';
	} // end while
	echo '</table>';
	echo '<p class="smaller"><a href="recentapplications.php" title="Click to see more recent applications">See more</a></p>';
} else {
	echo '<p class="smaller">No applications received within the past '.$config['RECENT_APPS'].' days (excludes approved applications).</p>';
}

?>

<script type="text/javascript">
$(document).ready(function() {
  $('a.quickAppBox').cluetip({ splitTitle: '|' });

  $("#yearEditBtn").click(function() {
    $("#yearValue").hide();
    $("#yearChange").show();
    $("#yearEditBtn").hide();
  });

$('#yearChangeField').keyup(function(e) {
	if(e.keyCode == 13) {
		$("#yearChange").hide();
		$("#yearEditBtn").show();
		$.get('do_misc_year.php', {year:$("#yearChangeField").val()}, function(data) { 
			$("#yearValue").html(data);
		});
		$("#yearValue").show();
	}
});

  $("#yearChangeSave").click(function() {
    $("#yearChange").hide();
    $("#yearEditBtn").show();
	$.get('do_misc_year.php', {year:$("#yearChangeField").val()}, function(data) { 
		$("#yearValue").html(data);
	});
    $("#yearValue").show();
  });

/*
$.get("test.cgi", { name: "John", time: "2pm" },
  function(data){
    alert("Data Loaded: " + data);
  });
*/

  $("#yearHelpBtn").hover(function() {
    $("#yearHelpBox").show();
  }, function() {
    $("#yearHelpBox").hide();
  });

});
</script>
<link rel="stylesheet" href="../css/jquery.cluetip.css" type="text/css" />
</div> <!-- end recentappsbox -->
</div> <!-- end adminRightColumn -->


<div style="float:left;width:70%;">

<?php
$query = "SELECT pageID, pageName, pageFile, pageDescription, icon FROM ".$config['dbprefix']."adminpages WHERE (parentID IS NULL OR parentID = '') AND ".$_SESSION['roleID']." <= requiredRole ORDER BY sequence";
$res = $festos->query($query);

while($row = $res->fetch()) {
?>
<h4 class="mgmtHeader" style="clear:both;margin-bottom:0px;"><img src="images/<?php echo $row['icon'];?>" height="32" width="32" align="left" style="padding-bottom:10px;margin-top:10px;margin-right:15px;"><a href="<?php echo $row['pageFile'];?>?pageID=<?php echo $row['pageID'];?>"><?php echo $row['pageName'];?></a></h4>
<p style="margin-top:0px;padding-bottom:20px;"><?php echo stripslashes($row['pageDescription']);?></p>

<?php
}
echo '</div></div>';
include "includes/footer.php";
?>
