<?php 
$title = "Language Editor";

require_once('../core/core.php');
require_once($config['ABSOLUTE_FILE_PATH'].'admin/includes/header.php');

$labels = array();
$labels['festival'] = 'Festival name';
$labels['thefestival'] = 'The festival name';
$labels['pageheader'] = 'Page Heading';
$labels['meta_description'] = 'Default meta description';
$labels['meta_keywords'] = 'Default meta keywords';
$labels['webmaster'] = 'Webmaster email';
$labels['shorturl'] = 'Short URL';
$labels['fullurl'] = 'Full URL';
$labels['organizer'] = 'Organization\'s name';
$labels['mailingaddress'] = 'Mailing address';
$labels['member'] = 'Membership name';
$labels['member_abbreviation'] = 'Membership abbreviation';
$labels['tellafriendtext'] = 'Tell-a-friend text';
$labels['tellafriendurl'] = 'Tell-a-friend URL';
$labels['infoemail'] = 'Information email';
$labels['registration_message'] = 'Registration message';
$labels['registration_subject'] = 'Registration subject';
$labels['artistagreement'] = 'Artist agreement';
$labels['exhibitoragreement'] = 'Exhibitor agreement';
$labels['foodagreement'] = 'Food vendor agreement';
$labels['entertaineragreement'] = 'Entertainer agreement';
$labels['volunteerragreement'] = 'Volunteer agreement';
$labels['send_announcements_message'] = 'Announcements message';
$labels['send_approval_message'] = 'Approval message';
$labels['send_boothassignment_message'] = 'Booth assignment message';

$explanation = array();
$explanation['festival'] = 'Festival name without a leading "the"';
$explanation['thefestival'] = 'The festival name including a leading "The" (such as The Sample Festival)';
$explanation['pageheader'] = 'The text in the header of the web pages.';
$explanation['meta_description'] = 'Default meta description';
$explanation['meta_keywords'] = 'Default meta keywords';
$explanation['webmaster'] = 'Webmaster\'s email address';
$explanation['shorturl'] = 'The URL without the http:// portion (such as www.example.com) <strong>Without the ending slash (/)!</strong>';
$explanation['fullurl'] = 'The URL with the http:// portion (such as http://www.example.com) <strong>Without the ending slash (/)!</strong>';
$explanation['organizer'] = 'The sponoring organization\'s name, used in some emails and messages to applicants';
$explanation['mailingaddress'] = 'The sponoring organization\'s mailing address, pay by check option directs applicants to mail to this address.';
$explanation['member'] = 'The full name of member of your organization (such as SampleCity Merchants Association)';
$explanation['member_abbreviation'] = 'An abbreviated form the membership name (such as SMA)';
$explanation['tellafriendtext'] = '(Not implemented) Text to include in the Tell-a-friend pop-up box.';
$explanation['tellafriendurl'] = '(Not implemented) URL that will be appended to any Tell-a-friend messages. ';
$explanation['infoemail'] = 'Email address that applicants requesting more information will contact.';
$explanation['registration_message'] = 'Email text sent to an applicant after they are done and have submitted their applications.';
$explanation['registration_subject'] = 'Registration message subject line';
$explanation['artistagreement'] = 'The "I agree" text shown at the bottom of the application form for artist type applicants.';
$explanation['exhibitoragreement'] = 'The "I agree" text shown at the bottom of the application form for exhibitor type applicants.';
$explanation['foodagreement'] = 'The "I agree" text shown at the bottom of the application form for food vendor type applicants.';
$explanation['entertaineragreement'] = 'The "I agree" text shown at the bottom of the application form for entertainer type applicants.';
$explanation['volunteerragreement'] = 'The "I agree" text shown at the bottom of the application form for volunteers.';
$explanation['send_announcements_message'] = 'The stock, default, text shown in the Send Announcements email box in the Email&gt;Send Announcements administration page';
$explanation['send_approval_message'] = 'The stock, default, text shown in the Send Approved Email box in the Email&gt;Send Announcements administration page';
$explanation['send_boothassignment_message'] = 'The stock, default, text shown in the Send Booth Assignments email box in the Email&gt;Send Announcements administration page';

?>

<h2>Language Editor - General Language Strings</h2>
<?php
if(isset($_GET['success']) && $_GET['success'] == 'true') {
?>
<p style="color:#7E0922;background-color:#ffffcc;width:250px;padding:4px;border:1px solid #ddd;" id="configsaved"><strong>Language configuration saved.</strong>
<script type="text/javascript" language="javascript">
$().ready(function() {
	$('#configsaved').fadeOut(2500);
});
</script>
<?php } ?>

<p>Update the language strings that are used to display repeated information throughout your site.</p>

<form action="do_language.php" method="post">
<table class="stripeMe" cellspacing="0">
<tr>
	<td valign="middle" class="artisanApplicationTableHeader" colspan="3">Language variables</td>
</tr>
<tr>
<?php
foreach($lang as $lng => $val) {
?>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels[$lng];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top">
	<?php
	if(strlen($val) < 75) {
		echo '<input type="text" name="'.$lng.'" value="'.stripslashes($val).'" size="70"/>';
	} else {
		echo '<textarea name="'.$lng.'" rows="7" cols="75">'.stripslashes($val).'</textarea>';
	}
	?><br/>
	<p class="howto"><?php echo $explanation[$lng];?></p>
	</td>
</tr>
<?php
} // end foreach
?>
<tr>
	<td valign="middle"></td>
	<td valign="middle"><input type="submit" value="Submit"><input type="button" value="Cancel" style="font-weight:bold;" onClick="location='index.php';"></td>
	<td></td>
</tr>

</table>

</form>
<script type="text/javascript">
 $(document).ready(function(){
   $(".stripeMe tr").mouseover(function(){$(this).addClass("overrow");}).mouseout(function(){$(this).removeClass("overrow");});
   $(".stripeMe tr:even").addClass("oddrow");
 });
</script>


<?php 
include "includes/footer.php";
?>
