<?php 

require_once('../core/core.php');
if($_SESSION["roleID"] > $ent_edit) {
   header("Location:index.php");
}
$title = "ADMIN: Manage Artist Locations";
include "includes/header.php";
?>
<script type="text/javascript" language="javascript" src="../js/ajax.js"></script>
<script type="text/javascript" language="javascript" src="../js/unserialize.js"></script>
<script type="text/javascript" language="javascript">

// global variables for use in the various functions
locationID = '';
locationDescription = '';
locationCode = '';
sequence = '';

function stripslashes(str) {
	str=str.replace(/\\'/g,'\'');
	str=str.replace(/\\"/g,'"');
	str=str.replace(/\\\\/g,'\\');
	str=str.replace(/\\0/g,'\0');
	return str;
}
// create the ajax request object
var request = null;
function createRequest() {
	try {
	  request = new XMLHttpRequest();
	} catch (trymicrosoft) {
	  try {
		request = new ActiveXObject("Msxml2.XMLHTTP");
	  } catch (othermicrosoft) {
		try {
		  request = new ActiveXObject("Microsoft.XMLHTTP");
		} catch (failed) {
		  request = null;
		}
	  }
	}
} // end createRequest();

// get the sponsor details
function getLocation(locationID) {
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_locations_getdetails.php?locationID='+locationID;
	request.open('GET', url, true);
	request.onreadystatechange = updatePage;
	request.send(null);
} // end getLocation


function updatePage() {
	if(request.readyState==4) {
		// after a short pause, remove focus from the button and reset its text
		var arr = PHP_Unserialize(request.responseText);
//		alert(request.responseText);
		locationID = arr['locationID'];
		locationDescription = arr['locationDescription'];
		locationCode = arr['locationCode'];
		sequence = arr['sequence'];
		sponsorLevelID = arr['sponsorLevelID'];
		setTimeout("newDetails();", 150);
	}
} // end updatePage

function newDetails() {
	// update the page with the new details just retrieved from the server
	document.getElementById('frm_legend').innerHTML = "Edit";
	document.getElementById('frm_legend').style.fontWeight = "bold";
	document.getElementById('frm_location').style.backgroundColor = "#BBFFA8";
	document.getElementById('frm_location').locationID.value = locationID;
	document.getElementById('frm_location').locationDescription.value = stripslashes(locationDescription);
	document.getElementById('frm_location').locationCode.value = locationCode;
	document.getElementById('frm_location').sequence.value = sequence;
	document.getElementById('frm_location').frm_button.value = 'Edit';
	document.getElementById('frm_location').frm_button.onclick = function() { editLocation(document.getElementById("frm_location"));};

} // newDetails

function lookupSponsorLevelID(levelID) {
	// given a level ID determines the array position in the select list
	var opts = document.getElementById('frm_location').sponsorLevelID.options
	for (i=0; i < opts.length; i++) {
		if(levelID == opts[i].value) return i;
	}
} // end lookupSponsorLevelID

function editLocation(frm) {
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_locations_edit.php';
	request.open('POST', url, true);
	request.onreadystatechange = updatePagePostEdit;
	request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	postData = 
		"locationID="+frm.locationID.value +
		"&locationDescription="+escape(frm.locationDescription.value) +
		"&locationCode="+escape(frm.locationCode.value) +
		"&sequence="+escape(frm.sequence.value);
	request.send(postData);
} // end editLocation

function addLocation(frm) {
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_locations_add.php';
	request.open('POST', url, true);
	request.onreadystatechange = updatePagePostEdit;
	request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	postData = 
		"locationID="+frm.locationID.value +
		"&locationDescription="+escape(frm.locationDescription.value) +
		"&locationCode="+escape(frm.locationCode.value) +
		"&sequence="+escape(frm.sequence.value);
	request.send(postData);
} // end editLocation

function updatePagePostEdit() {
	if(request.readyState==4) {
		document.location.reload();
	}
} // end updatePagePostEdit

function deleteLocation(id) {
	document.getElementById('row'+id).style.backgroundColor = "#CC0000";
	var answer = confirm("Are you sure you want to delete this location?");
	if(answer == true) {
		doDeleteLocation(id);
	} else {
		document.getElementById('row'+id).style.backgroundColor = "#fff";
	}
} // end deleteSponsor

function doDeleteLocation(id) {
	document.getElementById('row'+id).style.backgroundColor = "#fff";
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_locations_delete.php';
	request.open('POST', url, true);
	request.onreadystatechange = updatePagePostEdit;
	request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	postData = 
		"locationID="+id;
	request.send(postData);
} // end doDeleteSponsor

</script>

<h1>Manage Artist Locations</h1>

<?php 
if(isset($_GET["errormsg"])) { 
  echo '<p class="error"><b>Problems:</b><br>'.stripslashes(urldecode($_GET["errormsg"])).'</p>';
} 
?>


<table cellspacing="0" class="stripeMe" cellpadding="3" width="90%">
<tr id="header">
  <td valign="top" class="tableheader"><strong>Description</strong></td>
  <td valign="top" class="tableheader"><strong>Abbreviation</strong></td>
  <td valign="top" class="tableheader"><strong>Sequence</strong></td>
  <td valign="top" class="tableheader">&nbsp;</td>
  <td valign="top" class="tableheader">&nbsp;</td>
</tr>


<?php
// query
$query = "SELECT locationID, locationCode, locationDescription, sequence FROM ".$config['dbprefix']."locations
		  ORDER BY sequence";
$result = $festos->query($query);



// output
while ($row = $result->fetch()) {
?>

<tr id="row<?php echo $row["locationID"];?>">
  <td class="smaller" valign="top"><?php echo stripslashes($row["locationDescription"]);?></td>
  <td class="smaller" valign="top"><?php echo $row["locationCode"];?></td>
  <td class="smaller" valign="top"><?php echo $row["sequence"];?></td>
  <td class="smaller" valign="top"><input type="button" value="Edit" onClick="getLocation(<?php echo $row["locationID"];?>)"></td>
  <td class="smaller" valign="top"><input type="button" value="Delete" onClick="deleteLocation(<?php echo $row["locationID"];?>)"></td>
</tr>

<?php
} // continue while loop

?>
</table>

<form style="margin-top:20px;" id="frm_location" name="frm_location">
<input type="hidden" name="locationID" value="">
<fieldset>
<legend id="frm_legend">Add</legend>
<table>
<tr>
	<td valign="top">Description</td>
	<td valign="top"><input type="text" name="locationDescription" size="40" value=""></td>
	<td valign="top"></td>
</tr>
<tr>
	<td valign="top">Abbreviation</td>
	<td valign="top"><input type="text" name="locationCode" size="10" value=""></td>
	<td valign="top"></td>
</tr>
<tr>
	<td valign="top">Sequence</td>
	<td valign="top"><input type="text" name="sequence" size="5" value="99"></td>
	<td valign="top"><input type="button" value="Add" onClick="addLocation(this.form);" style="margin-left:25px;" name="frm_button"></td>
</tr>



</table>

</fieldset>

</form>

<form style="margin-top:20px;display:none;" id="frm_location_delete" name="frm_location_delete">
<input type="hidden" name="locationID" value="">
<fieldset>
<legend id="frm_legend">Are you sure?</legend>
<p>Are you sure you want to delete this venue?</p>
<p id="location_delete_details"></p>
<input type="button" value="Yes, delete this location" onClick="deleteLocation(this.locationID);">
</fieldset>
</form>

<script type="text/javascript">
 $(document).ready(function(){
   $(".stripeMe tr").mouseover(function(){$(this).addClass("overrow");}).mouseout(function(){$(this).removeClass("overrow");});
   $(".stripeMe tr:even").addClass("oddrow");
 });
</script>



<?php 

include "includes/footer.php";
?>
