<?php 
$title = "ADMIN: Manage the Menu";
require_once('../core/core.php');
if($_SESSION["roleID"] > $ex_add) {
   header("Location:index.php");
}
include "includes/header.php";

/*
MENU MANAGER
- rearrangable list of pages
- links in nested ULs
	- URL (based on alias)
	- Menu text (page title)
	- Link title (also title of page)
- Drag and Drop
	- Side A: current menu in order
		- display: menu text, smaller text: alias
	- Side B: List of pages	
		- Lists built-in pages and active dynamic pages

- do_menu.php
	- accepts list of page IDs (need to figure out how to identify built-in pages)
	- creates unordered list from those IDs
	- write HTML to cache/menu.php
	- store to DB table
		menuID
		pageID
		parentID
		url
		title

FUTURE ENHANCEMENTS
	- NESTED LISTS - to support multi-level menus
		- use parentID field to build nested <ul>
	- MULTIPLE MENUS
		- do_menu.php will need to accept some sort of menu ID to edit the appropriate menu
		- mabye multiple cache/menu.php or a single such file that accepts menu IDs

*/


?>
<link rel="stylesheet" type="text/css" media="all" href="<?php echo $config['HTTP_PATH'];?>css/jqueryui_redmond/jquery-ui-1.7.2.custom.css"  />
<!-- core, slider, datepicker -->
<script type="text/javascript" src="<?php echo $config['HTTP_PATH'];?>js/jquery-ui-1.7.2.custom.min.js"></script>

<style type="text/css">
.pageCodeBlock {
	font-size:10px;
	display:none;
}
.homepagerow td { font-weight:bold; }
table.stripeMe { border-bottom:1px solid #8FA0BF;border-left:1px solid #8FA0BF; }
#rightContainer, #leftContainer {
	background-color:#B49E74;
	float:left;
	width:40%;
	margin-right:25px;
	border:1px solid #37558E;
	padding:4px;
}
#rightContainer h3, #leftContainer h3 {
	margin-left:25px;
}
#rightContainer ul, #leftContainer ul {
	padding:10px 2px 10px 20px;
	background-color:#C3CDDF;
	min-height:50px;
}
#rightContainer li, #leftContainer li {
	list-style: none;
	margin: 0 0 4px 0;
	padding: 5px;
	background-color:#DFD5C3;
	border: #37558E solid 1px;
	color:#000;
	width:90%;
	font-size:11px;
	cursor:move;
}
#btnSave, #btnAdd, #btnAddLink, #btnAddCancel {
	background-color:#37558E;
	border: #C3CDDF solid 1px;
	color:#C3CDDF;
	padding:3px;
	cursor:pointer;
}
#btnAdd { background-color:#38828F; }
#btnAddLink { background-color:#829ECE;color:#000; }
#btnAddCancel { background-color:CC877B; }
#btnSave:hover, #btnAdd:hover, #btnAddLink:hover, #btnAddCancel:hover {
	color:#fff;
	border: #fff solid 1px;
}
#addLink {
	width:350px;
	height:150px;
	border:2px solid #38828F;
	-webkit-border-radius: 8px; 
	-moz-border-radius: 8px;
	position:absolute;
	top:250px;
	left:250px;
	background-color:#E7D9C1;
	padding:4px;
	display:none;
}
</style>
<h1>Menu Manager</h1>
<p>Drag and drop to rearrange the menu presented to visitors to your site. Click Save to save your changes.</p>

<p style="color:#7E0922;background-color:#ffffcc;width:350px;padding:4px;border:1px solid #ddd;display:none;" id="menusaved"><strong>Menu changes saved</strong>

<?php 
if(isset($_GET["errormsg"])) { 
  echo '<p class="error"><b>Problems:</b><br>'.stripslashes(urldecode($_GET["errormsg"])).'</p>';
} 
?>

<?php
// build the list of static pages
$pagelist = array();
// $pagelist[pageID, parentID, alias w/extension, menu text, title text, isHomePage]
$pagelist += $stockPages;

// query
$pagequery = "SELECT pageID, parentID, title, alias, isHomePage 
	FROM ".$config['dbprefix']."pages
	WHERE active = 1
	ORDER BY title, pageID";
$pageresult = $festos->query($pagequery);
if($pageresult->size() > 0) {
	while($pagerow = $pageresult->fetch()) {
		$pID = (isset($pagerow['parentID'])) ? $pagerow['parentID'] : '';
		$pagelist[] = array(
			'pageID'=>$pagerow['pageID'], 
			'parentID'=>$pID, 
			'alias'=>$pagerow['alias'].'.html', 
			'menuText'=>$pagerow['title'], 
			'titleText'=>$pagerow['title'], 
			'isHomePage'=>$pagerow['isHomePage']
		);
	} // end while
} // end if($result->size() > 0)

asort($pagelist); 
?>


<div id="leftContainer">
<h3>Your menu</h3>
<ul class="connectedSortable" id="customMenu">
<?php
$menuQuery = "SELECT pageID, parentID, title, url, isHomePage 
	FROM ".$config['dbprefix']."menus
	WHERE menuID = 1
	ORDER BY sortorder";
$menuRes = $festos->query($menuQuery);
if($menuRes->size()>0) {
	while($menuRow = $menuRes->fetch()) {
		echo '<li id="'.$menuRow['pageID'].'">';
		if($menuRow['isHomePage']==1) {
			echo '<img src="images/home.png" align="absmiddle"> ';
		} else {
			echo '<img src="images/page.png" align="absmiddle"> ';
		}
		echo $menuRow['title'];
		if(ctype_digit($menuRow['pageID'])) {
			echo ' <span style="color:#37558E;">(dynamic)</span>';
		} else {
			echo ' <span style="color:#37558E;">(built-in)</span>';
		}
		echo '</li>';
	
	} // end while
} // end if($menuRes->size()>0)

?>
</ul>
<div align="center"><input type="button" value="Add Link" id="btnAdd" title="Add a Link to Another Site">&nbsp;::&nbsp;<input type="button" value="Save" id="btnSave" title="Save the Menu"></div>
</div>

<div id="rightContainer">
<h3>Available pages</h3>
<ul class="connectedSortable">
<?php
	foreach($pagelist as $pg) {
		echo '<li id="'.$pg['pageID'].'">';
		if($pg['isHomePage']==1) {
			echo '<img src="images/home.png" align="absmiddle"> ';
		} else {
			echo '<img src="images/page.png" align="absmiddle"> ';
		}
		echo $pg['menuText'];
		if(ctype_digit($pg['pageID'])) {
			echo ' <span style="color:#37558E;">(dynamic)</span>';
		} else {
			echo ' <span style="color:#37558E;">(built-in)</span>';
		}
		echo '</li>';
	} // end foreach
?>
</ul>
</div>

<div id="addLink">
<h4>Add a Link</h4>
<table>
<tr>
	<td>URL:</td><td><input type="text" id="addLink_URL" size="35"></td>
</tr>
<tr>
	<td>Menu Text:</td><td><input type="text" id="addLink_mText" size="35"></td>
</tr>
<tr>
	<td>Open Link In:</td><td><select id="addLink_target">
	<option selected value="_same">Same Window/Tab</option>
	<option value="_blank">New Window/Tab</option>
	<option value="_top">Top Frame</option>
</select></td>
</tr>
<tr>
<td></td>
<td><input type="button" value="Cancel" id="btnAddCancel" title="Cancel">&nbsp;::&nbsp;<input type="button" value="Add New Link" id="btnAddLink" title="Add the link to your menu"></td>
</tr>
</table>
</div>


<br clear="all"/>

<script type="text/javascript">
$('#btnSave').click(function () { 
	var order = $("#leftContainer ul").sortable("toArray");
	$.post("do_menu.php", {items:escape(order)}, function(theResponse){


				$().ready(function() {
					$('#menusaved').show();
					$('#menusaved').fadeOut(3500);
				});

//				alert(theResponse); // uncomment for debugging
			});
});
$('#btnAdd').click(function () { 
	$('#addLink').show('slow');
});
$('#btnAddCancel').click(function () { 
	$('#addLink').hide('slow');
});

$('#btnAddLink').click(function () { 
	id = 'zz'+escape($('#addLink_mText').val() + '|x|' + $('#addLink_URL').val()  + '|x|' + $('#addLink_target').val());
	$('#customMenu').append('<li id="'+id+'"><img align="absmiddle" src="images/page.png"/>'+$('#addLink_mText').val()+'</li>');
	$('#addLink').hide('slow');
});

</script>

<script type="text/javascript">
$(document).ready(function(){
	$("#rightContainer ul, #leftContainer ul").sortable({ opacity: 0.6, cursor: 'move', connectWith:'.connectedSortable'}).disableSelection();

});


</script>


<?php 
include "includes/footer.php";
?>
