<?php 
$title = "Payment Configuration";

require_once('../core/core.php');

include "includes/header.php";

$query = "SELECT * FROM ".$config['dbprefix']."payments WHERE paymentsID = 1";
$res = $festos->query($query);
$row = $res->fetch();
?>
<style>
.stripeMe td { padding-top:10px;padding-bottom:10px; }
</style>
<h1>General Payment Configuration</h1>
<p>Please configure the following general settings, which affect <em><strong>all</strong></em> payment modules that you have installed an enabled.</p>

<?php
if(isset($_GET['configsaved'])) {
?>
<p style="color:#7E0922;background-color:#ffffcc;width:250px;padding:4px;border:1px solid #ddd;" id="configsaved"><strong>Payment configuration information saved.</strong>
<script type="text/javascript" language="javascript">
$().ready(function() {
	$('#configsaved').fadeOut(2500);
});
</script>
<?php } ?>


<form method="post" action="do_paymentconfig.php">
<table cellspacing="0" class="stripeMe" cellpadding="3" width="90%">
<tr>
	<td width="33%" valign="top">Send emails to the <strong>administrator</strong> when a payment is made, declined, fails, etc.</td>
    <td width="66%" valign="top"><?php if($row['emailAdmin']==1) {
		echo '<input type="radio" value="1" name="emailAdmin" checked> Yes <input type="radio" value="0" name="emailAdmin"> No';
	} else {
		echo '<input type="radio" value="1" name="emailAdmin"> Yes <input type="radio" value="0" name="emailAdmin" checked> No';
	}
	?>
    </td>
</tr>
<tr>
	<td valign="top">Send emails to the <strong>applicant</strong> (artist/exhibitor/etc.) when a payment is made, declined, fails, etc.</td>
    <td valign="top"><?php if($row['emailApplicant']==1) {
		echo '<input type="radio" value="1" name="emailApplicant" checked> Yes <input type="radio" value="0" name="emailApplicant"> No';
	} else {
		echo '<input type="radio" value="1" name="emailApplicant"> Yes <input type="radio" value="0" name="emailApplicant" checked> No';
	}
	?>
    </td>
</tr>
<tr>
	<td valign="top">Send administrator payment emails to this email account:</td>
    <td valign="top"><input type="text" name="administratorsEmail" value="<?php
	if($row['administratorsEmail']=='') {
		echo $lang['webmaster'];
	} else {
		echo $row['administratorsEmail'];
	}
	?>" size="40"></td>
</tr>
<tr>
	<td valign="top">Administrator email text&dagger;:</td>
    <td valign="top"><textarea name="adminEmailText" rows="5" cols="50"><?php echo $row['adminEmailText'];?></textarea></td>
</tr>
<tr>
	<td valign="top">Applicant email text&dagger;:</td>
    <td valign="top"><textarea name="applicantEmailText" rows="5" cols="50"><?php echo $row['applicantEmailText'];?></textarea></td>
</tr>
<tr>
	<td></td>
    <td><input type="submit" value="Submit"></td>
</tr>
</table>
</form>

<p style="font-weight:bold;">Make sure you <a href="paymentmodules.php" title="Configure payment modules">configure the payment modules</a> themselves.</p>

<p class="howto" style="font-style:normal;"><strong>&dagger; Help Info</strong><ul type="circle">
<p class="howto" style="font-style:normal;">You can use the following field codes in your text, which will be replaced by the actual values when the email is sent:</p>
<ul>
<li class="howto" style="font-style:normal;"><strong>{FIRSTNAME}</strong> - The exhibitor's first name.</li>
<li class="howto" style="font-style:normal;"><strong>{LASTNAME}</strong> - The exhibitor's last name.</li>
<li class="howto" style="font-style:normal;"><strong>{ARTISAN}</strong> - The exhibitor's company name.</li>
<li class="howto" style="font-style:normal;"><strong>{EMAIL}</strong> - The exhibitor's email address.</li>
<li class="howto" style="font-style:normal;"><strong>{FESTIVALNAME}</strong> - Your festival's name, as set in the configuration pages.</li>
<li class="howto" style="font-style:normal;"><strong>{PAYMENTDATE}</strong> - The date and time of the transaction, according to the processor, if available.</li>
<li class="howto" style="font-style:normal;"><strong>{AMOUNT}</strong> - The amount they have paid.</li>
<li class="howto" style="font-style:normal;"><strong>{TRANSACTIONID}</strong> - An ID for the payment, if provided by the payment processor.</li>
<li class="howto" style="font-style:normal;"><strong>{PAYMENTPROCESSOR}</strong> - The payment processor used (Pay by check, PayPal, credit card, etc).</li>
</ul>


<script type="text/javascript">
 $(document).ready(function(){
   $(".stripeMe tr").mouseover(function(){$(this).addClass("overrow");}).mouseout(function(){$(this).removeClass("overrow");});
   $(".stripeMe tr:even").addClass("oddrow");
 });
</script>

<?php 
include "includes/footer.php";
?>
