<?php 
$title = "Language Editor - Photos";

require_once('../core/core.php');
require_once($config['ABSOLUTE_FILE_PATH'].'admin/includes/header.php');

$labels = array();
$labels['description'] = 'Instructions';
$labels['photo_1'] = 'Photo 1';
$labels['photo_2'] = 'Photo 2';
$labels['photo_3'] = 'Photo 3';
$labels['photo_4'] = 'Photo 4';

$explanation = array();
$explanation['description'] = 'Instructions and description presented to the applicant prior to the photo upload form fields.';
$explanation['photo_1'] = 'Description / requirements for what should be included in the first photo';
$explanation['photo_2'] = 'Description / requirements for what should be included in the second photo';
$explanation['photo_3'] = 'Description / requirements for what should be included in the third photo';
$explanation['photo_4'] = 'Description / requirements for what should be included in the fourth photo';

?>

<h2>Language Editor - Photo Language Strings</h2>
<?php
if(isset($_GET['success']) && $_GET['success'] == 'true') {
?>
<p style="color:#7E0922;background-color:#ffffcc;width:250px;padding:4px;border:1px solid #ddd;" id="configsaved"><strong>Language configuration saved.</strong>
<script type="text/javascript" language="javascript">
$().ready(function() {
	$('#configsaved').fadeOut(2500);
});
</script>
<?php } ?>

<p>Update the language strings that are used to display information about photo requirements for applicants.</p>

<form action="do_photolang.php" method="post">
<table class="stripeMe" cellspacing="0" cellpadding="3" width="600">
<tr>
	<td valign="middle" class="artisanApplicationTableHeader" colspan="2">Artist Applicants</td>
</tr>
<tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['description'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><textarea name="artist_description" rows="7" cols="75"><?php echo stripslashes($photolang[$config['ARTISTS_APPTYPID']][0]);?></textarea><br/>
	<p class="howto"><?php echo $explanation['description'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_1'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="artist_photo1" value="<?php echo stripslashes($photolang[$config['ARTISTS_APPTYPID']][1]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_1'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_2'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="artist_photo2" value="<?php echo stripslashes($photolang[$config['ARTISTS_APPTYPID']][2]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_2'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_3'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="artist_photo3" value="<?php echo stripslashes($photolang[$config['ARTISTS_APPTYPID']][3]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_3'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_4'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="artist_photo4" value="<?php echo stripslashes($photolang[$config['ARTISTS_APPTYPID']][4]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_4'];?></p>
	</td>
</tr>

<tr>
	<td valign="middle" class="artisanApplicationTableHeader" colspan="2">Exhibitor Applicants</td>
</tr>
<tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['description'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><textarea name="exhibitors_description" rows="7" cols="75"><?php echo stripslashes($photolang[$config['EXHIBITORS_APPTYPID']][0]);?></textarea><br/>
	<p class="howto"><?php echo $explanation['description'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_1'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="exhibitors_photo1" value="<?php echo stripslashes($photolang[$config['EXHIBITORS_APPTYPID']][1]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_1'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_2'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="exhibitors_photo2" value="<?php echo stripslashes($photolang[$config['EXHIBITORS_APPTYPID']][2]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_2'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_3'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="exhibitors_photo3" value="<?php echo stripslashes($photolang[$config['EXHIBITORS_APPTYPID']][3]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_3'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_4'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="exhibitors_photo4" value="<?php echo stripslashes($photolang[$config['EXHIBITORS_APPTYPID']][4]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_4'];?></p>
	</td>
</tr>

<tr>
	<td valign="middle" class="artisanApplicationTableHeader" colspan="2">Food Vendor Applicants</td>
</tr>
<tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['description'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><textarea name="food_description" rows="7" cols="75"><?php echo stripslashes($photolang[$config['FOODVENDORS_APPTYPID']][0]);?></textarea><br/>
	<p class="howto"><?php echo $explanation['description'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_1'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="food_photo1" value="<?php echo stripslashes($photolang[$config['FOODVENDORS_APPTYPID']][1]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_1'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_2'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="food_photo2" value="<?php echo stripslashes($photolang[$config['FOODVENDORS_APPTYPID']][2]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_2'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_3'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="food_photo3" value="<?php echo stripslashes($photolang[$config['FOODVENDORS_APPTYPID']][3]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_3'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_4'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="food_photo4" value="<?php echo stripslashes($photolang[$config['FOODVENDORS_APPTYPID']][4]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_4'];?></p>
	</td>
</tr>

<tr>
	<td valign="middle" class="artisanApplicationTableHeader" colspan="2">Entertainer Applicants</td>
</tr>
<tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['description'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><textarea name="entertainer_description" rows="7" cols="75"><?php echo stripslashes($photolang[$config['ENTERTAINERS_APPTYPID']][0]);?></textarea><br/>
	<p class="howto"><?php echo $explanation['description'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_1'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="entertainer_photo1" value="<?php echo stripslashes($photolang[$config['ENTERTAINERS_APPTYPID']][1]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_1'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_2'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="entertainer_photo2" value="<?php echo stripslashes($photolang[$config['ENTERTAINERS_APPTYPID']][2]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_2'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_3'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="entertainer_photo3" value="<?php echo stripslashes($photolang[$config['ENTERTAINERS_APPTYPID']][3]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_3'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_4'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="entertainer_photo4" value="<?php echo stripslashes($photolang[$config['ENTERTAINERS_APPTYPID']][4]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_4'];?></p>
	</td>
</tr>


<tr>
	<td valign="middle" class="artisanApplicationTableHeader" colspan="2">Volunteer Applicants</td>
</tr>
<tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['description'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><textarea name="volunteer_description" rows="7" cols="75"><?php echo stripslashes($photolang[$config['VOLUNTEERS_APPTYPID']][0]);?></textarea><br/>
	<p class="howto"><?php echo $explanation['description'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_1'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="volunteer_photo1" value="<?php echo stripslashes($photolang[$config['VOLUNTEERS_APPTYPID']][1]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_1'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_2'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="volunteer_photo2" value="<?php echo stripslashes($photolang[$config['VOLUNTEERS_APPTYPID']][2]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_2'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_3'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="volunteer_photo3" value="<?php echo stripslashes($photolang[$config['VOLUNTEERS_APPTYPID']][3]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_3'];?></p>
	</td>
</tr>
<tr>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><?php echo $labels['photo_4'];?></td>
	<td style="padding-bottom:10px;padding-top:2px;" valign="top"><input type="text" name="volunteer_photo4" value="<?php echo stripslashes($photolang[$config['VOLUNTEERS_APPTYPID']][4]);?>" size="80"/><br/>
	<p class="howto"><?php echo $explanation['photo_4'];?></p>
	</td>
</tr>


<tr>
	<td valign="middle"></td>
	<td valign="middle"><input type="submit" value="Submit"><input type="button" value="Cancel" style="font-weight:bold;" onClick="location='index.php';"></td>

</tr>

</table>

</form>
<script type="text/javascript">
 $(document).ready(function(){
   $(".stripeMe tr").mouseover(function(){$(this).addClass("overrow");}).mouseout(function(){$(this).removeClass("overrow");});
   $(".stripeMe tr:even").addClass("oddrow");
 });
</script>


<?php 
include "includes/footer.php";
?>
