<?php 
$title = "Booth Book Report";
require_once('../core/core.php');

$pt = new ParamTester($_GET, 'vTypeID','integer');  // type = integer, string, required, letters
$pt->go();

if($_SESSION["roleID"] > $slideshow) {
   header("Location:index.php");
}

include "includes/reportheader.php";

// Connect to db
function getImageTag($img) {
	global $config;
	$maxwidth = '450';
	$maxheight = '450';
	$imgProps = _checkSize($img, $maxwidth, $maxheight, '../vendorimages/');
	if($imgProps['oversized']==false) {
		echo '<img src="../vendorimages/'.$img.'" width="'.$imgProps['width'].'" height="'.$imgProps['height'].'" />';
	} else {
		$newImg = _resize($img, $imgProps, '../vendorimages/');
		echo '<img src="'.$config["HTTP_PATH"].'cache/'.$newImg['name'].'" width="'.$newImg['width'].'" height="'.$newImg['height'].'" />';
	}
}

function _checkSize($img, $maxwidth, $maxheight, $path) {
	$returnValue['oversized'] = false;
	list($width, $height) = getimagesize($path.$img);
	if($width > $maxwidth) { 
		$returnValue['oversized'] = true;
		$returnValue['toowide'] = true;
	}
	if($height > $maxheight) { 
		$returnValue['oversized'] = true;
		$returnValue['tootall'] = true;
	}
	$returnValue['width'] = $width;
	$returnValue['height'] = $height;
	$returnValue['maxwidth'] = $maxwidth;
	$returnValue['maxheight'] = $maxheight;
	return $returnValue;
}

function _resize($img, $imgProps, $path) {
	global $config;
	$returnValue = array();
	
	// get file extension
	$ext = explode('.',$img);
	$ext = $ext[count($ext)-1];
	
	$newWidth = $imgProps['width'];
	$newHeight = $imgProps['height'];

	$x_ratio = $imgProps['maxwidth'] / $imgProps['width'];
	$y_ratio = $imgProps['maxheight'] / $imgProps['height'];
	
	if( ($imgProps['width'] <= $imgProps['maxwidth']) && ($imgProps['height'] <= $imgProps['maxheight']) )
	{
		$newWidth = $imgProps['width'];
		$newHeight = $imgProps['height'];
	}
	elseif (($x_ratio * $imgProps['height']) < $imgProps['maxheight'])
	{
	   $newHeight = ceil($x_ratio * $imgProps['height']);
	   $newWidth = $imgProps['maxwidth'];
	}
	else
	{
	   $newWidth = ceil($y_ratio * $imgProps['width']);
	   $newHeight = $imgProps['maxheight'];
	}
	// Increase memory limit to support larger files
	
	ini_set('memory_limit', '32M');
	set_time_limit(1800);

	// now, create the new image
	$image_p = imagecreatetruecolor($newWidth, $newHeight); 
	if($ext=='gif'){
	   $image = imagecreatefromgif($path.$img);                           
	   imagecopyresampled($image_p, $image, 0, 0, 0, 0, $newWidth, $newHeight, $imgProps['width'], $imgProps['height']);
	   imagegif($image_p, $config['ABSOLUTE_FILE_PATH'].'cache/'.$img);
	} else {
	   $image = @imagecreatefromjpeg($path.$img);
	   if($image != '') {                           
		   imagecopyresampled($image_p, $image, 0, 0, 0, 0, $newWidth, $newHeight, $imgProps['width'], $imgProps['height']);
		   imagejpeg($image_p, $config['ABSOLUTE_FILE_PATH'].'cache/'.$img, 80);
		}
	} // end gif/jpg block
	
	@imagedestroy($image_p);
	@imagedestroy($thumb_p);
	@imagedestroy($image);	

	$returnValue['name'] = $img;
	$returnValue['width'] = $newWidth;
	$returnValue['height'] = $newHeight;
	return $returnValue;
}


?>
<style type="text/css">
<!--
body {margin:0;}
.vType { font-weight:bold;color:#7e0922;font-size:14px; }
.reportDetails tr td { font-size:9px;}
.reportDetails tr th { font-weight:bold;text-align:left;font-size:11px;background:#555;color:#fff; }
.reportDetails {background:#000;empty-cells:show;table-layout:auto;}
-->
</style>
<?php


  $q2 = 'SELECT vendorID, tracking, vendorName, lastname, firstname, photo1, photo2, photo3, photo4
         FROM '.$config['dbprefix'].'vendors
         WHERE vTypeID = '.$_GET['vTypeID'];
		 if(isset($_GET['testing'])) {
		 	$q2 .= ' AND approved = 0 ORDER BY vendorName LIMIT 0, 2';
		 } else {
		 	$q2 .= ' AND approved = 1 ORDER BY vendorName';
		 }
  $r2 = $festos->query($q2);
  $oddEven = 0;
  if($r2->size() > 0) {
  // if there's data to output, output it
  while ($row2 = $r2->fetch()) {
?>

<!--- OUTPUT HTML HERE --->
<h1><?php
if(stripslashes($row2['vendorName']) != '') {
	echo stripslashes($row2['vendorName']);
} else {
	echo stripslashes($row2['firstname']).' '.stripslashes($row2['lastname']);
}
?>
</h1>
<table border="0" cellpadding="3" cellspacing="0" style="page-break-after:always;">

<!-- HEADER ROW -->
<tr>
	<td valign="top" align="left" colspan="2"><h1 style="color:#666;"><?php echo ' <span style="color:#000;text-decoration:underline;padding-right:25px;">'.stripslashes($row2['vendorName']).'</span>';?></h1></td>
</tr>

<!-- TWO ROWS OF PHOTOS -->
<tr>
	<td valign="top" align="left">
	<?php
	if($row2['photo1'] != '' && file_exists('../vendorimages/'.$row2['photo1'])) {
		echo getImageTag($row2['photo1']);
	} else {
		echo '<img src="../'.$config["NO_IMAGE"].'" width="400" />';
	}
	?>
	</td>
	<td valign="top" align="left">
	<?php
	if($row2['photo2'] != '' && file_exists('../vendorimages/'.$row2['photo2'])) {
		echo getImageTag($row2['photo2']);
	} else {
		echo '<img src="../'.$config["NO_IMAGE"].'" width="400" />';
	}
	?>
	</td>
</tr>
<tr>
	<td valign="top" align="left">
	<?php
	if($row2['photo3'] != '' && file_exists('../vendorimages/'.$row2['photo2'])) {
		echo getImageTag($row2['photo3']);
	} else {
		echo '<img src="../'.$config["NO_IMAGE"].'" width="400" />';
	}
	?>
	</td>
	<td valign="top" align="left">
	<?php
	if($row2['photo4'] != '' && file_exists('../vendorimages/'.$row2['photo2'])) {
		echo getImageTag($row2['photo4']);
	} else {
		echo '<img src="../'.$config["NO_IMAGE"].'" width="400" />';
	}
	?>
	</td>
</tr>

<!-- ARTISAN DETAILS ROW -->
<tr>
	<td valign="top" align="left" colspan="2">
	<table cellpadding="3" cellspacing="0" border="1">
	<tr>
	  <td width="150"><strong>ID/Tracking #</strong></td>
	  <td width="375"><?php 
	  if($row2['tracking']=='') {
	  	echo $row2['vendorID'];
	  } else {
	    echo $row2['tracking'];
	  }
	  ?>&nbsp;</td>
	</tr>
	<tr>
	  <td><strong>Category:</strong></td>
	  <td><?php echo stripslashes(urldecode($_GET['vType']));?>&nbsp;</td>
	</tr>
	<tr>
	  <td><strong>Contact:</strong></td>
	  <td><?php echo stripslashes($row2['firstname']).' '.stripslashes($row2['lastname']);?>&nbsp;</td>
	</tr>
	<tr>
	  <td><strong>Booth Assignment:</strong></td>
	  <td><?php 
		$q3 = 'SELECT booth FROM '.$config['dbprefix'].'vendorlocations WHERE vendorID = '.$row2['vendorID'];
		$r3 = $festos->query($q3);
		if($r3->size() > 0) {
			while($row3 = $r3->fetch()) {
				echo $row3['booth']. ', ';
			}
	    }
	  ?>&nbsp;</td>
	</tr>
	</table>
	</td>
</tr>
</table>



<?php
flush();
} // continue the while loop

} else {
  // no data to output, so output a blank row
?>

<!--- OUTPUT HTML HERE --->
<p style="page-break-after:always;">No vendors in the <?php echo $row['vType']; ?> category</p>
<?php


} // end the if-rows-to-output block
echo '<p>&nbsp;</p>';

?>



<?php 
/*
FINALLY, DELETE ANY AND ALL FILES FROM THE admin/tmp_vendorimages DIRECTORY!!!!!
*/

foreach (glob($config['ABSOLUTE_FILE_PATH']."cache/*.jpg") as $filename) {
   @unlink($filename);
}	
foreach (glob($config['ABSOLUTE_FILE_PATH']."cache/*.JPG") as $filename) {
   @unlink($filename);
}	

include "includes/reportfooter.php";
?>
