<?php 

require_once('../core/core.php');
if($_SESSION["roleID"] > $reports) {
   header("Location:index.php");
}
$title = $lang['member_abbreviation']." Applicants Report";
include "includes/reportheader.php";

$pricesQuery = 'SELECT apptypeID, boothFee, extraBoothFee, appFee, lateFee, lateFeeDate, cornerBoothFee FROM '.$config['dbprefix'].'applicanttypes';
$pricesRes = $festos->query($pricesQuery);
while ($pricesRow = $pricesRes->fetch()) {
	$prices[$pricesRow['apptypeID']]['boothFee'] = $pricesRow['boothFee'];
	$prices[$pricesRow['apptypeID']]['extraBoothFee'] = $pricesRow['extraBoothFee'];
	$prices[$pricesRow['apptypeID']]['appFee'] = $pricesRow['appFee'];
	$prices[$pricesRow['apptypeID']]['lateFee'] = $pricesRow['lateFee'];
	$prices[$pricesRow['apptypeID']]['cornerBoothFee'] = $pricesRow['cornerBoothFee'];
	$prices[$pricesRow['apptypeID']]['lateFeeDate'] = $pricesRow['lateFeeDate'];
}


$apptypeQuery = 'SELECT apptypeID, apptypelabel FROM '.$config['dbprefix'].'applicanttypes';
$apptypeRes = $festos->query($apptypeQuery);
while ($apptypeRow = $apptypeRes->fetch()) {
	$appTypes[$apptypeRow['apptypeID']] = $apptypeRow['apptypelabel'];
}



$now = mktime();
$dateParts = getdate($now);
$thisYear = ($dateParts['mon']<9) ? ($dateParts['year']-1) : $dateParts['year'];
$currentYear = strtotime('September 01 '.$thisYear);

function calcTotal($apptypeID, $numBooths=1, $corner=0) {
	global $prices, $now;
	if($apptypeID == '' || $apptypeID == 0) $apptypeID = 1;

  	$total = 0; 
	if($now > $prices[$apptypeID]['lateFeeDate']) {
		$total = $prices[$apptypeID]['appFee']+$prices[$apptypeID]['lateFee'];
	} else {
		$total = $prices[$apptypeID]['appFee'];
	}
	$total += $prices[$apptypeID]['boothFee'];
	$total += (($numBooths-1) * $prices[$apptypeID]['extraBoothFee']);
	if($corner) $total += $prices[$apptypeID]['cornerBoothFee'];
	return $total;
}


?>
<style type="text/css">
<!--
body {margin:0;}
.vType { font-weight:bold;color:#7e0922;font-size:14px; }
.reportDetails tr td { font-size:9px;}
.reportDetails tr th { font-weight:bold;text-align:left;font-size:11px;background:#555;color:#fff; }
.reportDetails {background:#000;empty-cells:show;table-layout:auto;}
-->
</style>
<h1><?php echo $lang['member_abbreviation'];?> Applicants</h1>

<?php


// query
$query = 'SELECT vTypeID, vType
          FROM '.$config['dbprefix'].'vendortypes
          ORDER BY vType';

$res = $festos->query($query);
while ($row = $res->fetch()) {
echo '<div class="vType">'.$row['vType'].'</div>';
?>
<table class="reportDetails" cellspacing="0" border="1" cellpadding="2" width="100%">
<tr>
  <th>Business</th>
  <th>Name</th>
  <th>Booths</th>
  <th>Corner</th>
  <th>Retail/Home</th>
  <th>Total owed</th>
  <th>Appl. Type</th>
  <th>Appl. date</th>
</tr>
<?php
$orderby = (!isset($_GET['alpha'])) ? 'vendorName' : $_GET['alpha'];
  $q2 = 'SELECT vendorName, lastname, firstname, requestedBooths, corner, paidApplicationFee, paidBoothFee, appDate, fpma, fpma_retail, apptypeID
         FROM '.$config['dbprefix'].'vendors
         WHERE vTypeID = '.$row['vTypeID'].'
		 AND fpma = 1
		 AND appDate >= '.$currentYear.'
         ORDER BY '.$orderby;
	$r2 = $festos->query($q2);
	$oddEven = 0;
	if($r2->size() > 0) {
	// if there's data to output, output it
	while ($row2 = $r2->fetch()) {
	$bgcolor = '#ffffff';
	if($oddEven == 0) $bgcolor = '#dedede';
	if($row2['fpma']==1) $bgcolor = '#ffaa0b';
	echo '<tr bgcolor="'.$bgcolor.'">';
?>

<!--- OUTPUT HTML HERE --->
  <td><?php echo stripslashes($row2['vendorName']);?></td>
  <td><?php echo stripslashes($row2['lastname']).', '.stripslashes($row2['firstname']);?></td>
  <td><?php echo $row2['requestedBooths']?></td>
  <td><?php if($row2['corner']) echo 'Yes'; else echo 'No';?></td>
  <td><?php if($row2['fpma_retail']) echo 'Retail'; else echo 'Home-based';?></td>
  <td>$<?php echo number_format(calcTotal($row2['apptypeID'], $row2['requestedBooths'], $row2['corner']),2); ?></td>
  <td><?php echo ($row2['apptypeID'] != '') ? $appTypes[$row2['apptypeID']] : 'Artisan'; ?></td>
  <td><?php echo strftime($config["SHORT_DATE_FORMAT"], $row2['appDate']); ?></td>
</tr>

<?php
if($oddEven == 0) $oddEven = 1;
else $oddEven = 0;
} // continue the while loop

} else {
  // no data to output, so output a blank row
?>

<!--- OUTPUT HTML HERE --->
  <td colspan="9" style="background:#fff;">No vendors in this category</td>
</tr>

<?php


} // end the if-rows-to-output block
echo '</table><p>&nbsp;</p>';
} // continue the outer while loop

?>



<?php 
include "includes/reportfooter.php";
?>
