<?php 

require_once('../core/core.php');

$title = "ADMIN: Slideshow Report";
$festos->login();


/*
*   Create a where clause to select artists from current year (12/1/prev_year to current date)
*/
$whereclause = " AND ".$config['dbprefix']."vendors.vTypeID NOT IN (".$config['EXCLUDED_VENDOR_CATEGORIES'].")";
$scope = isset($_GET['scope']) ? $_GET['scope'] : 'unapproved';
$today = mktime();
$dateParts = getdate($today);
$lastYear = intval($year)-1;
$lastDecember = strtotime('12/01/'.$lastYear);
switch($scope) {
	case 'all':
	break;
	case 'current':
		$whereclause .= ' AND (appDate BETWEEN '.$lastDecember.' AND '.$today.')';
	break;
	case 'approved':
		$whereclause .= ' AND approved=1 AND (appDate BETWEEN '.$lastDecember.' AND '.$today.')';
	break;
	default:
	case 'unapproved':
		$whereclause .= ' AND approved=0 AND (appDate BETWEEN '.$lastDecember.' AND '.$today.')';
	break;
} // end switch
$whereclause .= ' AND fpma=0';


$idQuery = "SELECT vendorID, vendorName, firstname, lastname, vType, tracking FROM ".$config['dbprefix']."vendors, ".$config['dbprefix']."vendortypes WHERE ".$config['dbprefix']."vendors.vTypeID = ".$config['dbprefix']."vendortypes.vTypeID".$whereclause." ORDER BY  vType, vendorName";

$results = $festos->query($idQuery);
$numResults = $results->size();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Untitled Document</title>
	<link rel="stylesheet" href="css/jquery.treeview.css" />
    <link rel="stylesheet" href="css/red-treeview.css" />
	<link rel="stylesheet" href="css/screen.css" />
	<script src="includes/jquery.js" type="text/javascript"></script>

	<script src="includes/jquery.cookie.js" type="text/javascript"></script>
	<script src="includes/jquery.treeview.js" type="text/javascript"></script>
	<script type="text/javascript">
	$(document).ready(function(){
		
		$("#applicantlist").treeview( { collapsed:true});
		$("#add").click(function() {
			var branches = $("<li><span class='folder'>New Sublist</span><ul>" + 
				"<li><span class='file'>Item1</span></li>" + 
				"<li><span class='file'>Item2</span></li></ul></li>").appendTo("#browser");
			$("#browser").treeview({
				add: branches
			});
			branches = $("<li class='closed'><span class='folder'>New Sublist</span><ul><li><span class='file'>Item1</span></li><li><span class='file'>Item2</span></li></ul></li>").prependTo("#folder21");
			$("#browser").treeview({
				add: branches
			});
		});
	});
	</script>
	<style type="text/css">
		html, body {height:100%; margin: 0; padding: 0; }

		html>body {
			font-size: 16px; 
			font-size: 68.75%;
		} /* Reset Base Font Size */
		
		body {
			font-family: Verdana, helvetica, arial, sans-serif;
			font-size: 68.75%;
			background: #999;
			color: #333;
			padding-left: 20px;
		} /* Reset Font Size */

		.treeview, .treeview ul { 
			padding: 0;
			margin: 0;
			list-style: none;
		}	

		.treeview li { 
			margin: 0;
			padding: 3px 0pt 3px 16px;
		}
		
		ul.dir li { padding: 2px 0 0 16px; }
		
		
		a { color:#333; text-decoration:none; }
		a:hover { background-color:#FFFFCC; }

	</style>
</head>

<body>

<h1>Applicants</h1>
<p>Grouped by type, in order by application type (artists first, then exhibitors, food vendors, etc.)</p>
<?php 

if(isset($_GET['scope'])) {
	switch($_GET['scope']) {
		case 'approved':
			echo '<p>Approved Applicants</p>';
		break;
		case 'current':
			echo '<p>Applicants - current year</p>';
		break;
		case 'all':
			echo '<p>All Applicants</p>';
		break;
		case 'unapproved':
			echo '<p>Unapproved Applicants</p>';
		break;
	} // end switch
} else {
	echo '<p>Unapproved Applicants</p>';
}

if($numResults <= 0) {
	echo '<p class="smaller">No applicants meet your criteria.</p>';
} else {

$category = '';
//echo '<div id="treecontrol"><a href="#">Collapse All</a> :: <a href="#">Expand All</a></div>';
echo '<ul id="applicantlist">'."\n";
while($row = $results->fetch()) {
	$prevCategory = $category;
	$category = $row['vType'];
	if($category == $prevCategory) {
		// in the same category, so just output another LI
		echo "\t".'<li><a href="slideshow_right.php?vendorID='.$row['vendorID'].'" target="main">';
		if($config['JURIED']==0) {
			// NOT A JURIED SHOW, SO OUTPUT VENDOR NAME DETAILS
			if(trim($row['vendorName']) != '') {
				echo stripslashes($row['vendorName']);
			} else {
				echo stripslashes($row['firstname']).' '.stripslashes($row['lastname']);
			}
		} else {
			// JURIED SHOW, SO OUTPUT ID NUMBER ONLY
			echo 'Applicant: ';
			echo ($row['tracking']!='') ? $row['tracking'] : $row['vendorID'];
		} // END JURIED YES/NO BLOCK
		echo '</a></li>'."\n";
	} else {
		// starting a new category
		// close the previous UL
		if($prevCategory != '') echo "\t".'</ul></li>'."\n";
		// start a new one
		echo '<li class="treeview closed"><img src="../js/images/folder.gif" />'.stripslashes($category)."\n";
		echo "\t".'<ul>'."\n";
		// echo the current vendor
		echo "\t".'<li><a href="slideshow_right.php?vendorID='.$row['vendorID'].'" target="main">';
		if($config['JURIED']==0) {
			// NOT A JURIED SHOW, SO OUTPUT VENDOR NAME DETAILS
			if(trim($row['vendorName']) != '') {
				echo stripslashes($row['vendorName']);
			} else {
				echo stripslashes($row['firstname']).' '.stripslashes($row['lastname']);
			}
		} else {
			// JURIED SHOW, SO OUTPUT ID NUMBER ONLY
			echo 'Applicant: ';
			echo ($row['tracking']!='') ? $row['tracking'] : $row['vendorID'];
		} // END JURIED YES/NO BLOCK
		echo '</a></li>'."\n";
	} // end if($category == $prevCategory)
} // end while
echo "\t".'</ul></li>'."\n"; // gotta close the last UL
echo '</ul>'."\n"; // gotta close the last UL

} // end if($numResults <= 0) block


echo '<p>';
echo ($numResults) ? $numResults : '0';
echo ' applicants included in this report.</p>';

//echo '<p>'.$idQuery.'</p>';
?>




</body>
</html>
