<?php 
$title = "ADMIN: Manage Sponsor Levels";

require_once('../core/core.php');
if($_SESSION["roleID"] > $sponsor) {
   header("Location:index.php");
}
include "includes/header.php";
?>
<script type="text/javascript" language="javascript" src="../js/ajax.js"></script>
<script type="text/javascript" language="javascript" src="../js/unserialize.js"></script>
<script type="text/javascript" language="javascript">

// global variables for use in the various functions
sponsorLevelID = '';
sponsorLevel = '';
sponsorSortOrder = '';
sponsorAmount = '';

// create the ajax request object
var request = null;
function createRequest() {
	try {
	  request = new XMLHttpRequest();
	} catch (trymicrosoft) {
	  try {
		request = new ActiveXObject("Msxml2.XMLHTTP");
	  } catch (othermicrosoft) {
		try {
		  request = new ActiveXObject("Microsoft.XMLHTTP");
		} catch (failed) {
		  request = null;
		}
	  }
	}
} // end createRequest();

// get the sponsor details
function getSponsorLevel(sponID) {
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_sponsorlevel_getdetails.php?sponsorLevelID='+sponID;
	request.open('GET', url, true);
	request.onreadystatechange = updatePage;
	request.send(null);
} // end getSponsor


function updatePage() {
	if(request.readyState==4) {
		// after a short pause, remove focus FROM ".$config['dbprefix']."the button and reset its text
		var arr = PHP_Unserialize(request.responseText);
//		alert(request.responseText);
		sponsorLevelID = arr['sponsorLevelID'];
		sponsorLevel = arr['sponsorLevel'];
		sponsorSortOrder = arr['sponsorSortOrder'];
		sponsorAmount = arr['sponsorAmount'];
		setTimeout("newDetails();", 150);
	}
} // end updatePage

function newDetails() {
	// update the page with the new details just retrieved FROM ".$config['dbprefix']."the server
	document.getElementById('frm_legend').innerHTML = "Edit";
	document.getElementById('frm_legend').style.fontWeight = "bold";
	document.getElementById('frm_sponsor').style.backgroundColor = "#BBFFA8";
	document.getElementById('frm_sponsor').sponsorLevelID.value = sponsorLevelID;
	document.getElementById('frm_sponsor').sponsorLevel.value = sponsorLevel;
	document.getElementById('frm_sponsor').sponsorSortOrder.value = sponsorSortOrder;
	document.getElementById('frm_sponsor').sponsorAmount.value = sponsorAmount;
	document.getElementById('frm_sponsor').frm_button.value = 'Edit';
	document.getElementById('frm_sponsor').frm_button.onclick = function() { editSponsorLevel(document.getElementById("frm_sponsor"));};

} // newDetails

function editSponsorLevel(frm) {
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_sponsorlevel_edit.php';
	request.open('POST', url, true);
	request.onreadystatechange = updatePagePostEdit;
	request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	postData = 
		"sponsorLevelID="+frm.sponsorLevelID.value +
		"&sponsorLevel="+escape(frm.sponsorLevel.value) +
		"&sponsorAmount="+escape(frm.sponsorAmount.value) +
		"&sponsorSortOrder="+escape(frm.sponsorSortOrder.value);
	request.send(postData);
} // end editSponsor

function addSponsorLevel(frm) {
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_sponsorlevel_add.php';
	request.open('POST', url, true);
	request.onreadystatechange = updatePagePostEdit;
	request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	postData = 
		"sponsorLevel="+escape(frm.sponsorLevel.value) +
		"&sponsorAmount="+escape(frm.sponsorAmount.value) +
		"&sponsorSortOrder="+escape(frm.sponsorSortOrder.value);
	request.send(postData);
} // end editSponsor

function updatePagePostEdit() {
	if(request.readyState==4) {
		document.location.reload();
	}
} // end updatePagePostEdit

function deleteSponsorLevel(id) {
	document.getElementById('row'+id).style.backgroundColor = "#CC0000";
	var answer = confirm("Are you sure you want to delete this sponsor level?");
	if(answer == true) {
		doDeleteSponsorLevel(id);
	} else {
		document.getElementById('row'+id).style.backgroundColor = "#fff";
	}
} // end deleteSponsor

function doDeleteSponsorLevel(id) {
	document.getElementById('row'+id).style.backgroundColor = "#fff";
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_sponsorlevel_delete.php';
	request.open('POST', url, true);
	request.onreadystatechange = updatePagePostEdit;
	request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	postData = 
		"sponsorLevelID="+id;
	request.send(postData);
} // end doDeleteSponsor

</script>

<h1>Manage Sponsor Levels</h1>

<?php 
if(isset($_GET["errormsg"])) { 
  echo '<p class="error"><b>Problems:</b><br>'.stripslashes(urldecode($_GET["errormsg"])).'</p>';
} 
?>


<table cellpadding="4" cellspacing="0">
<?php
// query
$query = "SELECT sponsorLevelID, sponsorLevel, sponsorSortOrder, sponsorAmount FROM ".$config['dbprefix']."sponsorlevels
		  ORDER BY sponsorSortOrder";
$result = $festos->query($query);


// output
if($result->size()>0) {
?>

<tr id="header">
  <td class="smaller" valign="top" width="100"><strong>Level</strong></td>
  <td class="smaller" valign="top" width="100"><strong>Amount</strong></td>
  <td class="smaller" valign="top" width="100"><strong>Sort Order</strong></td>
  <td class="smaller" valign="top"> </td>
  <td class="smaller" valign="top"> </td>
</tr>
<?php
while ($row = $result->fetch()) {
?>

<tr id="row<?php echo $row["sponsorLevelID"];?>">
  <td class="smaller" valign="top" width="100"><?php echo $row["sponsorLevel"];?></td>
  <td class="smaller" valign="top" width="100"><?php echo '$'.number_format($row["sponsorAmount"]);?></td>
  <td class="smaller" valign="top" width="100"><?php echo $row["sponsorSortOrder"];?></td>
  <td class="smaller" valign="top"><input type="button" value="Edit" onClick="getSponsorLevel(<?php echo $row["sponsorLevelID"];?>)"></td>
  <td class="smaller" valign="top"><input type="button" value="Delete" onClick="deleteSponsorLevel(<?php echo $row["sponsorLevelID"];?>)"></td>
</tr>

<?php
} // continue while loop

} // end if()
?>
</table>

<form style="margin-top:20px;" id="frm_sponsor" name="frm_sponsor">
<input type="hidden" name="sponsorLevelID" value="">
<fieldset>
<legend id="frm_legend">Add</legend>
<table>
<tr>
	<td valign="top" width="125">Sponsor Level</td>
	<td valign="top"><input type="text" name="sponsorLevel" size="40" value=""></td>
	<td valign="top"></td>
</tr>
<tr>
	<td valign="top">Amount</td>
	<td valign="top"><input type="text" name="sponsorAmount" size="40" value=""><br /><span class="howto">Do not enter the $ dollar sign or commas</span></td>
	<td valign="top"></td>
</tr>
<tr>
	<td valign="top">Sort order</td>
	<td valign="top"><input type="text" name="sponsorSortOrder" size="4" value="">&nbsp;<span class="howto">Sponsor levels are sorted by this value, lowest numbers are shown first</span></td>
	<td valign="top"><input type="button" value="Add" onClick="addSponsorLevel(this.form);" style="margin-left:25px;" name="frm_button"> <input type="button" value="Reset" onClick="location.reload();"></td>
</tr>



</table>

</fieldset>

</form>

<form style="margin-top:20px;display:none;" id="frm_sponsor_delete" name="frm_sponsor_delete">
<input type="hidden" name="sponsorID" value="">
<fieldset>
<legend id="frm_legend">Are you sure?</legend>
<p>Are you sure you want to delete this sponsor?</p>
<p id="sponsor_delete_details"></p>
<input type="button" value="Yes, delete this sponsor" onClick="deleteSponsor(this.sponsorID);">
</fieldset>
</form>

<?php 

include "includes/footer.php";
?>
