<?php 
$title = "ADMIN: Manage Sponsors";

require_once('../core/core.php');
if($_SESSION["roleID"] > $sponsor) {
   header("Location:index.php");
}
include "includes/header.php";
?>
<script type="text/javascript" language="javascript" src="../js/ajax.js"></script>
<script type="text/javascript" language="javascript" src="../js/unserialize.js"></script>
<script type="text/javascript" language="javascript">

// global variables for use in the various functions
sponsorID = '';
sponsor = '';
website = '';
address = '';
address2 = '';
sponsorLevel = '';

// create the ajax request object
var request = null;
function createRequest() {
	try {
	  request = new XMLHttpRequest();
	} catch (trymicrosoft) {
	  try {
		request = new ActiveXObject("Msxml2.XMLHTTP");
	  } catch (othermicrosoft) {
		try {
		  request = new ActiveXObject("Microsoft.XMLHTTP");
		} catch (failed) {
		  request = null;
		}
	  }
	}
} // end createRequest();

// get the sponsor details
function getSponsor(sponID) {
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_sponsor_getdetails.php?sponsorID='+sponID;
	request.open('GET', url, true);
	request.onreadystatechange = updatePage;
	request.send(null);
} // end getSponsor


function updatePage() {
	if(request.readyState==4) {
		// after a short pause, remove focusFROM ".$config['dbprefix']."the button and reset its text
		var arr = PHP_Unserialize(request.responseText);
		sponsorID = arr['sponsorID'];
		sponsor = arr['sponsor'];
		website = arr['url'];
		address = arr['address'];
		address2 = arr['address2'];
		sponsorLevelID = arr['sponsorLevelID'];
		setTimeout("newDetails();", 150);
	}
} // end updatePage

function newDetails() {
	// update the page with the new details just retrievedFROM ".$config['dbprefix']."the server
	document.getElementById('frm_legend').innerHTML = "Edit";
	document.getElementById('frm_legend').style.fontWeight = "bold";
	document.getElementById('frm_sponsor').style.backgroundColor = "#BBFFA8";
	document.getElementById('frm_sponsor').sponsorID.value = sponsorID;
	document.getElementById('frm_sponsor').sponsor.value = sponsor;
	document.getElementById('frm_sponsor').url.value = website;
	document.getElementById('frm_sponsor').address.value = address;
	document.getElementById('frm_sponsor').address2.value = address2;
	document.getElementById('frm_sponsor').sponsorLevelID.options[lookupSponsorLevelID(sponsorLevelID)].selected = true;
	document.getElementById('frm_sponsor').frm_button.value = 'Edit';
	document.getElementById('frm_sponsor').frm_button.onclick = function() { editSponsor(document.getElementById("frm_sponsor"));};

} // newDetails

function lookupSponsorLevelID(levelID) {
	// given a level ID determines the array position in the select list
	var opts = document.getElementById('frm_sponsor').sponsorLevelID.options
	for (i=0; i < opts.length; i++) {
		if(levelID == opts[i].value) return i;
	}
} // end lookupSponsorLevelID

function editSponsor(frm) {
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_sponsor_edit.php';
	request.open('POST', url, true);
	request.onreadystatechange = updatePagePostEdit;
	request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	postData = 
		"sponsorID="+frm.sponsorID.value +
		"&sponsor="+escape(frm.sponsor.value) +
		"&sponsorLevelID="+escape(frm.sponsorLevelID.value) +
		"&url="+escape(frm.url.value) +
		"&address="+escape(frm.address.value) +
		"&address2="+escape(frm.address2.value);
	request.send(postData);
} // end editSponsor

function addSponsor(frm) {
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_sponsor_add.php';
	request.open('POST', url, true);
	request.onreadystatechange = updatePagePostEdit;
	request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	postData = 
		"sponsor="+escape(frm.sponsor.value) +
		"&sponsorLevelID="+escape(frm.sponsorLevelID.value) +
		"&url="+escape(frm.url.value) +
		"&address="+escape(frm.address.value) +
		"&address2="+escape(frm.address2.value);
	request.send(postData);
} // end editSponsor

function updatePagePostEdit() {
	if(request.readyState==4) {
		document.location.reload();
	}
} // end updatePagePostEdit

function deleteSponsor(id) {
	document.getElementById('row'+id).style.backgroundColor = "#CC0000";
	var answer = confirm("Are you sure you want to delete this sponsor?");
	if(answer == true) {
		doDeleteSponsor(id);
	} else {
		document.getElementById('row'+id).style.backgroundColor = "#fff";
	}
} // end deleteSponsor

function doDeleteSponsor(id) {
	document.getElementById('row'+id).style.backgroundColor = "#fff";
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_sponsor_delete.php';
	request.open('POST', url, true);
	request.onreadystatechange = updatePagePostEdit;
	request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	postData = 
		"sponsorID="+id;
	request.send(postData);
} // end doDeleteSponsor

</script>

<h1>Manage Sponsors</h1>

<?php 
if(isset($_GET["errormsg"])) { 
  echo '<p class="error"><b>Problems:</b><br>'.stripslashes(urldecode($_GET["errormsg"])).'</p>';
} 
?>


<table cellpadding="4" cellspacing="0">
<?php
// query
$query = "SELECT sponsor, sponsorID, sponsorLevel FROM ".$config['dbprefix']."sponsors, ".$config['dbprefix']."sponsorlevels
          WHERE ".$config['dbprefix']."sponsors.sponsorLevelID = ".$config['dbprefix']."sponsorlevels.sponsorLevelID
		  ORDER BY ".$config['dbprefix']."sponsors.sponsorID";
$result = $festos->query($query);

$levelsquery = "SELECT sponsorLevelID, sponsorLevel FROM ".$config['dbprefix']."sponsorlevels ORDER BY sponsorSortOrder";
$levelsresult = $festos->query($levelsquery);


// output
while ($row = $result->fetch()) {
?>

<tr id="row<?php echo $row["sponsorID"];?>">
  <td class="smaller" valign="top"><?php echo $row["sponsor"];?></td>
  <td class="smaller" valign="top"><?php echo $row["sponsorLevel"];?></td>
  <td class="smaller" valign="top"><input type="button" value="Edit" onClick="getSponsor(<?php echo $row["sponsorID"];?>)"></td>
  <td class="smaller" valign="top"><input type="button" value="Delete" onClick="deleteSponsor(<?php echo $row["sponsorID"];?>)"></td>
</tr>

<?php
} // continue while loop

?>
</table>

<form style="margin-top:20px;" id="frm_sponsor" name="frm_sponsor">
<input type="hidden" name="sponsorID" value="">
<fieldset>
<legend id="frm_legend">Add</legend>
<table>
<tr>
	<td valign="top">Sponsor</td>
	<td valign="top"><input type="text" name="sponsor" size="40" value=""></td>
	<td valign="top"></td>
</tr>
<tr>
	<td valign="top">Web site</td>
	<td valign="top"><input type="text" name="url" size="40" value=""></td>
	<td valign="top"></td>
</tr>
<tr>
	<td valign="top">Address</td>
	<td valign="top"><input type="text" name="address" size="40" value=""></td>
	<td valign="top"></td>
</tr>
<tr>
	<td valign="top">Address 2</td>
	<td valign="top"><input type="text" name="address2" size="40" value=""></td>
	<td valign="top"></td>
</tr>
<tr>
	<td valign="top">Sponsorship</td>
	<td valign="top"><select name="sponsorLevelID" style="width:250px;">
	<?php
	while ($levelsrow = $levelsresult->fetch()) {
		echo '<option value="'.$levelsrow['sponsorLevelID'].'">'.$levelsrow['sponsorLevel'].'</option>';
	} // end while
	?>
	</select></td>
	<td valign="top"><input type="button" value="Add" onClick="addSponsor(this.form);" style="margin-left:25px;" name="frm_button"> <input type="button" value="Reset" onClick="location.reload();"></td>
</tr>



</table>

</fieldset>

</form>

<form style="margin-top:20px;display:none;" id="frm_sponsor_delete" name="frm_sponsor_delete">
<input type="hidden" name="sponsorID" value="">
<fieldset>
<legend id="frm_legend">Are you sure?</legend>
<p>Are you sure you want to delete this sponsor?</p>
<p id="sponsor_delete_details"></p>
<input type="button" value="Yes, delete this sponsor" onClick="deleteSponsor(this.sponsorID);">
</fieldset>
</form>

<?php 

include "includes/footer.php";
?>
