<?php 

require_once('../core/core.php');
if($_SESSION["roleID"] > $ent_edit) {
   header("Location:index.php");
}
$title = "ADMIN: Manage Venues";
include "includes/header.php";
?>
<script type="text/javascript" language="javascript" src="../js/ajax.js"></script>
<script type="text/javascript" language="javascript" src="../js/unserialize.js"></script>
<script type="text/javascript" language="javascript">

// global variables for use in the various functions
venueID = '';
venue = '';
venueAbbreviation = '';
sequence = '';

function stripslashes(str) {
	str=str.replace(/\\'/g,'\'');
	str=str.replace(/\\"/g,'"');
	str=str.replace(/\\\\/g,'\\');
	str=str.replace(/\\0/g,'\0');
	return str;
}
// create the ajax request object
var request = null;
function createRequest() {
	try {
	  request = new XMLHttpRequest();
	} catch (trymicrosoft) {
	  try {
		request = new ActiveXObject("Msxml2.XMLHTTP");
	  } catch (othermicrosoft) {
		try {
		  request = new ActiveXObject("Microsoft.XMLHTTP");
		} catch (failed) {
		  request = null;
		}
	  }
	}
} // end createRequest();

// get the sponsor details
function getLocation(venueID) {
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_venues_getdetails.php?venueID='+venueID;
	request.open('GET', url, true);
	request.onreadystatechange = updatePage;
	request.send(null);
} // end getLocation


function updatePage() {
	if(request.readyState==4) {
		// after a short pause, remove focus from the button and reset its text
		var arr = PHP_Unserialize(request.responseText);
//		alert(request.responseText);
		venueID = arr['venueID'];
		venue = arr['venue'];
		venueAbbreviation = arr['venueAbbreviation'];
		sequence = arr['sequence'];
		sponsorLevelID = arr['sponsorLevelID'];
		setTimeout("newDetails();", 150);
	}
} // end updatePage

function newDetails() {
	// update the page with the new details just retrieved from the server
	document.getElementById('frm_legend').innerHTML = "Edit";
	document.getElementById('frm_legend').style.fontWeight = "bold";
	document.getElementById('frm_location').style.backgroundColor = "#BBFFA8";
	document.getElementById('frm_location').venueID.value = venueID;
	document.getElementById('frm_location').venue.value = stripslashes(venue);
	document.getElementById('frm_location').venueAbbreviation.value = venueAbbreviation;
	document.getElementById('frm_location').sequence.value = sequence;
	document.getElementById('frm_location').frm_button.value = 'Edit';
	document.getElementById('frm_location').frm_button.onclick = function() { editLocation(document.getElementById("frm_location"));};

} // newDetails

function lookupSponsorLevelID(levelID) {
	// given a level ID determines the array position in the select list
	var opts = document.getElementById('frm_location').sponsorLevelID.options
	for (i=0; i < opts.length; i++) {
		if(levelID == opts[i].value) return i;
	}
} // end lookupSponsorLevelID

function editLocation(frm) {
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_venues_edit.php';
	request.open('POST', url, true);
	request.onreadystatechange = updatePagePostEdit;
	request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	postData = 
		"venueID="+frm.venueID.value +
		"&venue="+escape(frm.venue.value) +
		"&venueAbbreviation="+escape(frm.venueAbbreviation.value) +
		"&sequence="+escape(frm.sequence.value);
	request.send(postData);
} // end editLocation

function addLocation(frm) {
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_venues_add.php';
	request.open('POST', url, true);
	request.onreadystatechange = updatePagePostEdit;
	request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	postData = 
		"venueID="+frm.venueID.value +
		"&venue="+escape(frm.venue.value) +
		"&venueAbbreviation="+escape(frm.venueAbbreviation.value) +
		"&sequence="+escape(frm.sequence.value);
	request.send(postData);
} // end editLocation

function updatePagePostEdit() {
	if(request.readyState==4) {
		if(request.responseText=='err_zero_venues') alert('You must have at least one venue and cannot delete the only one in the system.');
		document.location.reload();
	}
} // end updatePagePostEdit

function deleteLocation(id) {
	document.getElementById('row'+id).style.backgroundColor = "#CC0000";
	var answer = confirm("Are you sure you want to delete this venue? Any events assigned to this venue will be re-assigned to the lowest-numbered venue in your system.");
	if(answer == true) {
		doDeleteLocation(id);
	} else {
		document.getElementById('row'+id).style.backgroundColor = "#fff";
	}
} // end deleteSponsor

function doDeleteLocation(id) {
	document.getElementById('row'+id).style.backgroundColor = "#fff";
	createRequest();
	if(request==null) alert('Error creating request object!');
	var url= 'do_venues_delete.php';
	request.open('POST', url, true);
	request.onreadystatechange = updatePagePostEdit;
	request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	postData = 
		"venueID="+id;
	request.send(postData);
} // end doDeleteSponsor

</script>

<h1>Manage Venues</h1>
<p><a href="ent_manage.php" title="Manage events">Manage events</a></p>
<?php 
if(isset($_GET["errormsg"])) { 
  echo '<p class="error"><b>Problems:</b><br>'.stripslashes(urldecode($_GET["errormsg"])).'</p>';
} 
?>


<table cellspacing="0" class="stripeMe" cellpadding="3" width="90%">
<tr id="header">
  <td valign="top" class="tableheader"><strong>Venue</strong></td>
  <td valign="top" class="tableheader"><strong>Abbreviation</strong></td>
  <td valign="top" class="tableheader"><strong>Sequence</strong></td>
  <td valign="top" class="tableheader">&nbsp;</td>
  <td valign="top" class="tableheader">&nbsp;</td>
</tr>


<?php
// query
$query = "SELECT venueID, venueAbbreviation, venue, sequence FROM ".$config['dbprefix']."venues
		  ORDER BY sequence";
$result = $festos->query($query);



// output
while ($row = $result->fetch()) {
?>

<tr id="row<?php echo $row["venueID"];?>">
  <td class="smaller" valign="top"><?php echo stripslashes($row["venue"]);?></td>
  <td class="smaller" valign="top"><?php echo $row["venueAbbreviation"];?></td>
  <td class="smaller" valign="top"><?php echo $row["sequence"];?></td>
  <td class="smaller" valign="top"><input type="button" value="Edit" onClick="getLocation(<?php echo $row["venueID"];?>)"></td>
  <td class="smaller" valign="top"><input type="button" value="Delete" onClick="deleteLocation(<?php echo $row["venueID"];?>)"></td>
</tr>

<?php
} // continue while loop

?>
</table>

<form style="margin-top:20px;" id="frm_location" name="frm_location">
<input type="hidden" name="venueID" value="">
<fieldset>
<legend id="frm_legend">Add</legend>
<table>
<tr>
	<td valign="top">Venue</td>
	<td valign="top"><input type="text" name="venue" size="40" value=""></td>
	<td valign="top"></td>
</tr>
<tr>
	<td valign="top">Abbreviation</td>
	<td valign="top"><input type="text" name="venueAbbreviation" size="10" value=""></td>
	<td valign="top"></td>
</tr>
<tr>
	<td valign="top">Sequence</td>
	<td valign="top"><input type="text" name="sequence" size="5" value="99"></td>
	<td valign="top"><input type="button" value="Add" onClick="addLocation(this.form);" style="margin-left:25px;" name="frm_button"></td>
</tr>



</table>

</fieldset>

</form>

<form style="margin-top:20px;display:none;" id="frm_location_delete" name="frm_location_delete">
<input type="hidden" name="venueID" value="">
<fieldset>
<legend id="frm_legend">Are you sure?</legend>
<p>Are you sure you want to delete this venue?</p>
<p id="location_delete_details"></p>
<input type="button" value="Yes, delete this venue" onClick="deleteLocation(this.venueID);">
</fieldset>
</form>

<script type="text/javascript">
 $(document).ready(function(){
   $(".stripeMe tr").mouseover(function(){$(this).addClass("overrow");}).mouseout(function(){$(this).removeClass("overrow");});
   $(".stripeMe tr:even").addClass("oddrow");
 });
</script>



<?php 

include "includes/footer.php";
?>
