<?php
@session_start();

/* **************************************************
Copyright (c) 2008, Skypanther(r) Studios, Inc.
Skypanther(r) is a registered trademark of Skypanther Studios, Inc. 
************************************************** */


/* INCLUDE THE REQUIRED PARENT CLASS  */
require_once($config['ABSOLUTE_FILE_PATH'].'core/DB.php');
class Applicant extends DB {
	// properties
	var $config;
	var $lang;
	var $host;
	var $dbUser;
	var $dbPass;
	var $dbName;
	var $dbPrefix;
	var $errorMsg;
	var $filepath;
	var $auto_logout;
	var $loggedIn;
	var $id;
	var $email;

	function Applicant($config, $autoLogin = false) {
		$this->lang = &$GLOBALS['lang'];
		$this->config = &$GLOBALS['config'];
        $this->host=&$config['dbserver'];
        $this->dbUser=&$config['dbuser'];
        $this->dbPass=&$config['dbpassword'];
        $this->dbName=&$config['dbname'];
        $this->dbPrefix=&$config['dbprefix'];
		$this->errorMsg='';
		$this->filepath = &$config['ABSOLUTE_FILE_PATH'];
		$this->auto_logout = &$config['AUTO_LOGOUT'];
		$this->connectToDb();
		$this->loggedIn = false;
		$this->id;
		$this->email;
		if($autoLogin) {
			$this->login();
		}
	} // end constructor	
	
	/**
    * Logs the user in
    * @access public
    * @return void
	*/
	function login($redir='apply_loginform.tpl') {
		if(!isset($_SESSION['aplogin']) || $_SESSION['aplogin'] != 'TRUE' || $_SESSION['aplogin'] != TRUE) {
			$this->logout($redir);
		} else if($this->auto_logout !== FALSE && (time() - $_SESSION['aptimeout'] < $this->auto_logout) ) {
			// sessions time out after XXX seconds, less than that and
			// we reset the clock to keep folks logged in
			$_SESSION['aptimeout'] = time();
			$_SESSION['aplogin'] = 'TRUE';
			$this->id = (!isset($_SESSION['apid']) || $_SESSION['apid']=='' || $_SESSION['apid']== NULL) ? $_SESSION['uID'] : $_SESSION['apid'];
			$this->loggedIn = true;
		} else {
			$this->logout($redir);
		}
	} // end login()
	
	/**
    * Logs out the current session
	* @param redir - url of page to redirect to after function runs, default = login.php
    * @access public
    * @return void, but redirects to fixed page
	*/
	function logout($redir='apply_loginform.tpl') {
		if($redir === false) {
			return;
		} else {
			$_SESSION['aplogin'] = 'FALSE';
			$_SESSION['aptimeout'] = 9999999999999999999999;
			session_destroy();
			$this->loggedIn = false;
			require_once('core/Template.php');
			$tpl = & new Template();
			$tpl->set('thispage', $_SERVER['PHP_SELF']);
			$tpl->set('querystring',urlencode(passTheQueryString($_GET)));
			$tpl->set('config',$this->config);
			echo $tpl->fetch('templates/apply_loginform.tpl');
		}
	} // end logout()
	
	function isLoggedIn() {
		// getter method for loggedIn property
		if(isset($_SESSION['aplogin'])) {
			return $_SESSION['aplogin']; // $this->loggedIn;
		} else {
			return false;
		}
	}

	/**
    * Checks to see if the user is logged in
    * @access public
    * @return void
	*/
	function checklogin() {
		if($this->isLoggedIn()) {
			if($this->auto_logout !== FALSE && (time() - $_SESSION['aptimeout'] < $this->auto_logout) ) {
				// sessions time out after XXX seconds, less than that and
				// we reset the clock to keep folks logged in
				$_SESSION['aptimeout'] = time();
				$_SESSION['aplogin'] = 'TRUE';
				$this->id = (!isset($_SESSION['apid']) || $_SESSION['apid']=='' || $_SESSION['apid']== NULL) ? $_SESSION['vID'] : $_SESSION['apid'];
				$this->loggedIn = true;
			} else {
				$this->logout('login.php?reason=timeout');
			}
		}
	} // end checklogin()

} // end class declaration
?>