<?php
/**
* @package SKYPANTHER
* @version $Id:Auth.php, v1.0 2006/02/08 tim Exp $
*
* Provides for user authentication
* 
*/

class Auth {
	var $id;

	/**
	* Constructor function
	* @param autoLogin, if true, login method called which sends user to login page
    * @access public
    * @return void
	*/
	function Auth($autoLogin = TRUE) {
		@session_start();
		if(isset($_SESSION['auto_logout'])) {
			$this->auto_logout = $_SESSION['auto_logout']; 
		} else {
			$this->auto_logout = 1200;  // default log out is 10 mins if not set in session vars
		}
		if($autoLogin) $this->login();
	} // end constructor
	
	/**
    * Logs the user in
    * @access public
    * @return void
	*/
	function login($redir='login.php') {
		if(!isset($_SESSION['splogin']) || $_SESSION['splogin'] != 'TRUE') {
			header('Location:http://'.$_SERVER['HTTP_HOST'].rtrim(dirname($_SERVER['PHP_SELF']),'\\').'/'.$redir);
			die();
		} 
		if(time() - $_SESSION['sptimeout'] < $this->auto_logout ) {
			// sessions time out after 10 minutes, less than that and
			// we reset the clock to keep folks logged in
			$_session['sptimeout'] = time();
			$this->id = (!isset($_SESSION['vendorID']) || $_SESSION['vendorID']=='' || $_SESSION['vendorID']== NULL) ? $_SESSION['vID'] : $_SESSION['vendorID'];
		} else {
			$this->logout('login.php?reason=timeout');
		}
	} // end login()
	
	/**
    * Logs out the current session
	* @param redir - url of page to redirect to after function runs, default = login.php
    * @access public
    * @return void, but redirects to fixed page
	*/
	function logout($redir='login.php?reason=logout') {
		$_SESSION['splogin'] = 'FALSE';
		$_SESSION['sptimeout'] = 9999999999999999999999;
		$_SESSION['fpma'] = 0;
		session_destroy();
		header('Location:http://'.$_SERVER['HTTP_HOST'].rtrim(dirname($_SERVER['PHP_SELF']),'\\').'/'.$redir);
		die();
	} // end logout()

} // end class
?>