<?php
/* **************************************************
Copyright (c) 2008, Skypanther(r) Studios, Inc.
Skypanther(r) is a registered trademark of Skypanther Studios, Inc. 
************************************************** */

/**
* Database Connection Class
* @version $Id: DB.php,v 1.0 2008/01/16 skypanther Exp $
* @access public
* @package SPLIB
*
* SPECIFIC TO MYSQL, REPLACE AS NEEDED WITH OTHER DATABASE LAYER
*/
class DB {
    /**
    * Database server hostname
    * @access private
    * @var string
    */
    var $host;

    /**
    * Database username
    * @access private
    * @var string
    */
    var $dbUser;

    /**
    * Database user's password
    * @access private
    * @var string
    */
    var $dbPass;

    /**
    * Name of database to use
    * @access private
    * @var string
    */
    var $dbName;

    /**
    * Database Resource link identifier stored here
    * @access private
    * @var string
    */
    var $dbConn;

    /**
    * True/false error switch
    * @access private
    * @var Boolean
    */
    var $connectError;

    /**
    * Stores error messages
    * @access private
    * @var string
    */
    var $errorMsg;

    /**
    * DB constructor
    * @param string host
    * @param string dbUser
    * @param string dbPass
    * @param string dbName
    * @access public
    */
    function DB ($host,$dbUser,$dbPass,$dbName) {
        $this->host=$host;
        $this->dbUser=$dbUser;
        $this->dbPass=$dbPass;
        $this->dbName=$dbName;
		$this->errorMsg='';
        $this->connectToDb();
		$this->rawResult;
    }

    /**
    * Establishes connection to MySQL and selects a database
    * @return void
    * @access private
    */
    function connectToDb () {
        // Make connection to MySQL server
        if (!$this->dbConn = @mysql_connect($this->host,
                                      $this->dbUser,
                                      $this->dbPass)) {
            $this->connectError=true;
			$this->errorMsg .= 'Could not connect to server';
        // Select database
        } else if ( !@mysql_select_db($this->dbName,$this->dbConn) ) {
            $this->connectError=true;
			$this->errorMsg .= 'Could not select database';
        }
    }

    /**
    * Checks for MySQL errors
    * @return boolean
    * @access public
    */
    function isError () {
        if ( $this->connectError )
            return true;
        $this->errorMsg .= mysql_error ($this->dbConn);
        if ( empty ($error) )
            return false;
        else
            return true;
    }

    /**
    * Returns an instance of MySQLResult to fetch rows with
    * @param $sql string the database query to run
    * @return MySQLResult
    * @access public
    */
    function query($sql) {
        if (!$queryResource=mysql_query($sql,$this->dbConn))
            $this->errorMsg .= ('Query failed: '.mysql_error($this->dbConn).'<br /> SQL: '.$sql);
		$this->rawResult = $queryResource;
        return new DBResult($this,$queryResource);
    }
}

/**
* MySQLResult Data Fetching Class
* @access public
* @package SPLIB
*/
class DBResult {
    /**
    * Instance of MySQL providing database connection
    * @access private
    * @var MySQL
    */
    var $mysql;

    /**
    * Query resource
    * @access private
    * @var resource
    */
    var $query;

    /**
    * MySQLResult constructor
    * @param object mysql   (instance of MySQL class)
    * @param resource query (MySQL query resource)
    * @access public
    */
    function DBResult(&$db,$query) {
        $this->db=& $db;
        $this->query=$query;
    }

    /**
    * Fetches a rowFROM ".$config['dbprefix']."the result
    * @return array
    * @access public
    */
    function fetch () {
        if ( $row=mysql_fetch_array($this->query,MYSQL_ASSOC) ) {
            return $row;
        } else if ( $this->size() > 0 ) {
            mysql_data_seek($this->query,0);
            return false;
        } else {
            return false;
        }
    }

    /**
    * Returns the number of rows selected
    * @return int
    * @access public
    */
    function size () {
        return mysql_num_rows($this->query);
    }

    /**
    * Returns the number of rows affected by a DELETE, INSERT, REPLACE, or UPDATE statement
    * @return int
    * @access public
    */
    function affected () {
        return mysql_affected_rows($this->db->dbConn);
    }

    /**
    * Returns the ID of the last row inserted
    * @return int
    * @access public
    */
    function insertID () {
        return mysql_insert_id($this->db->dbConn);
    }
    
    /**
    * Checks for MySQL errors
    * @return boolean
    * @access public
    */
    function isError () {
        return $this->db->isError();
    }
}
?>