<?php
/* **************************************************
Copyright (c) 2008, Skypanther(r) Studios, Inc.
Skypanther(r) is a registered trademark of Skypanther Studios, Inc. 
************************************************** */

/**
* @package SKYPANTHER
* @version $Id: DBServerConnection.php,v 1.0 2006/01/11 15:30:00 tim Exp $
* @author Tim Poulsen, Skypanther Studios
*/
/**
* Database Server Connector Class - Connects to server but does not select DB
* @access public
*/
class DBServerConnection {
    /**
    * MySQL server hostname
    * @access private
    * @var string
    */
    var $host;

    /**
    * MySQL username
    * @access private
    * @var string
    */
    var $dbUser;

    /**
    * MySQL user's password
    * @access private
    * @var string
    */
    var $dbPass;

    /**
    * MySQL Resource link identifier stored here
    * @access public
    * @var string
    */
    var $dbConn;

    /**
    * Stores error messages for connection errors
    * @access public
    * @var string
    */
    var $connectError;

    /**
    * DBServerConnection constructor
    * @param string host (MySQL server hostname)
    * @param string dbUser (MySQL User Name)
    * @param string dbPass (MySQL User Password)
    * @param string dbName (Database to select)
    * @access public
    */
    function DBServerConnection ($host,$dbUser,$dbPass) {
        $this->host=$host;
        $this->dbUser=$dbUser;
        $this->dbPass=$dbPass;
		$this->connectError=false;
        $this->connectToDb();
    }

    /**
    * Establishes connection to MySQL server
    * @return MySQL link identifier
    * @access private
    */
    function connectToDb () {
        // Make connection to MySQL server
        if (!$this->dbConn = @mysql_connect($this->host,
                                      $this->dbUser,
                                      $this->dbPass)) {
            trigger_error('Could not connect to server');
            $this->connectError=true;
        } 
    }
}
?>