<?php
require_once($config['ABSOLUTE_FILE_PATH']."core/sessions.php");
session_start();

/* **************************************************
Copyright (c) 2008, Skypanther(r) Studios, Inc.
Skypanther(r) is a registered trademark of Skypanther Studios, Inc. 
************************************************** */


/* INCLUDE THE REQUIRED PARENT CLASS  */
require_once($config['ABSOLUTE_FILE_PATH'].'core/DB.php');
class FestOS extends DB {
	// properties
	var $config;
	var $lang;
	var $host;
	var $dbUser;
	var $dbPass;
	var $dbName;
	var $dbPrefix;
	var $errorMsg;
	var $filepath;
	var $auto_logout;
	var $loggedIn;
	var $id;
	var $email;

	function FestOS($config, $autoLogin = false) {
		$this->lang = $GLOBALS['lang'];
		$this->config = &$GLOBALS['config'];
        $this->host=&$config['dbserver'];
        $this->dbUser=&$config['dbuser'];
        $this->dbPass=&$config['dbpassword'];
        $this->dbName=&$config['dbname'];
        $this->dbPrefix=&$config['dbprefix'];
		$this->errorMsg='';
		$this->filepath = &$config['ABSOLUTE_FILE_PATH'];
		$this->auto_logout = &$config['AUTO_LOGOUT'];
		$this->connectToDb();
		$this->loggedIn = false;
		$this->id;
		$this->email;
		if($autoLogin) {
			$this->login();
		}
	} // end constructor	
	
	/**
    * Logs the user in
    * @access public
    * @return void
	*/
	function login($redir='login.php') {
		if(!isset($_SESSION['splogin']) || $_SESSION['splogin'] != 'TRUE' || $_SESSION['splogin'] != TRUE) {
			$this->redirect($redir);
		} else if($this->auto_logout !== FALSE && (time() - $_SESSION['sptimeout'] < $this->auto_logout) ) {
			// sessions time out after XXX seconds, less than that and
			// we reset the clock to keep folks logged in
			$_SESSION['sptimeout'] = time();
			$_SESSION['splogin'] = 'TRUE';
			$this->id = (!isset($_SESSION['userid']) || $_SESSION['userid']=='' || $_SESSION['userid']== NULL) ? $_SESSION['vID'] : $_SESSION['userid'];
			$this->loggedIn = true;
		} else {
			$this->logout('login.php?reason=timeout');
		}
	} // end login()
	
	/**
    * Logs out the current session
	* @param redir - url of page to redirect to after function runs, default = login.php
    * @access public
    * @return void, but redirects to fixed page
	*/
	function logout($redir='login.php?reason=logout') {
		$_SESSION['splogin'] = 'FALSE';
		$_SESSION['sptimeout'] = 9999999999999999999999;
		session_destroy();
		$this->loggedIn = false;
		$this->redirect($redir);
	} // end logout()
	
	function isLoggedIn() {
		// getter method for loggedIn property
		if(isset($_SESSION['splogin'])) {
			return $_SESSION['splogin']; // $this->loggedIn;
		} else {
			return false;
		}
	}

	/**
    * Checks to see if the user is logged in
    * @access public
    * @return void
	*/
	function checklogin() {
		if($this->isLoggedIn()) {
			if($this->auto_logout !== FALSE && (time() - $_SESSION['sptimeout'] < $this->auto_logout) ) {
				// sessions time out after XXX seconds, less than that and
				// we reset the clock to keep folks logged in
				$_SESSION['sptimeout'] = time();
				$_SESSION['splogin'] = 'TRUE';
				$this->id = (!isset($_SESSION['userid']) || $_SESSION['userid']=='' || $_SESSION['userid']== NULL) ? $_SESSION['vID'] : $_SESSION['userid'];
				$this->loggedIn = true;
			} else {
				$this->logout('login.php?reason=timeout');
			}
		}
	} // end checklogin()


	function getRoleID() {
		// get role ID for block and page level authorization
		$r = $this->query("SELECT roleID FROM ".$this->dbPrefix."users WHERE userid = ".$this->id);
		$rw = $r->fetch();
		return $rw['roleID'];
	}

	function getRole() {
		// get role name for block and page level authorization
		switch($this->getRoleID()) {
			case 0:
			case 1:
				return $this->lang['ADMINISTRATOR'];
			break;
			case 2:
				return $this->lang['VENDOR'];
			break;
			default:
				return $this->lang['USER'];
			break;
		}
	}
	function isAdmin() {
		return true; 
		/*
		DEC. 2 2008 - DISABLED BY TIM, NEEDS TO BE RETHOUGHT, 
			RETURNING TRUE MIGHT CAUSE PROBLEMS FOR A COUPLE OF THE ACTION PAGES THAT
			DON'T OTHERWISE CHECK LOGGED IN STATE. BUG NOTED FOR NEXT VERSION
		*/
		
		// determine if user is an administrator (const defined in core.php)
		//return ($this->getRoleID() <= ADMINISTRATOR_ROLE_ID) ? true : false;
	}
	function isVendor() {
		// determine if user is green vendor
		return ($this->getRoleID() == VENDOR_ROLE_ID) ? true : false;
	}

	function isUser() {
		// determine if user is a user
		return ($this->getRoleID() == USER_ROLE_ID) ? true : false;
	}

	function redirect($url){
		if($url) {
			if (!headers_sent()){    //If headers not sent yet... then do php redirect
				header('Location: '.$url); exit;
			}else{                    //If headers are sent... do java redirect... if java disabled, do html redirect.
				echo '<script type="text/javascript">';
				echo 'window.location.href="'.$url.'";';
				echo '</script>';
				echo '<noscript>';
				echo '<meta http-equiv="refresh" content="0;url='.$url.'" />';
				echo '</noscript>'; exit;
			}
		} 
	}//==== End -- Redirect

} // end class declaration
?>