<?php
@session_start();

/* **************************************************
Copyright (c) 2008, Skypanther(r) Studios, Inc.
Skypanther(r) is a registered trademark of Skypanther Studios, Inc. 
************************************************** */


/* INCLUDE THE REQUIRED PARENT CLASS  */
require_once($config['ABSOLUTE_FILE_PATH'].'core/DB.php');
class PaymentRecorder extends DB {
	// properties
	var $config;
	var $host;
	var $dbUser;
	var $dbPass;
	var $dbName;
	var $dbPrefix;
	var $errorMsg;
	var $filepath;
	var $vendorID; 
	var $paymentDate; // string
	var $paymentAmount; // float
	var $paymentID; // string - transaction id from processor
	var $paymentNotes; // string
	var $paymentProcessor;  // string - processor (check, paypal, credit card, etc.)

	function PaymentRecorder($config) {
		$this->config = &$GLOBALS['config'];
		$this->lang = &$GLOBALS['lang'];
        $this->host=&$config['dbserver'];
        $this->dbUser=&$config['dbuser'];
        $this->dbPass=&$config['dbpassword'];
        $this->dbName=&$config['dbname'];
        $this->dbPrefix=&$config['dbprefix'];
		$this->errorMsg='';
		$this->filepath = &$config['ABSOLUTE_FILE_PATH'];
		$this->connectToDb();

		$this->vendorID == '';
		$this->paymentDate == '';
		$this->paymentAmount == '';
		$this->paymentID == '';
		$this->paymentNotes == '';
		$this->paymentProcessor == '';
	} // end constructor	

	// SETTER METHODS
	function setVendorID($id) {
		$this->vendorID = $id;
	}
	function paymentDate($date) {
		$this->paymentDate = $date;
	}
	function paymentAmount($amount) {
		$this->paymentAmount = $amount;
	}
	function paymentID($id) {
		// string - transaction id from processor
		$this->paymentID = $id;
	}
	function paymentNotes($notes) {
		$this->paymentNotes = $notes;
	}
	function paymentProcessor($processor) {
		 // string - processor (check, paypal, credit card, etc.)
		$this->paymentProcessor = $processor;
	}

	// ACTION METHODS
	function recordPayment() {
		/*
		recordPayment - records a payment in the database
		returns TRUE or error string
		if($this->vendorID == '' || $this->paymentDate == '' || $this->paymentAmount == '' || $this->paymentID == '' || $this->paymentProcessor == '') {
		*/
		if($this->vendorID == '') {
			return false;
		} else {
			$transactionString = $this->paymentDate.' $'.ltrim($this->paymentAmount,'$').' ID:'.$this->paymentID.' ';
			$query = "UPDATE ".$this->config['dbprefix']."vendors SET
			   paidApplicationFee = 1,
			   paidBoothFee = 1,
			   transactionID = concat_ws(' ', '".$transactionString."<br />', transactionID),
			   statusID = 3
			  WHERE vendorID = ".$this->vendorID;
			$result = $this->query($query);
			if($this->errorMsg == '') {
				return true;
			} else {
				return $this->errorMsg;
			}
		}
	} // end recordPayment

function paymentNotify () {
	/*
	paymentNotify - sends email notification to applicant and admin about payment received
	returns boolean (success: yes/no)
	*/
	$query = "SELECT emailAdmin, emailApplicant, adminEmailText, applicantEmailText, administratorsEmail FROM ".$this->config['dbprefix']."payments LIMIT 1";
	$res = $this->query($query);
	$row = $res->fetch();
	$q2 = "SELECT vendorName, firstname, lastname, tracking, email FROM ".$this->config['dbprefix']."vendors WHERE vendorID=".$this->vendorID;
	$res2 = $this->query($q2);
	$row2 = $res2->fetch();
	if($row['emailAdmin']==1) {
		$artisanStr = ('ID:'.$this->vendorID.'/'.$row2['tracking'].' '.$row2['vendorName'].' '.$row2['lastname'].', '.$row2['firstname']);
		$msg = str_replace('{ARTISAN}', $artisanStr, $row['adminEmailText']);
		$msg = str_replace('{PAYMENTDATE}', $this->paymentDate, $msg);
		$msg = str_replace('{AMOUNT}', $this->paymentAmount, $msg);
		$msg = str_replace('{TRANSACTIONID}', $this->paymentID, $msg);
		$msg = str_replace('{PAYMENTPROCESSOR}', $this->paymentProcessor, $msg);
		sendEmail($row['administratorsEmail'], 'Payment notification', $msg);
	} // end sending admin email
	if($row['emailApplicant']==1) {
		$artisanStr = ('ID:'.$this->vendorID.'/'.$row2['tracking'].' '.$row2['vendorName'].' '.$row2['lastname'].', '.$row2['firstname']);
		$msg = str_replace('{ARTISAN}', $artisanStr, $row['applicantEmailText']);
		$msg = str_replace('{FESTIVALNAME}', $this->lang['festival'], $msg);
		$msg = str_replace('{PAYMENTDATE}', $this->paymentDate, $msg);
		$msg = str_replace('{AMOUNT}', $this->paymentAmount, $msg);
		$msg = str_replace('{TRANSACTIONID}', $this->paymentID, $msg);
		$msg = str_replace('{PAYMENTPROCESSOR}', $this->paymentProcessor, $msg);
		sendEmail($row2['email'], ($this->lang['festival'].': Payment notification'), $msg);
	} // end sending applicant email
	
} // end paymentNotify

function failureNotify () {
	/*
	failureNotify - sends email notification to applicant and admin about failed/declined payment
	returns boolean (success: yes/no)
	*/
	$query = "SELECT emailAdmin, emailApplicant, adminEmailText, applicantEmailText, administratorsEmail FROM ".$this->config['dbprefix']."payments LIMIT 1";
	$res = $this->query($query);
	$row = $res->fetch();
	$q2 = "SELECT vendorName, firstname, lastname, tracking, email FROM ".$this->config['dbprefix']."vendors WHERE vendorID=".$this->vendorID;
	$res2 = $this->query($q2);
	$row2 = $res2->fetch();
	if($row['emailAdmin']==1) {
		$artisanStr = ('ID:'.$this->vendorID.'/'.$row2['tracking'].' '.$row2['vendorName'].' '.$row2['lastname'].', '.$row2['firstname']);
		$msg = str_replace('{ARTISAN}', $artisanStr, $row['adminEmailText']);
		$msg = str_replace('{PAYMENTDATE}', $this->paymentDate, $msg);
		$msg = str_replace('{AMOUNT}', $this->paymentAmount, $msg);
		$msg = str_replace('{TRANSACTIONID}', $this->paymentID, $msg);
		$msg = str_replace('{PAYMENTPROCESSOR}', $this->paymentProcessor, $msg);
		sendEmail($row['administratorsEmail'], 'Payment failure', $msg);
	} // end sending admin email
	if($row['emailApplicant']==1) {
		$artisanStr = ('ID:'.$this->vendorID.'/'.$row2['tracking'].' '.$row2['vendorName'].' '.$row2['lastname'].', '.$row2['firstname']);
		$msg = str_replace('{ARTISAN}', $artisanStr, $row['applicantEmailText']);
		$msg = str_replace('{FESTIVALNAME}', $this->lang['festival'], $msg);
		$msg = str_replace('{PAYMENTDATE}', $this->paymentDate, $msg);
		$msg = str_replace('{AMOUNT}', $this->paymentAmount, $msg);
		$msg = str_replace('{TRANSACTIONID}', $this->paymentID, $msg);
		$msg = str_replace('{PAYMENTPROCESSOR}', $this->paymentProcessor, $msg);
		sendEmail($row2['email'], ($this->lang['festival'].': Payment failure'), $msg);
	} // end sending applicant email

} // end failureNotify

} // end class declaration
?>