<?php
/* **************************************************
Copyright (c) 2008, Skypanther(r) Studios, Inc.
Skypanther(r) is a registered trademark of Skypanther Studios, Inc. 
************************************************** */

/* **************************************************

                      *********
              PRIMARY CONFIGURATION FILE
                      *********

  YOU ** MUST ** EDIT THIS FILE TO SET THE BASIC DATABASE AND HTTP VARIABLES. 

************************************************** */

// DATABASE CONFIGURATION SETTINGS
$config['dbserver'] = "localhost"; // database server
$config['dbuser'] = "root";
$config['dbpassword'] = "";
$config['dbname'] = "festos";
$config['dbprefix'] = "fest_"; // doesn't have to, but should end in an underscore
$config['HTTP_PATH'] = 'http://localhost/festos/'; // URL WITH SLASH (/) AT END

/* MAIL SENDING VALUES - CHANGE IF YOUR HOST REQUIRES "NICER" MAILING SETTINGS */
define('MAILDELAY', 15000); // delay between mail batches in seconds
define('MAILBATCH', 25); // mail batch size

/* ABSOLUTE DIRECTORY WHERE FESTOS IS INSTALLED, YOU PROBABLY DON'T NEED TO TOUCH THIS */
$config['ABSOLUTE_FILE_PATH'] = dirname(dirname(__FILE__)) .'/'; // WITH SLASH (/) AT END!


/* **************************************************
	DEFINE THE BUILT-IN PAGES FOR THE MENU
	
	TREAD CAREFULLY WHEN UPDATING THIS LIST. DON'T CHANGE THE pageID VALUE
		- CHANGE parentID TO MOVE THE PAGE TO A SUBMENU (not yet implemented)
		- EDIT menuText TO CHANGE WHAT SHOWS UP IN THE MENU
		- EDIT titleText TO CHANGE THE LINK TITLE (tooltip)
************************************************** */

$stockPages = array();
$stockPages['applications'] = array(
	'pageID'=>'applications',
	'parentID'=>'',
	'alias'=>'applications.php', 
	'menuText'=>'Applications', 
	'titleText'=>'Apply or manage your application',
	'pageTitle'=>'Applications',
	'isHomePage'=>0);
$stockPages['artists'] = array(
	'pageID'=>'artists',
	'parentID'=>'',
	'alias'=>'artists.php', 
	'menuText'=>'Artists', 
	'titleText'=>'View the artists',
	'pageTitle'=>'Artists',
	'isHomePage'=>0);
$stockPages['contacts'] = array(
	'pageID'=>'contacts',
	'parentID'=>'',
	'alias'=>'contacts.php',
	'menuText'=>'Contacts', 
	'titleText'=>'Festival contacts',
	'pageTitle'=>'Contacts',
	'isHomePage'=>0);
$stockPages['entertainers'] = array(
	'pageID'=>'entertainers',
	'parentID'=>'',
	'alias'=>'entertainers.php', 
	'menuText'=>'Entertainers', 
	'titleText'=>'Entertainers',
	'pageTitle'=>'Entertainers',
	'isHomePage'=>0);
$stockPages['exhibitors'] = array(
	'pageID'=>'exhibitors',
	'parentID'=>'',
	'alias'=>'exhibitors.php', 
	'menuText'=>'Exhibitors', 
	'titleText'=>'Exhibitors',
	'pageTitle'=>'Exhibitors',
	'isHomePage'=>0);
$stockPages['foodvendors'] = array(
	'pageID'=>'foodvendors',
	'parentID'=>'',
	'alias'=>'foodvendors.php', 
	'menuText'=>'Food', 
	'titleText'=>'Food and drinks',
	'pageTitle'=>'Food and drinks',
	'isHomePage'=>0);
$stockPages['performanceschedule'] = array(
	'pageID'=>'performanceschedule',
	'parentID'=>'',
	'alias'=>'performanceschedule.php', 
	'menuText'=>'Performance Schedule', 
	'titleText'=>'Schedule of performances',
	'pageTitle'=>'Performance Schedule',
	'isHomePage'=>0);
$stockPages['sponsors'] = array(
	'pageID'=>'sponsors',
	'parentID'=>'',
	'alias'=>'sponsors.php', 
	'menuText'=>'Sponsors', 
	'titleText'=>'Festival sponsors',
	'pageTitle'=>'Festival sponsors',
	'isHomePage'=>0);
$stockPages['winners'] = array(
	'pageID'=>'winners',
	'parentID'=>'',
	'alias'=>'winners.php', 
	'menuText'=>'Winners', 
	'titleText'=>'Winning artists',
	'pageTitle'=>'Winning artists',
	'isHomePage'=>0);


/* **************************************************
     DO NOT CHANGE ANYTHING BELOW THIS POINT!!!
************************************************** */
require_once($config['ABSOLUTE_FILE_PATH'].'cache/dynconfig.php');

?>