<?php
/* **************************************************
FestOS(TM) - Digital Festival Management System
Copyright (C) 2009, Skypanther Studios, Inc.
Skypanther is a registered trademark of Skypanther Studios, Inc. and is not covered by this license.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
************************************************** */

function showSnippet($snippetID) {
	global $festos, $config;
	$query = "SELECT active, contents FROM ".$config['dbprefix']."pagesnippets WHERE snippetID = ".$snippetID;
	$res=$festos->query($query);
	if($res->size() == 1) {
		$row=$res->fetch();
		if($row['active']==1) {
			// echo stripslashes($row['contents']);
			// The KFM file manager replaces the HTTP path with a path relative to itself on insert
			// so the next line replaces that relative path with an absolute path so that the image will show
			echo stripslashes(str_replace('../cache', $config['HTTP_PATH'].'cache',$row['contents']));
		}
	}
}


function showEvent($eventID) {
	global $festos, $config;
	require_once($config['ABSOLUTE_FILE_PATH'].'core/Template.php');
	$tpl = & new Template();

	$query = "SELECT eventID, title, performer, startTime, endTime, venue, description, active
		FROM ".$config['dbprefix']."schedule
		LEFT JOIN ".$config['dbprefix']."venues ON ".$config['dbprefix']."venues.venueID = ".$config['dbprefix']."schedule.venueID
		WHERE eventID = ".$eventID;
	$res=$festos->query($query);
	if($res->size() == 1) {
		$row=$res->fetch();
		if($row['active']==1) {
			$tpl->set('eventID',$row['eventID']);
			$tpl->set('title',stripslashes($row['title']));
			$tpl->set('performer',stripslashes($row['performer']));
			$tpl->set('startTime',$row['startTime']);
			$tpl->set('endTime',$row['endTime']);
			$tpl->set('venue',stripslashes($row['venue']));
			// echo stripslashes($row['contents']);
			// The KFM file manager replaces the HTTP path with a path relative to itself on insert
			// so the next line replaces that relative path with an absolute path so that the image will show
			$tpl->set('description',stripslashes(str_replace('../cache', $config['HTTP_PATH'].'cache',$row['description'])));
			$tpl->set('config',$config);
			echo $tpl->fetch($config['ABSOLUTE_FILE_PATH'].'templates/schedule_single_event.tpl');
		} // end if row is active test
	} // end if single record returned
} // end showEvent()


function showAllEvents() {
	global $festos, $config;
	require_once($config['ABSOLUTE_FILE_PATH'].'core/Template.php');
	$tpl = & new Template();

	$query = "SELECT eventID, title, performer, startTime, endTime, venue, description, active
		FROM ".$config['dbprefix']."schedule
		LEFT JOIN ".$config['dbprefix']."venues ON ".$config['dbprefix']."venues.venueID = ".$config['dbprefix']."schedule.venueID
		ORDER BY startTime, endTime";
	$res=$festos->query($query);
	$events = array();
	while($row=$res->fetch()) {
		if($row['active']==1) {
			$events['eventID']['eventID'] = $row['eventID'];
			$events['eventID']['title'] = stripslashes($row['title']);
			$events['eventID']['performer'] = stripslashes($row['performer']);
			$events['eventID']['startTime'] = $row['startTime'];
			$events['eventID']['endTime'] = $row['endTime'];
			$events['eventID']['venue'] = stripslashes($row['venue']);
			// echo stripslashes($row['contents']);
			// The KFM file manager replaces the HTTP path with a path relative to itself on insert
			// so the next line replaces that relative path with an absolute path so that the image will show
			$events['eventID']['description'] = stripslashes(str_replace('../cache', $config['HTTP_PATH'].'cache',$row['description']));
		} // end if row is active test
	} // end while loop
	$tpl->set('events',$events);
	$tpl->set('config',$config);
	echo $tpl->fetch($config['ABSOLUTE_FILE_PATH'].'templates/schedule_all_events.tpl');
} // end showEvent()

?>