<?php
/* **************************************************
FestOS(TM) - Digital Festival Management System
Copyright (C) 2009, Skypanther Studios, Inc.
Skypanther is a registered trademark of Skypanther Studios, Inc. and is not covered by this license.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
************************************************** */
$festos->login(false);

/* *********************************************************************************
	OUTPUT OF CONTROL PANEL, APPLICATIONS, PROFILE, AND OTHER APPLICANT SCREENS
		- IF LOGGED IN, GET VENDOR DETAILS FROM DB, CHECK WHICH PAGE TO SHOW, LOAD TEMPLATE
		- IF NOT LOGGED IN, LOAD LOGIN FORM
   ******************************************************************************* */

if(isset($festos) && $festos->loggedIn) {
	// logged in
	require_once('core/Template.php');
	$tpl = & new Template();

	// get applicant details
	$appQuery = "SELECT * FROM ".$config['dbprefix']."vendors WHERE vendorID = ".$festos->id;
	$res = $festos->query($appQuery);
	if($res->size() == 1) {
		// logged in
		$row = $res->fetch();
		$tpl->set('details', $row);
	} else {
		$festos->logout();
		die();
	}

	// get application type details, needed for some of the templates
	$appTypeQuery = "SELECT apptypeID, apptype, apptypelabel, rulesPDF FROM ".$config['dbprefix']."applicanttypes";
	// $appTypeQuery .= ' WHERE enabled = 1';
	$appTypeQuery .= ' ORDER BY sortorder, apptypelabel';
	$appTypeRes = $festos->query($appTypeQuery);
	$appTypes = array();
	while($appTypesRow = $appTypeRes->fetch() ) {
		$appTypes[] = $appTypesRow;
	}
	$tpl->set('appTypes',$appTypes);

	// add standard details
	$tpl->set('applicantID',$festos->id);
	$tpl->set('thispage', $_SERVER['PHP_SELF']);
	$tpl->set('querystring',urlencode(passTheQueryString($_GET)));
	$tpl->set('config',$config);
	$tpl->set('lang',$lang);
	$whichpage = (isset($_GET['pg'])) ? $_GET['pg'] : 'default';
	switch($whichpage) {
		case 'appform':
		case 'applyform':
			// (Step 1) application form
			/* ******************************************************** 
				BEGIN APPLICATION FORM - VARIOUS QUERIES TO BUILD DYNAMIC FORM
			   ******************************************************** */
			
			// DETERMINE ARTISAN'S APPLICATION TYPE
			// if it's not already set - set to $_GET['apptypeID'] 
			// if it's not already set  && $_GET['apptypeID'] isn't set, set to the $config['DEFAULT_APPLICANT_TYPE']
			// (second option is a cleanup for old applications made prior to the multiple application type support features were added
			// DETERMINE WHICH FIELDS GO ONTO THE FORM
			if($row['apptypeID']!='') {
				$apptypeID = $row['apptypeID'];
			} else if(isset($_GET['apptypeID']) && intval($_GET['apptypeID'])>0) {
				$apptypeID = $_GET['apptypeID'];
				// then, update the applicant's DB record for future use
				$appTypeQuery = "UPDATE ".$config['dbprefix']."vendors SET apptypeID = ".$apptypeID.' WHERE vendorID = '.$festos->id;
				$appTypeRes = $festos->query($appTypeQuery);
			} else {
				if(isset($row['fpma']) && $row['fpma']==1) {
					$apptypeID =  $config['MEMBER_APPLICANT_TYPE'];  // user is "preferred member"
				} else {
					$apptypeID = $config['DEFAULT_APPLICANT_TYPE'];  // set the apptypeID for this page
				}
			}
			$tpl->set('apptypeID', $apptypeID);
			
			// RETRIEVE VENDOR CATEGORIES
			$categoryQuery = "SELECT vTypeID, vType FROM ".$config['dbprefix']."vendortypes WHERE vTypeID NOT IN (".$config['EXCLUDED_VENDOR_CATEGORIES'].") AND apptypeID = ".$apptypeID." ORDER BY vType";
			$categoryRes = $festos->query($categoryQuery);
			$vendorCategories = array();
			while($categoryRow = $categoryRes->fetch()) {
				$vendorCategories[] = $categoryRow;
			}
			$tpl->set('vendorCategories', $vendorCategories);
			
			// RETRIEVE FEE AMOUNTS
			$feeQuery = "SELECT boothFee, extraBoothFee, appFee, lateFee, lateFeeDate, cornerBoothFee FROM ".$config['dbprefix']."applicanttypes WHERE apptypeID=".$apptypeID;
			$feeResults = $festos->query($feeQuery);
			$tpl->set('fees', $feeResults->fetch());
			
			
			// DEFINE THE FIELDS INCLUDED ON THE FORM 
			//$fieldList[] = array('fieldname' => '', 'type'=>'', 'label'=>'', 'size'=>'', 'title'=>'', 'class'=>'', 'value'=>''); 
			
			// FIRST, FIELDS COMMON TO ALL APPLICATION TYPES (FOR NOW, STATICLY DEFINED HERE, MOVE TO DATABASE OR SEPARATE FILE)
			$fieldList[] = array('fieldname' => 'firstname', 'type'=>'text', 'label'=>'First name', 'size'=>'35', 'title'=>'You must enter your first name', 'class'=>'required');
			$fieldList[] = array('fieldname' => 'lastname', 'type'=>'text', 'label'=>'Last name', 'size'=>'35', 'title'=>'You must enter your last name', 'class'=>'required');
			if($apptypeID!=$config['ENTERTAINERS_APPTYPID']) {
				$fieldList[] = array('fieldname' => 'vendorName', 'type'=>'text', 'label'=>'Business/DBA name', 'size'=>'35', 'title'=>'(Optional) Enter your business or DBA name', 'class'=>'');
			} else {
				$fieldList[] = array('fieldname' => 'vendorName', 'type'=>'text', 'label'=>'Band name', 'size'=>'35', 'title'=>'Enter your band or stage name', 'class'=>'required');
			}
			$fieldList[] = array('fieldname' => 'address', 'type'=>'text', 'label'=>'Address', 'size'=>'35', 'title'=>'You must enter your address', 'class'=>'required');
			$fieldList[] = array('fieldname' => 'address2', 'type'=>'text', 'label'=>'Address 2', 'size'=>'35', 'title'=>'(Optional) Enter a second address line', 'class'=>'');
			$fieldList[] = array('fieldname' => 'city', 'type'=>'text', 'label'=>'City', 'size'=>'20', 'title'=>'You must enter your city', 'class'=>'required');
			$fieldList[] = array('fieldname' => 'state', 'type'=>'text', 'label'=>'State', 'size'=>'2', 'title'=>'You must enter your state', 'class'=>'required');
			$fieldList[] = array('fieldname' => 'zip', 'type'=>'text', 'label'=>'Zip code', 'size'=>'12', 'title'=>'You must enter your zip code', 'class'=>'required');
			$fieldList[] = array('fieldname' => 'phone', 'type'=>'text', 'label'=>'Phone', 'size'=>'15', 'title'=>'You must enter your phone number with area code', 'class'=>'validphone');
			$fieldList[] = array('fieldname' => 'cellphone', 'type'=>'text', 'label'=>'Cell/alternate phone #', 'size'=>'15', 'title'=>'(Optional) Enter a cell or other number where we can reach you', 'class'=>'validphone');
			$fieldList[] = array('fieldname' => 'website', 'type'=>'text', 'label'=>'Web site', 'size'=>'35', 'title'=>'(Optional) Enter your web site address without the \'http://\' part', 'class'=>'');
		
			// NOW DEFINE THE DYNAMIC FIELDS BASED ON THE APPLICANT TYPE
			$formQuery = "SELECT fieldname, fieldtype, label, size, title, required FROM ".$config['dbprefix']."applicationforms, ".$config['dbprefix']."applicanttypes 
			WHERE (".$config['dbprefix']."applicationforms.appFormID = ".$config['dbprefix']."applicanttypes.appFormID AND ".$config['dbprefix']."applicanttypes.apptypeID = ".$apptypeID.")
			ORDER BY ".$config['dbprefix']."applicationforms.sortorder";
			/*
			Could also use this sub-query:
			SELECT distinct fieldname, fieldtype, label, size, title, required FROM ".$config['dbprefix']."applicationforms, applicanttypes 
			WHERE applicationforms.appFormID = (select appFormID FROM ".$config['dbprefix']."applicanttypes where apptypeID=4)
			ORDER BY applicationforms.sortorder
			*/
			
			$formRes = $festos->query($formQuery);
			while($formRow = $formRes->fetch()) {
				$fieldList[] = array('fieldname' => $formRow['fieldname'],
								'type' => $formRow['fieldtype'],
								'label' => $formRow['label'],
								'size' => $formRow['size'],
								'title' => $formRow['title'],
								'class' => $formRow['required']);
			
			} // end while
			
			$tpl->set('fieldList', $fieldList);

			$rulesPDFQuery = "SELECT apptypelabel, rulesPDF FROM ".$config['dbprefix']."applicanttypes WHERE apptypeID=".$apptypeID;
			$rulesPDFResults = $festos->query($rulesPDFQuery);
			$tpl->set('rulesPDF', $rulesPDFResults->fetch());

			echo $tpl->fetch('templates/apply_applyform.tpl');

			/* ******************************************************** 
				END APPLICATION FORM - VARIOUS QUERIES TO BUILD DYNAMIC FORM
			   ******************************************************** */
		break;
		case 'photos':
			// (Step 2) photo upload - go here if required photos aren't uploaded with applyform

			// determine if the apptypeID has been set yet or not
			if($row['apptypeID'] == '' || ($row['apptypeID'] != $config['ARTISTS_APPTYPID'] && $row['apptypeID'] != $config['EXHIBITORS_APPTYPID'] && $row['apptypeID'] != $config['FOODVENDORS_APPTYPID'] && $row['apptypeID'] != $config['ENTERTAINERS_APPTYPID'] && $row['apptypeID'] != $config['VOLUNTEERS_APPTYPID']) ) {
				// no apptypeID assigned yet, use default app type
				$apptypeID = $config['DEFAULT_APPLICANT_TYPE'];
			} else {
				$apptypeID = $row['apptypeID'];
			}
			$tpl->set('apptypeID', $apptypeID);
			
			// get number ofrequired photos
			$photoRequirementsQuery = "SELECT numphotos, numphotosrequired FROM ".$config['dbprefix']."applicanttypes WHERE apptypeID = ".$apptypeID;
			$photoRequirementsRes = $festos->query($photoRequirementsQuery);
			$tpl->set('photoRequirements', $photoRequirementsRes->fetch());


			$tpl->set('lang',$lang);
			$tpl->set('photolang',$photolang);
			echo $tpl->fetch('templates/apply_photos.tpl');
		break;
		case 'media':
			// (Step 3) optional step for entertainers - upload media files
			echo $tpl->fetch('templates/apply_media.tpl');
		break;
		case 'apply_received':
			// (Step 6) application submitted and received
			$tpl->set('lang',$lang);
			echo $tpl->fetch('templates/apply_received.tpl');
		break;
		case 'profile':
			// (ancillary) update profile
			echo $tpl->fetch('templates/apply_profile.tpl');
		break;
		case 'changeapptype':
			// (ancillary) update profile
			$tpl->set('lang',$lang);

/*
			$appTypeQuery = "SELECT apptypeID, apptype, apptypelabel, rulesPDF FROM ".$config['dbprefix']."applicanttypes";
			$appTypeQuery .= ' ORDER BY sortorder, apptypelabel';
			$appTypeRes = $festos->query($appTypeQuery);
			$appTypes = array();
			while($appTypeRow = $appTypeRes->fetch()) {
				$appTypes[] = $appTypeRow;
			}
			$tpl->set('apptypes',$appTypes);
*/
			echo $tpl->fetch('templates/apply_changeapptype.tpl');
		break;
		case 'privacy':
			// (ancillary) update profile
			$tpl->set('lang',$lang);
			echo $tpl->fetch('templates/apply_privacypolicy.tpl');
		break;
		case 'payoptions':
			// (Step 5) payment options page
			// FIRST, CHECK PHOTO REQUIREMENTS: IF PHOTOS ARE REQUIRED BUT NOT UPLOADED,
			// NEED TO SEND TO PHOTO UPLOADS PAGE

			if($row['apptypeID'] == '' || ($row['apptypeID'] != $config['ARTISTS_APPTYPID'] && $row['apptypeID'] != $config['EXHIBITORS_APPTYPID'] && $row['apptypeID'] != $config['FOODVENDORS_APPTYPID'] && $row['apptypeID'] != $config['ENTERTAINERS_APPTYPID'] && $row['apptypeID'] != $config['VOLUNTEERS_APPTYPID']) ) {
				// no apptypeID assigned yet, use default app type
				$apptypeID = $config['DEFAULT_APPLICANT_TYPE'];
			} else {
				$apptypeID = $row['apptypeID'];
			}


			$photoRequirementsQuery = "SELECT numphotosrequired FROM ".$config['dbprefix']."applicanttypes WHERE apptypeID = ".$apptypeID;
			$photoRequirementsRes = $festos->query($photoRequirementsQuery);
			$requiredPhotosRow = $photoRequirementsRes->fetch();
			$requiredPhotos = $requiredPhotosRow['numphotosrequired']+1;
			for($i=1;$i<$requiredPhotos;$i++) {
				if($row['photo'.$i] == '') {
					echo $tpl->fetch('templates/apply_missingrequiredphotos.tpl');
					die();
				}
			}

			$tpl->set('lang',$lang);
			$tpl->set('photolang',$photolang);


			// RETRIEVE FEE AMOUNTS
			$feeQuery = "SELECT boothFee, extraBoothFee, appFee, lateFee, lateFeeDate, cornerBoothFee FROM ".$config['dbprefix']."applicanttypes WHERE apptypeID=".$row['apptypeID'];
			$feeResults = $festos->query($feeQuery);
			$fees = $feeResults->fetch();
			$tomorrow = ( mktime(0, 0, 0, date("m"), date("d")+1, date("Y")) );
			$tpl->set('tomorrow', $tomorrow);
			if($fees['extraBoothFee']>0 || $fees['lateFee']>0 || $fees['appFee']>0 || $fees['boothFee']>0 || $fees['cornerBoothFee']>0) {
				$tpl->set('fees', $fees);
				$tpl->set('requestedBooths', $row['requestedBooths']);

				// figure out the specifics of what they owe
				$total = 0;
				$tpl->set('appfee', $fees['appFee']);
				$total += $fees['appFee'];
				// booth fee for one or more booths
				$totalBoothFee = $fees['boothFee'];
				$totalBoothFee += ($row['requestedBooths']-1>0) ? ($row['requestedBooths']-1)*$fees['extraBoothFee'] : 0; 
				$total += $totalBoothFee;
				$tpl->set('boothfee',$totalBoothFee);
				// late fee, if any
				if($tomorrow > $fees['lateFeeDate']) {
					$latefee = $fees['lateFee'];
				} else {
					$latefee = 0;
				}
				$total += $latefee;
				$tpl->set('latefee',$latefee);
				// corner fee, if any
				$corner = ($row['corner']==1) ? $fees['cornerBoothFee'] : 0;
				$tpl->set('cornerfee',$corner);
				$total += $corner;
				$tpl->set('total',$total);
				// GET AVAILABLE PAYMENT METHODS
				$paymethodsQuery = "SELECT moduleID, modulePaymentButtonFile FROM ".$config['dbprefix']."paymentmodules WHERE enabled = 1 ORDER BY sortorder ASC";
				$paymethodsRes = $festos->query($paymethodsQuery);
				$paymentmethod = array();
				while($paymethodsRow = $paymethodsRes->fetch()) {
					$paymentmethod[] = $paymethodsRow;
				}
				$tpl->set('paymentmethod', $paymentmethod);
				echo $tpl->fetch('templates/apply_paymentoptions.tpl');
			} else {
				echo $tpl->fetch('templates/apply_received.tpl');
			}
		break;
		case 'payform':
			// (ancillary) update profile
			$tpl->set('lang',$lang);
			$tpl->set('tomorrow', ( mktime(0, 0, 0, date("m"), date("d")+1, date("Y")) ) );

			// RETRIEVE FEE AMOUNTS
			$feeQuery = "SELECT boothFee, extraBoothFee, appFee, lateFee, lateFeeDate, cornerBoothFee FROM ".$config['dbprefix']."applicanttypes WHERE apptypeID=".$row['apptypeID'];
			$feeResults = $festos->query($feeQuery);
			$fees = $feeResults->fetch();
			$tomorrow = ( mktime(0, 0, 0, date("m"), date("d")+1, date("Y")) );
			$tpl->set('tomorrow', $tomorrow);
			if($fees['extraBoothFee']>0 || $fees['lateFee']>0 || $fees['appFee']>0 || $fees['boothFee']>0 || $fees['cornerBoothFee']>0) {
				$tpl->set('fees', $fees);
				$tpl->set('requestedBooths', $row['requestedBooths']);

				// figure out the specifics of what they owe
				$total = 0;
				$tpl->set('appfee', $fees['appFee']);
				$total += $fees['appFee'];
				// booth fee for one or more booths
				$totalBoothFee = $fees['boothFee'];
				$totalBoothFee += ($row['requestedBooths']-1>0) ? ($row['requestedBooths']-1)*$fees['extraBoothFee'] : 0; 
				$total += $totalBoothFee;
				$tpl->set('boothfee',$totalBoothFee);
				// late fee, if any
				if($tomorrow > $fees['lateFeeDate']) {
					$latefee = $fees['lateFee'];
				} else {
					$latefee = 0;
				}
				$total += $latefee;
				$tpl->set('latefee',$latefee);
				// corner fee, if any
				$corner = ($row['corner']==1) ? $fees['cornerBoothFee'] : 0;
				$tpl->set('cornerfee',$corner);
				$total += $corner;
				$tpl->set('total',$total);
				$tpl->set('totalwithoutappfee', ($total - $fees['appFee']) );

				// GET TEMPLATE PAGE FOR THE PAYMENT MODULE
				$paymethodsQuery = "SELECT modulePaymentTemplate, modulePaymentProcessor FROM ".$config['dbprefix']."paymentmodules WHERE moduleID = ".$_GET['moduleID'];
				$paymethodsRes = $festos->query($paymethodsQuery);
				$paymethods = $paymethodsRes->fetch();
				if($paymethods['modulePaymentProcessor'] != '') include 'addons/'.$paymethods['modulePaymentProcessor'];

				echo $tpl->fetch('addons/'.$paymethods['modulePaymentTemplate']);


			} else {
				echo $tpl->fetch('templates/apply_controlpanel.tpl');
			}
		break;
		case 'paid':
			// (Step 6) application submitted and received
			$tpl->set('lang',$lang);
			echo $tpl->fetch('templates/apply_paid.tpl');
		break;
		case 'logout':
			// (ancillary) update profile
			$tpl->set('config',$config);
			$festos->logout($_SERVER['PHP_SELF']);
		break;
/*
		case '':
			// (Step #) page_function
			echo $tpl->fetch('templates/apply_PAGENAME.tpl');
		break;
*/
		case 'default':
		case 'cp':
		default:
			echo $tpl->fetch('templates/apply_controlpanel.tpl');
		break;
	} // end switch
	
} else {
	/* *********************************************************************************
		NOT CONNECTING OVER SSL AND NOT LOGGED IN
			LOAD LOGIN FORM OR NON-SECURE PAGES: 
				(REGISTRATION PAGE, PRIVACY POLICY, PASSWORD REMINDER, LOGIN FORM)
	   ******************************************************************************* */

	require_once('core/Template.php');
	$tpl = & new Template();
	$tpl->set('thispage', $_SERVER['PHP_SELF']);
	$tpl->set('querystring',urlencode(passTheQueryString($_GET)));
	$tpl->set('config',$config);
	$tpl->set('lang',$lang);
	$whichpage = (isset($_GET['pg'])) ? $_GET['pg'] : 'default';
	switch($whichpage) {
		case 'register':
			// (ancillary) update profile
			echo $tpl->fetch('templates/apply_register.tpl');
		break;
		case 'forgot':
			// (ancillary) update profile
			echo $tpl->fetch('templates/apply_forgot.tpl');
		break;
		case 'forgot_followup':
			// (ancillary) update profile
			echo $tpl->fetch('templates/apply_forgot_followup.tpl');
		break;
		case 'privacy':
			// (ancillary) update profile
			$tpl->set('lang',$lang);
			echo $tpl->fetch('templates/apply_privacypolicy.tpl');
		break;
		case 'login':
		case 'default':
		case 'cp':
		default:
			$tpl->set('config',$config);
			echo $tpl->fetch('templates/apply_loginform.tpl');
		break;
	} // end switch
} // end if_logged_in
?>