<?php
/* **************************************************
FestOS(TM) - Digital Festival Management System
Copyright (C) 2009, Skypanther Studios, Inc.
Skypanther is a registered trademark of Skypanther Studios, Inc. and is not covered by this license.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
************************************************** */

require_once('core/Template.php');
$tpl = & new Template();

/*
*	THIS IS A MULTI-USE FILE: DEPENDING ON THE QUERY STRING PARAM
*	IT LOADS EITHER THE LIST OF CATEGORIES, RECORDS IN THAT CATEGORY
*	OR DETAILS OF A PARTICULAR RECORD
*/

$switcher = (isset($_GET['view'])) ? $_GET['view'] : 'categories';

switch($switcher) {
	case 'details':
		if(!isset($_GET['vendorID']) || ctype_digit($_GET['vendorID'])===FALSE || $_GET['vendorID'] == '') {
			$template = 'artists_nonespecified.tpl';
			break;
		}

		// GET ARTIST DETAILS
		$query = "SELECT vendorID, vendorName, vTypeID, firstname, lastname, address, description,
			address2, city, state, zip, phone, email, website, fpma, photo1, photo2, photo3, photo4 FROM ".$config['dbprefix']."vendors
			WHERE ".$config['dbprefix']."vendors.vendorID = ".$_GET["vendorID"];
		$res = $festos->query($query);
		$row = $res->fetch(); // NO WHILE LOOP BECAUSE WE'RE RETRIEVING A UNIQUE RECORD
		$artist = array();
		$artist['vendorID'] = $row['vendorID'];
		$artist['vendorName'] = $row['vendorName'];
		$artist['vTypeID'] = $row['vTypeID'];
		$artist['firstname'] = $row['firstname'];
		$artist['lastname'] = $row['lastname'];
		$artist['address'] = $row['address'];
		$artist['address2'] = $row['address2'];
		$artist['city'] = $row['city'];
		$artist['state'] = $row['state'];
		$artist['zip'] = $row['zip'];
		$artist['phone'] = $row['phone'];
		$artist['email'] = $row['email'];
		$artist['website'] = $row['website'];
		$artist['description'] = $row['description'];
		$artist['fpma'] = $row['fpma'];
		$artist['photo1'] = $row['photo1'];
		$artist['photo2'] = $row['photo2'];
		$artist['photo3'] = $row['photo3'];
		$artist['photo4'] = $row['photo4'];

		// GET BOOTH ASSIGNMENTS

		$query = "SELECT booth FROM ".$config['dbprefix']."vendorlocations WHERE vendorID = ".$_GET["vendorID"];
		$res = $festos->query($query);
		$boothList = array();
		while ($row = $res->fetch()) {
			$boothList[] = $row['booth'];
		} 

		$tpl->set('boothList', $boothList);
		$tpl->set('vTypeID', $_GET['vTypeID']);
		$tpl->set('vType', $_GET['category']);
		$tpl->set('artist', $artist);
		$template = 'artists_details.tpl';
	break;
	
	case 'list':
		if(!isset($_GET['vTypeID']) || ctype_digit($_GET['vTypeID'])===FALSE || $_GET['vTypeID'] == '') {
			$query = "SELECT vTypeID FROM ".$config['dbprefix']."vendortypes ORDER BY vTypeID ASC LIMIT 1";
			$res = $festos->query($query);
			$row = $res->fetch();
			$vTypeID = $row['vTypeID'];
		} else {
			$vTypeID = $_GET['vTypeID'];
		}
		
		$query = "SELECT vType FROM ".$config['dbprefix']."vendortypes WHERE vTypeID = ".$vTypeID." LIMIT 1";
		$res = $festos->query($query);
		$row = $res->fetch();
		$vType = $row["vType"];
		
		$query = "SELECT vendorID, vendorName, lastname, firstname FROM ".$config['dbprefix']."vendors WHERE vTypeID = ".$vTypeID;
		$approvedClause = (isset($_GET["archive"]) && $_GET["archive"]=='yes') ? '' : ' AND approved=1' ;
		$query = $query.$approvedClause;
		$query = $query.' GROUP BY vendorName';
		$res = $festos->query($query);
		$artists = array();
		while($row = $res->fetch()) {
			$artists[] = $row;
		}

		$tpl->set('vTypeID', $vTypeID);
		$tpl->set('vType', $vType);
		$tpl->set('artists', $artists);
		$template = 'artists_list.tpl';
	break;
	
	case 'categories':
	default:
		$query = "SELECT vTypeID, vType FROM ".$config['dbprefix']."vendortypes
				WHERE vTypeID NOT IN (".$config['EXCLUDED_VENDOR_CATEGORIES'].")
				AND appTypeID = ".$config['ARTISTS_APPTYPID']."
				ORDER BY vType";
		$res = $festos->query($query);
		$categories = array();
		while ($row = $res->fetch()) {
			$categories[] = $row;
		}
		$tpl->set('categories', $categories);
		$template = 'artists_categories.tpl';
	break;
} // end switch()

// $tpl->set('VAR_NAME','value');

$tpl->set('config',$config);
echo $tpl->fetch('templates/'.$template);

?>