<?php
/* **************************************************
FestOS(TM) - Digital Festival Management System
Copyright (C) 2009, Skypanther Studios, Inc.
Skypanther is a registered trademark of Skypanther Studios, Inc. and is not covered by this license.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
************************************************** */
require_once('../core/core.php');
error_reporting(E_ALL);
require_once('../core/Template.php');
$tpl = & new Template();

require_once('templates/header.php');

$step = (isset($_GET['step'])) ? $_GET['step'] : 1;
$tpl->set('step', $step);

switch($step) {
	case 1:
		// CHECK FILE SYSTEM AND DATABASE ACCESS */
		// check that all required writeable files can be written to
		$dynconfig = is_writable($config['ABSOLUTE_FILE_PATH'].'cache/dynconfig.php');
		$tpl->set('dynconfig', $dynconfig);
		$dates = is_writable($config['ABSOLUTE_FILE_PATH'].'cache/dates.php');
		$tpl->set('dates', $dates);
		$roleinfo = is_writable($config['ABSOLUTE_FILE_PATH'].'cache/roleinfo.php');
		$tpl->set('roleinfo', $roleinfo);
		$vendorimages = is_writable($config['ABSOLUTE_FILE_PATH'].'vendorimages/');
		$tpl->set('vendorimages', $vendorimages);
		$tmp_vendorimages = is_writable($config['ABSOLUTE_FILE_PATH'].'cache/images/');
		$tpl->set('tmp_vendorimages', $tmp_vendorimages);

		// check db access
		$link = @mysql_connect($config['dbserver'], $config['dbuser'], $config['dbpassword']);
		$dbserver = ($link) ? true : false;
		$tpl->set('dbserver', $dbserver);
		$db_selected = @mysql_select_db($config['dbname'], $link);
		$dbconnection = ($db_selected) ? true : false;
		$tpl->set('dbconnection', $dbconnection);
		$mysqlversion = ($link) ? mysql_get_server_info() : false;
		$tpl->set('mysqlversion', $mysqlversion);
		$mysqlok = (floatval($mysqlversion) >= 3.23) ? true : false;
		$tpl->set('mysqlok', $mysqlok);

		// Good to proceed?
		$good2go = ($dynconfig && $dates && $roleinfo && $vendorimages && $tmp_vendorimages && $dbserver && $dbconnection && $mysqlok) ? true : false;
		$tpl->set('good2go', $good2go);

		// load template, step done
		$template = 'step1.tpl';
	break;
	case 2:
		/* IMPORT SQL INTO DATABASE */
		$sql = file_get_contents ('festos.sql');
		$sql = str_replace('DBPREFIX', $config['dbprefix'] , $sql);
		$tpl->set('sql', $sql);
		$error = '';

		$link = @mysql_connect($config['dbserver'], $config['dbuser'], $config['dbpassword']);
		if($link) {
			$dbconn = @mysql_select_db($config['dbname'], $link);
				if($dbconn) {

				$comment_patterns = array('/\/\*.*(\n)*.*(\*\/)?/', 
										  '/\s*--.*\n/', 
										  '/\s*#.*\n/', 
										  );
				$sql = preg_replace($comment_patterns, "\n", $sql); 
				$a = explode(";SP;",$sql);
				for ($x=0; $x<count($a); $x++) {
					$a[$x]=ltrim(rtrim($a[$x]));
					if ($a[$x] != "" && $a[$x] != "\n") {
						$result = mysql_query($a[$x]);
						if (!$result) {
							$good2go = false;
							$error .= mysql_error();
						} else {
							$good2go = true;
						}
					}
				}
				} else {
					$good2go = false;
					$error .= mysql_error();
				}
		} else {
			$good2go = false;
			$error .= mysql_error();
		}
		$tpl->set('error', $error);
		$tpl->set('good2go', $good2go);

		// load template, step done
		$template = 'step2.tpl';
	break;
	case 3:
		/* PROMPT FOR ADMIN USER NAME AND PASSWORD */
		$tpl->set('good2go', true);
		$template = 'step3.tpl';
	break;
	case 4:
		/* DONE, SHOW FINISHED MESSAGE */
		$template = 'step4.tpl';
	break;



} // end switch()


// $tpl->set('VAR_NAME','value');
$tpl->set('config',$config);
echo $tpl->fetch('templates/'.$template);
require_once('templates/footer.php');

?>