<?php
/* ****************************************************************
Available variables:
	$step = installation step
	$dynconfig = true/false is the abs_file_path/core/dynconfig.php file writable?
	$dates = true/false is the abs_file_path/includes/dates.php file writable?
	$roleinfo = true/false is the abs_file_path/admin/includes/roleinfo.php file writable?
	$vendorimages = true/false is the abs_file_path/vendorimages/ directory writable?
	$tmp_vendorimages = true/false is the abs_file_path/admin/tmp_vendorimages/ directory writable?

	$dbserver = true/false, can we log into the database
	$dbconnection = true/false, can we connect to the db table
	$mysqlok = true/false, version of MySQL sufficiently new
	$mysqlversion = either mysql software version or FALSE

	$good2go = true/false, all files readable and all db parameters check out

Template-specific notes:
	None


****************************************************************** */
?>
<h1>FestOS&trade; Installation Step <?php echo $step; ?></h1>
<p style="font-weight:bold;">File system checks:</p>
<p>The following files and folders must be writable in order for FestOS to function properly:</p>

<p>cache/dynconfig.php file writable: 
	<?php if($dynconfig==true) { ?>
		<img src="images/install_yes.gif" alt="Yes" width="16" height="16"/>
	<?php } else { ?>
		<img src="images/install_no.gif" alt="No" width="16" height="16"/>
	<?php } ?></p>
<p>cache/dates.php file writable: 
	<?php if($dates==true) { ?>
		<img src="images/install_yes.gif" alt="Yes" width="16" height="16"/>
	<?php } else { ?>
		<img src="images/install_no.gif" alt="No" width="16" height="16"/>
	<?php } ?></p>
<p>cache/roleinfo.php file writable: 
	<?php if($roleinfo==true) { ?>
		<img src="images/install_yes.gif" alt="Yes" width="16" height="16"/>
	<?php } else { ?>
		<img src="images/install_no.gif" alt="No" width="16" height="16"/>
	<?php } ?></p>
<p>cache/images folder writable: 
	<?php if($tmp_vendorimages==true) { ?>
		<img src="images/install_yes.gif" alt="Yes" width="16" height="16"/>
	<?php } else { ?>
		<img src="images/install_no.gif" alt="No" width="16" height="16"/>
	<?php } ?></p>
<p>vendorimages folder writable: 
	<?php if($vendorimages==true) { ?>
		<img src="images/install_yes.gif" alt="Yes" width="16" height="16"/>
	<?php } else { ?>
		<img src="images/install_no.gif" alt="No" width="16" height="16"/>
	<?php } ?></p>

<p style="font-weight:bold;">Database checks:</p>
<p>MySQL server connection (can we log in?): 
	<?php if($dbserver==true) { ?>
		<img src="images/install_yes.gif" alt="Yes" width="16" height="16"/>
	<?php } else { ?>
		<img src="images/install_no.gif" alt="No" width="16" height="16"/>
	<?php } ?></p>
<p>Database connection (can we connect to the database itelf?): 
	<?php if($dbconnection==true) { ?>
		<img src="images/install_yes.gif" alt="Yes" width="16" height="16"/>
	<?php } else { ?>
		<img src="images/install_no.gif" alt="No" width="16" height="16"/>
	<?php } ?></p>
<p>MySQL version check: 
	<?php if($mysqlok==true) { ?>
		<img src="images/install_yes.gif" alt="Yes" width="16" height="16"/> (version <?php echo $mysqlversion;?>)
	<?php } else { ?>
		<img src="images/install_no.gif" alt="No" width="16" height="16"/> (apparently you'll need a new version of MySQL)
	<?php } ?></p>

<p>
	<?php if($good2go==true) { ?>
		You are ready to proceed with the installation. <a href="index.php?step=2" title="Proceed to step 2">Continue ...</a>
	<?php } else { ?>
		Please correct the file permission settings then <a href="index.php" title="Retry step 1">retry</a>.
	<?php } ?></p>
