<?php
/* ****************************************************************
Available variables:
	$step = installation step
	$good2go = true/false, ready to proceed

Template-specific notes:
	None


****************************************************************** */
?>
<script type="text/javascript" language="javascript" src="../js/jquery.js"></script>
<style type="text/css">
/* FORM VALIDATION FIELDS, includes/jquery.simplevalidator.js */
/* OVERRIDE AUTOFILL YELLOW BACKGROUNDS ON INPUT FIELDS */
input.required {
   background: #EFD1D1 !important;
   color:#000;
} 
input.error {
	background-color:#CC0000 !important;
	color:#fff;
}
span.formerror {
	font-style:italic;
	font-weight:bold;
	color:#990000;
}
span.formsuccess {
	font-style:italic;
	color:#009900;
}
</style>

<h1>FestOS&trade; Installation Step <?php echo $step; ?></h1>
<p style="font-weight:bold;">Administrator credentials</p>
<p>Please enter the user name and password you will use to access the FestOS administration pages.</p>
<p id="error" style="color:#990000;font-weight:bold;">
<?php
if(isset($_GET['error'])) {
	switch($_GET['error']) {
		case 'nomatch':
			echo 'You must enter matching text in the Password and Confirm boxes.';
		break;
		case 'notcomplex':
			echo 'You must enter a password of at least 6 character containing at least 1 number.';
		break;
		case 'bademail':
			echo 'You must enter a valid email address.';
		break;
		default:
			echo 'You must enter a valid email address and password of at least 6 character containing at least 1 number.';
		break;
		
	} // end switch
}
?>
</p>
<form method="post" action="do_admincredentials.php">
<input type="hidden" name="step" value="<?php echo $step;?>"/>
<table>
<tr>
	<td>User name</td>
	<td><input type="text" name="username" id="username" value="" class="required" onBlur="checkUsername()"/> <span id="usernamelabel"></span></td>
</tr>
<tr>
	<td>Password</td>
	<td><input type="password" name="password" id="password" class="required" onBlur="checkPassword()"/> <span id="passwordlabel"></span></td>
</tr>
<tr>
	<td>Password (again)</td>
	<td><input type="password" name="confirm" id="confirm" class="required" onBlur="check4match()"/> <span id="confirmlabel"></span></td>
</tr>
<tr>
	<td>Email</td>
	<td><input type="text" name="email" id="email" value="" size="35" class="required" onBlur="checkEmail()"/> <span id="emaillabel"></span></td>
</tr>
<tr>
	<td></td>
	<td><input type="submit" value="Submit" id="submitbutton"/></td>
</tr>
</table>
</form>

<script type="text/javascript">
function checkUsername() {
	if($("#username").val()=='') {
		$('#usernamelabel').text('You must enter a username.');
		$('#usernamelabel').removeClass('formsuccess');
		$('#usernamelabel').addClass('formerror');
		$('#submitbutton').attr('disabled','true');
	}
}
function checkPassword() {
	if($("#password").val()=='') {
		$('#passwordlabel').text('You must enter a password.');
		$('#passwordlabel').removeClass('formsuccess');
		$('#passwordlabel').addClass('formerror');
		$('#submitbutton').attr('disabled','true');
	}
}
function checkEmail() {
	if($("#email").val()=='') {
		$('#emaillabel').text('You must enter an email address.');
		$('#emaillabel').removeClass('formsuccess');
		$('#emaillabel').addClass('formerror');
		$('#submitbutton').attr('disabled','true');
	}
}

function check4match() {
	if($("#password").val()!='') {
		if($("#password").val() != $("#confirm").val()) {
			$('#confirmlabel').text('Password and Confirm must match.');
			$('#confirmlabel').removeClass('formsuccess');
			$('#confirmlabel').addClass('formerror');
			$('#submitbutton').attr('disabled','true');
		}
	} else {
			$('#confirmlabel').text('You must enter a password.');
			$('#confirmlabel').removeClass('formsuccess');
			$('#confirmlabel').addClass('formerror');
			$('#submitbutton').attr('disabled','true');
	}
}
</script>