/* GENERIC FORM VALIDATION CODE


*/

// BEGIN WITH THE VARIOUS HELPER AND ACTUAL VALIDATION FUNCTIONS
function required(id, msgid, successMessage) {
	if(undefined == successMessage) successMessage = ' Good!';
	val = $("#"+id).attr('value');
	if(undefined != val && !isEmpty(val)) {
		$("#"+msgid).attr('class', 'success');
		$("#"+msgid).html(successMessage);
		$("#"+id).attr('class', 'requirementmet');
	} else {
		$("#"+msgid).attr('class', 'error');
		$("#"+msgid).html(' '+$("#"+id).attr('title'));
		$("#"+id).attr('class', 'required');
	}
	validate();
} // end required

function isEmpty(str) {
	str = str.replace(/\s+/g, ""); 
	if(str.length > 0) return false;
	return true;
} // end isEmpty

function validphone(id, msgid, successMessage) {
	phone_number = $("#"+id).attr('value');
	if(undefined == phone_number) phone_number = '123';
	phone_number = phone_number.replace(/\s+/g, ""); 
	if(undefined == successMessage) successMessage = ' Good!';
	if(phone_number.length > 9 && phone_number.match(/^(1-?)?(\([2-9]\d{2}\)|[2-9]\d{2})-?[2-9]\d{2}-?\d{4}$/) ) {
		// valid
		$("#"+msgid).attr('class', 'success');
		$("#"+msgid).html(successMessage);
		$("#"+id).attr('class', 'requirementmet');
	} else {
		// invalid
		$("#"+msgid).attr('class', 'error');
		$("#"+msgid).html(' '+$("#"+id).attr('title'));
		$("#"+id).attr('class', 'required');
	}
	validate();
} // end validphone

function validnumber(id, msgid, minValue, maxValue, successMessage) {
	if(undefined == successMessage) successMessage = ' Good!';
	val = $("#"+id).attr('value');
	validNumber = false;
	if(undefined != val && !isEmpty(val) && val.match(/\d$/)) {
		// a number
		validNumber = true;
		if(undefined != minValue) {
			if(val < minValue) validNumber = false
		}
		if(undefined != maxValue) {
			if(val > maxValue) validNumber = false
		}
	}
	if(validNumber) {
		$("#"+msgid).attr('class', 'success');
		$("#"+msgid).html(successMessage);
		$("#"+id).attr('class', 'requirementmet');
	} else {
		// invalid
		$("#"+msgid).attr('class', 'error');
		$("#"+msgid).html(' '+$("#"+id).attr('title'));
		$("#"+id).attr('class', 'required');
	}
	validate();
} // end validnumber

function accepted(id, msgid, successMessage) {
	if(undefined == successMessage) successMessage = ' Thank you!';
	if($("#"+id).attr("checked")) {
		$("#"+msgid).attr('class', 'success');
		$("#"+msgid).html(successMessage);
	} else {
		$("#"+msgid).attr('class', 'error');
		$("#"+msgid).html(' '+$("#"+id).attr('title'));
	}
	validate();
} // end checkbox


// NOW, ADD THE JQUERY CODE TO WALK THE FORM, ADD THE EVENT HANDLERS, VALIDATION RULES, ETC.
$(document).ready(function(){
	$("input, textarea, checkbox").each(function(){
		if($(this).hasClass('required')) {
//			$(this).blur(function() {'required("' + $(this).attr('id') + '", "' + $(this).attr('id') + '_error")'});
			$(this).attr('onBlur', 'required("' + $(this).attr('id') + '", "' + $(this).attr('id') + '_error")');
			$(this).after(' <em class="error" id="' + $(this).attr('id') + '_error">' + $(this).attr('title') + '</em>');
		} else if($(this).hasClass('validphone')) {
//			$(this).css('border','1px solid #f00');
			$(this).attr('onBlur', 'validphone("' + $(this).attr('id') + '", "' + $(this).attr('id') + '_error")');
			$(this).after(' <em class="error" id="' + $(this).attr('id') + '_error">' + $(this).attr('title') + '</em>');
		} else if($(this).hasClass('validnumber')) {
//			$(this).css('border','1px solid #f00');
			$(this).after(' <em class="error" id="' + $(this).attr('id') + '_error">' + $(this).attr('title') + '</em>');
			// need to add the correct function if there are min or max values specified
			blurString = 'validnumber("' + $(this).attr('id') + '", "' + $(this).attr('id') + '_error"';
			if(undefined != $(this).attr('minValue') && $(this).attr('minValue') != '') {
				blurString += ', ' + $(this).attr('minValue');
			} 
			if(undefined != $(this).attr('maxValue') && $(this).attr('maxValue') != '') {
				blurString += ', ' + $(this).attr('maxValue');
			} 
			blurString += ')';
			$(this).attr('onBlur', blurString);
		} else if($(this).hasClass('checkrequired')) {
			// $(this).css('border','1px solid #f00'); // can't seem to apply any styles to checkboxes
			$(this).attr('onClick', 'accepted("' + $(this).attr('id') + '", "' + $(this).attr('id') + '_error")');
			$(this).after(' <em class="error" id="' + $(this).attr('id') + '_error">' + $(this).attr('title') + '</em>');
		} 
	});
});	

$(document).ready(function() {
	$("input:submit").attr('disabled', 'true');
});

function validate() {
	if($("em.error").length==0) {
		$("input:submit").removeAttr('disabled');
	} else {
		$("input:submit").attr('disabled', 'true');
	}
}