<?php
/* ****************************************************************

*** MAIN APPLICATION FORM ****


Available variables:
	$details = array of applicant details, keys match field names in vendors table
	$appTypes = 2-dim array of application types (keys: apptypeID, apptype, apptypelabel, rulesPDF)
	$applicantID = (if logged in) applicants unique ID
	$thispage = URI of the page
	$querystring = All the stuff after the ? in the URL, url-encoded
	$config = configuration data
	$apptypeID = the applicant's application type ID
	$vendorCategories = 2-dim array of vendor categories (keys: vTypeID, vType)
	$fees = array of application fees (keys: boothFee, appFee, lateFee, lateFeeDate, cornerBoothFee)
	$fieldList = array of form fields (keys: fieldname, type, label, size, title, class, value)
	$rulesPDF = array (apptypelabel, rulesPDF)

Template-specific notes:
	THE FORM IS DYNAMICALLY CREATED FROM THE DATABASE.
	WATCH YOUR MODIFICATIONS -- STICK TO CHANGING JUST THE HTML AND CSS AND YOU WON'T CAUSE PROBLEMS

****************************************************************** */

// FUNCTION FOR ADDING FIELDS TO THE FORM
require_once('festos_inc_addfield.php');
?>
<script type="text/javascript" language="javascript" src="js/jquery.js"></script>

<style type="text/css">
em.error {
  background:url("images/formvalidator_invalid.gif") no-repeat 0px 0px;
  padding-left: 16px;
  border:none;
  color:#7E735C;
}
em.success {
  background:url("images/formvalidator_valid.gif") no-repeat 0px 0px;
  padding-left: 16px;
  border:none;
  color:#7E735C;
}
.required, .validnumber, .validphone { border:1px solid #f00; }
.requirementmet { border:1px solid #000; }
#feeTable td { background-color:#0069AA;color:#fff;font-size:11px;border-right:1px solid #fff;padding:2px 8px; }
textarea { float:left; margin-right:3px;}
</style>


<h1>Apply for <?php echo $lang['thefestival']; ?></h1>
<h2><?php echo $rulesPDF['apptypelabel'];?> application</h2>
<p>Begin your application for <?php echo $lang['thefestival']; ?> by completing this form. <strong>Please make sure all information is complete and correct.</strong> You will not be able to proceed until you provide the required information.</p>

<p align="center">Read the <a href="apps/<?php echo $rulesPDF['rulesPDF'];?>" target="_blank">rules and requirements PDF file</a>.</p>

<?php
if($fees['extraBoothFee']>0 || $fees['lateFee']>0 || $fees['appFee']>0 || $fees['boothFee']>0 || $fees['cornerBoothFee']>0) {
	// show fee table only if there's a fee for this application type
?>

<table id="feeTable" cellpadding="2" cellspacing="0" width="95%">
<tr>
	<td><strong>Fees:</strong></td>
	<td>Application: $<?php echo $fees['appFee']; ?></td>
	<td>Booth: $<?php echo $fees['boothFee']; ?></td>
	<td>Extra booth: $<?php echo $fees['extraBoothFee']; ?></td>
	<td>Corner: $<?php echo $fees['cornerBoothFee']; ?></td>
	<td>Late Fee: $<?php echo $fees['lateFee'] . ' after ' . strftime($config["DATE_FORMAT"],$fees['lateFeeDate']);?> </td>
</tr>
</table>
<?php
}  // end if block to show fees only if there is a fee to show
?>

<form action="festos_z_doapplyform.php" method="post" id="myform">
<input type="hidden" name="thispage" value="<?php echo $thispage;?>">
<table class="artisanApplicationTable" cellpadding="3" cellspacing="0" border="0" width="90%" id="appTable">
<?php
	for($i=0;$i<count($fieldList);$i++) {
			$fieldList[$i]['value'] = $details[$fieldList[$i]['fieldname']];
			echo addField($fieldList[$i]['fieldname'], $fieldList[$i]['type'], $fieldList[$i]['label'], $fieldList[$i]['size'], $fieldList[$i]['title'], $fieldList[$i]['class'], $fieldList[$i]['value']);
			echo "\r\n";
	} // end for()	

?>

<tr>
  <td valign="top"><input type="hidden" name="appDate" value="<?php echo ($details['appDate']!='') ? $details['appDate'] : mktime(); ?>"></td>
  <td valign="top" align="left"><input type="button" value="Cancel" onClick="location='<?php echo $thispage;?>?pg=cp'">&nbsp;&nbsp;<input type="submit" value="Save your application" id="btnSubmit" style="font-weight:bold;"><br /></td>
</tr>
</table>
</form>

<script type="text/javascript" language="javascript" src="js/array_helpers.js"></script>
<script type="text/javascript" language="javascript" src="js/tablestyler.js"></script>
<script type="text/javascript" language="javascript" src="js/formvalidator.js"></script>

<script type="text/javascript" language="javascript">

$(document).ready(function(){
	theFields = new Array();
	$("input, textarea, select").each(function (i) {
		if($(this).attr('class') == "validnumber" || $(this).attr('type') == "radio" || $(this).attr('type') == "select") {
			theFields.push([$(this).attr('name'), 'num']);
		} else {
			theFields.push([$(this).attr('name'), 'str']);
		}
	});
	$("<input type='hidden' name='theFields' value='"+escape(js_array_to_php_array(theFields))+"'>").appendTo("#myform");
});

$(document).ready(function(){
	$("input, textarea, checkbox").each(function(){
		if($(this).hasClass('required')) {
			required($(this).attr('id'), $(this).attr('id') + '_error');
		} else if($(this).hasClass('validphone')) {
			validphone($(this).attr('id'), $(this).attr('id') + '_error');
		} else if($(this).hasClass('validnumber')) {
			validnumber($(this).attr('id'), $(this).attr('id') + '_error');
		}
	});
});	


</script>