<?php
/* ****************************************************************
Available variables:
	$details = array of applicant details, keys match field names in vendors table
	$appTypes = 2-dim array of application types (keys: apptypeID, apptype, apptypelabel, rulesPDF)
	$applicantID = (if logged in) applicants unique ID
	$thispage = URI of the page
	$querystring = All the stuff after the ? in the URL, url-encoded
	$config = configuration data
	$fees = array of application fees (keys: boothFee, appFee, lateFee, lateFeeDate, cornerBoothFee)
	$appfee = application fee
	$boothfee = booth fee for one or more booths
	$cornerfee = corner booth fee or 0
	$latefee = late application fee or 0
	$total = total amount owed

Template-specific notes:
	NONE

****************************************************************** */

?>
<h3>Thank you for applying for <?php echo $lang['thefestival'];?></h3>
<p>To finish your application, please pay:</p>

<ul>
<?php
	if($appfee>0) {
		echo '<li>Application fee: $'.number_format($appfee, 2, '.', ',').'</li>';
	}
?>
<?php
	if($boothfee>0) {
		echo '<li>Booth fee: $'.number_format($boothfee, 2, '.', ',').'</li>';
	}
?>
<?php
	if($cornerfee>0) {
		echo '<li>Corner booth fee: $'.number_format($cornerfee, 2, '.', ',').'</li>';
	}
?>
<?php
	if($latefee>0) {
		echo '<li>Late fee: $'.number_format($latefee, 2, '.', ',').'</li>';
	}
?>
</ul>

<p><strong>Total: $<?php echo number_format($total, 2, '.', ',');?></strong></p>

<h3>Payment options:</h3>

<?php
foreach($paymentmethod as $method) {
	include('addons/'.$method['modulePaymentButtonFile']);
}
?>



<br clear="all"/>