<?php
/* ****************************************************************
Available variables:
	events = an 2-dimensional array where each member is this array
		eventID = the internal numeric identifier
		title = the event title
		performer = performer
		startTime = start time of event in UNIX timestamp format
		endTime = end time of event in UNIX timestamp format, might be blank
		venue = name of venue (location)
		description = HTML description of event
		
Template-specific notes:
	The date and time formats are controlled by configuration settings in the admin system. 
	  Generally, events end on the same day they start. So, the default template uses the
	  SHORT_DATETIME_FORMAT style to show the starting date and time and the TIME_FORMAT
	  style to show the ending time (no date).
	The key for the events array is the event ID. So, there may be gaps. For example, if you
	  add an event, which is assigned eventID=1, add another (eventID=2), add a third (eventID=3)
	  and then delete the second event, the $events array will have these members:
	  	$events[1] = an array (eventID, title, performer, etc.)
	  	$events[3] = an array (eventID, title, performer, etc.)
****************************************************************** */
?>

<?php
if(count($events)>0) {
	foreach($events as $ev) {
	?>
	<h2><?php echo $ev['title'];?></h2>
	<h3><?php echo $ev['performer'];?></h3>
	<p><strong>When: </strong><?php echo strftime($config['SHORT_DATETIME_FORMAT'], $ev['startTime']);?>
	<?php if($ev['endTime'] !='') { 
	 echo ' until ';
	 echo strftime($config['TIME_FORMAT'], $ev['endTime']);
	}
	?></p>
	
	<p><strong>Where:</strong> <?php echo $ev['venue'];?></p>
	
	<div><?php echo $ev['description'];?></div>
	
	<?php
	} // end foreach() loop

} else {
	// no events to show, so output some sort of message
	
?>
<p>We have not yet set the schedule for this year's festival. Please check back later.</p>

<?php
}


?>