<?php
/* ****************************************************************
Available variables:
	$vTypeID = category ID number
	$vType = category label
	$winners = array of winners
		vendorID = ID number
		vType = category name
		vendorName = text, name could be blank
		lastname, firstname = first and last name of the artist
		notes = Notes you entered on the winners page in admin system
		photo = number of photo to show

Template-specific notes:
	There's a bit of php here that should probably be in the associated php file. It's a function look up to retrieve the actual photo file name based on the value of 'photo' (see above).
	getPhoto($vID, $num, $thePath, $align, $class)
		where $vID is the vendor ID
			$num is the photo number ('photo')
			$thePath = path to the vendor images, which is probabably vendorimages
			$align = 'left' or 'right' or 'none' (image alignment)
			$class = CSS class for the photo, eg. to add margin or padding
****************************************************************** */
?>

<h1>Winners</h1>

<?php
if(count($winners) > 0) {
	// there are artists to show, so show them
?>

<?php
	foreach($winners as $w) {
?>

<div class="winnersblock"><?php echo getPhoto($w['vendorID'], $w['photo'], 'vendorimages/', 'left', 'winnersphoto');?>
<div class="winnerscategory"><h2><?php echo $w['vType']; ?></h2></div>
<div class="winnersname"><?php 
if($w['vendorName'] != '') 
	echo $w['vendorName'];
else
	echo $w['firstname'].' '.$w['lastname'];
?></div>
<div class="winnersdetails"><?php echo $w['notes'];?></div>
</div>
<br clear="all"/>

<?php
	} // end the foreach loop

?>

<?php
} else {
	// no artists to show
?>

<p>We have not announced our winners yet or the festival has not yet happened. Please check back later.</p>

<?php
} // end the if...else block
?>

